

//#define standalone

#include "ControlCenterC.h"

void printMenu();

typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1<<(i))
#define FILTER_GET(flag, i) ((flag) & 1<<(i))
#define UNSET_FILTER(i) ( FILTER_GET(FILTER, i)? FILTER ^= 1<<(i) : FILTER)

CORBA::ORB_var orb;
ControlCenter_ptr server;
unsigned int FILTER;


#ifdef standalone

int main (int argc, char* argv[])
{
  const CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

  ACE_TString serverIOR = ACE_TString(ACE_TEXT("file://ControlCenter.ior"));
  CORBA::Object_ptr optr = orb->string_to_object (serverIOR.c_str());
  ControlCenter_ptr server = ControlCenter::_narrow (optr);

  char input[10];
  unsigned int FILTER = 0;

  do {
    cout<<endl<<endl;
    printMenu();
    cout<<"   Your input ('q' exit) : ";
    cin >> input;
    
    if (0 == ACE_OS_String::strcmp(input, "gzip")) {
      cout<<" gzip"<<endl;
      SET_FILTER(GZIP);
    }
    else if (0 == ACE_OS_String::strcmp(input, "lzo")) {
      cout<<" lzo"<<endl;
      SET_FILTER(LZO);
    }
    else if (0 == ACE_OS_String::strcmp(input, "shrink")) {
      cout<<" shrink"<<endl;
      SET_FILTER(SHRINK);
    }
    else if (0 == ACE_OS_String::strcmp(input, "grey")) {
      cout<<" grey"<<endl;
      SET_FILTER(GREY);
    }
    else if (0 == ACE_OS_String::strcmp(input, "jpeg")) {
      cout<<" jpeg"<<endl;
      SET_FILTER(JPEG1);
    }
    else if (0 == ACE_OS_String::strcmp(input, "encrypt")) {
      cout<<" encrypt"<<endl;
      SET_FILTER(ENCRYPT);
    }
    else if (0 == ACE_OS_String::strcmp(input, "GZIP")) {
      cout<<" GZIP"<<endl;
      UNSET_FILTER(GZIP);
    }
    else if (0 == ACE_OS_String::strcmp(input, "LZO")) {
      cout<<" LZO"<<endl;
      UNSET_FILTER(LZO);
    }
    else if (0 == ACE_OS_String::strcmp(input, "SHRINK")) {
      cout<<" SHRINK"<<endl;
      UNSET_FILTER(SHRINK);
    }
    else if (0 == ACE_OS_String::strcmp(input, "GREY")) {
      cout<<" GREY"<<endl;
      UNSET_FILTER(GREY);
    }
    else if (0 == ACE_OS_String::strcmp(input, "JPEG")) {
      cout<<" JPEG"<<endl;
      UNSET_FILTER(JPEG1);
    }
    else if (0 == ACE_OS_String::strcmp(input, "ENCRYPT")) {
      cout<<" ENCRYPT"<<endl;
      UNSET_FILTER(ENCRYPT);
    }
    else if (0 == ACE_OS_String::strcmp(input, "ALL")) {
      cout<<" ALL"<<endl;
      FILTER &= 0xFFFFFF00;
    }
    else if (0 == ACE_OS_String::strcmp(input, "y") ||
	     0 == ACE_OS_String::strcmp(input, "Y") ) {
      cout<<" Y"<<endl;
      FILTER |= 0x80000000;
    }
    else if (0 == ACE_OS_String::strcmp(input, "n") ||
	     0 == ACE_OS_String::strcmp(input, "N") ) {
      cout<<" N"<<endl;
      FILTER &= 0x7FFFFFFF;
    }
    else if ( 0 == ACE_OS_String::strcmp(input, "q") ||
	      0 == ACE_OS_String::strcmp(input, "Q") ) {
      break;
    }
    else 
      continue;

    //Apply the filter to the server
    server->assignFilter(FILTER);
    cout<<" Filter (0x"<<hex<<FILTER<<") has been applied to the server."<<endl;
  } while (1);

  orb->shutdown();
  return 0;
}



void printMenu() {
  cout<<" Apply Filter Strings:"<<endl;
  cout<<"      gzip,  lzo, shrink, grey, jpeg, encrypt"<<endl;
  cout<<" Flow Control or Not:"<<endl;
  cout<<"      y (Yes), n (No)"<<endl;
  cout<<endl;
  cout<<" Remove Filter Strings:"<<endl;
  cout<<"      GZIP, LZO, SHRINK, GREY, JPEG, ENCRYPT, ALL"<<endl;
  cout<<" ==============================================="<<endl;
}

#endif
