
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // PPMP.cpp
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/timeb.h>
#include <stdarg.h>
#include <time.h>
#include <iostream.h>
#include "PPMP.h"


extern "C" {
  
    //<block name="filter_ENCRYPT">
#include "encrypt.h"
extern EncryptParam encryptParam;
extern int KEYSIZE;
    //</block>
  
    //<block name="filter_JPEG">
#include "jpgcodec.h"
    //</block>
  
    //<block name="filter_GZIP">
#include "gzip.h"
    //</block>
  
    //<block name="filter_SHRINK">
#include "imgFilters/filters.h"
    //</block>
  
    //<block name="filter_GREY">
#include "imgFilters/filters.h"
    //</block>
  
}    



#undef DEBUG_WHERE
#undef DEBUG_WHAT
#define DEBUG_WHERE 0
#define DEBUG_WHAT 0

FILE* outf = NULL;
static int rcvr_b = 0;
#define INTER_FRAG_DELAY 2000

typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define FILTER_GET(flag, i) ((flag) & 1<<(i))
#define UNSET_FILTER(i) ( FILTER_GET(FILTER, i)? FILTER ^= 1<<(i) : FILTER)



  

 PPMP_Fragment::PPMP_Fragment(char* frag_buf, size_t frag_len)
 : frag_buffer (frag_buf), frag_length(frag_len)
{
}
    

 PPMP_Fragment::PPMP_Fragment(unsigned long ppmp_header, unsigned long
      frame_no, const char* msg_buf, size_t len, char* frag_buf)
 : frag_buffer (frag_buf), frag_length(len+PPMP_FRAME_INFO_OFFSET)
{
  memmove(frag_buffer + PPMP_PICT_HEADER_OFFSET, &ppmp_header, 
	 sizeof(unsigned long));
  memmove(frag_buffer + PPMP_FRAME_NO_OFFSET, &frame_no,
	 sizeof(unsigned long));

  memmove(frag_buffer + PPMP_FRAME_INFO_OFFSET, msg_buf, len );
}
    

 PPMP_Sender::PPMP_Sender(int mus, int pixelsize, int maxpixelperline)
 : mus(mus)
{
  bpp = 3;
  max_buf_size = (mus + PPMP_FRAME_INFO_OFFSET + sizeof(unsigned long)
		  + sizeof(PPM_frame_info));
  lines_send_per_time = (int)(((double)mus)/(maxpixelperline) + .9999);
  max_buf_size = max_buf_size < lines_send_per_time*maxpixelperline ?
                 lines_send_per_time*maxpixelperline + PPMP_FRAME_INFO_OFFSET +
                 sizeof(unsigned long) + sizeof(PPM_frame_info) 
                 :
                 max_buf_size;

  num_times =(int)(((double)480/(double)lines_send_per_time)+.9999);
}
    

int PPMP_Sender::send_whole_frame(const char *msg_buf, const size_t len, const unsigned long PPMFrame_num, const int src_id, const unsigned int filter_flag)
{
  curr_frame_num = PPMFrame_num;
  int bytes_send_per_time = lines_send_per_time * pfi.width * bpp/8;

  char fragment_buffer[max_buf_size*sizeof(char)];
  unsigned long tmp = ToBigEndian32(PPMP_FRAME_HEADER);
  memcpy(fragment_buffer, &tmp, sizeof(unsigned long));

  //fill in frame #
  memcpy(&fragment_buffer[4],&curr_frame_num,sizeof(unsigned long));

  //For traditional img filters: shrink, grey.
  PPM_frame_info afterImg, afterImg1; 
  afterImg.buff = NULL;
  afterImg1.buff = NULL;

  if (FILTER_GET(filter_flag, SHRINK)) {

    //<block name="filter_SHRINK">
    afterImg.size = pfi.size/4;
    if (!(afterImg.buff = (char*)malloc(sizeof(char) * afterImg.size)))
      printf(" [PPMP_Sender::send_whole_frame(): mem alloc error\n");

    pfi.buff = (char*)msg_buf;
    int ret = shrinkFilter(&pfi, &afterImg);

    pfi = afterImg;
    setPPMFrameInfo (mus, pfi); 
    bytes_send_per_time = lines_send_per_time * pfi.width * bpp/8;
    //</block>

  }
  
  if (FILTER_GET(filter_flag, GREY)) {

    //<block name="filter_GREY">
    afterImg1.size = pfi.size/3;
    if (!(afterImg1.buff = (char*)malloc(sizeof(char) * afterImg1.size)))
      printf(" [PPMP_Sender::send_whole_frame(): mem alloc error\n");

    if (!FILTER_GET(filter_flag, SHRINK)) {
      pfi.buff = (char*)msg_buf;
    }
   int ret = greyFilter(&pfi, &afterImg1);

   if (FILTER_GET(filter_flag, SHRINK)) 
      if (afterImg.buff) free(afterImg.buff), afterImg.buff = NULL;

    pfi = afterImg1;
    setPPMFrameInfo (mus, pfi); 
    bytes_send_per_time = lines_send_per_time * pfi.width * bpp/8;
    //</block>

  }
  else if (0) {
  }

  int sendresult=send_preframe(fragment_buffer, src_id, curr_frame_num,
			       filter_flag);
  usleep(100);

  int bytes_read = 0;
  int actualsend = 0;
  sendresult=0;

  //
  // JPEG compression has to be here:
  // Assume jpg compression ONLY applied ONCE which gives us compressed img
  // about the size less than 16KB, in the sense we don't need to do jpg fragment
  // in AVStreams.
  // JPEG cannot be applied together with SHRINK or GREY filter(s).
  if (FILTER_GET(filter_flag, JPEG1)) {

    //<block name="filter_JPEG">
    //Call jpeg
    char* jpgImage = (char*)malloc(sizeof(char)*60*1024);
    int ret_size=0;
    
    int ret = ppm_to_jpeg (msg_buf, 
			   pfi.height,
			   pfi.width,
			   jpgImage,
			   40,
			   &ret_size);
    
    if (ret < 0)
      cout<<" Jpeg compression error "<<endl;

    unsigned short mark = 0x0;
    if (ret_size > max_buf_size - PPMP_FRAME_INFO_OFFSET) 
      cout<< " [PPMP_Sender::send_whole_frame(): JPEG compressed size too large !!!!\n";

    PPMP_Fragment frag(ToBigEndian32(PPMP_PICT_HEADER), ToBigEndian32(curr_frame_num),
		       jpgImage, 
		       ret_size, 
		       fragment_buffer);
    sendresult = this->send_fragment(fragment_buffer, ret_size+PPMP_FRAME_INFO_OFFSET,
				     src_id, curr_frame_num,
				     filter_flag,
				     mark);
    if (jpgImage) free(jpgImage), jpgImage = NULL;

    usleep(INTER_FRAG_DELAY);
    actualsend += sendresult;
    //</block>

  }
  else if (FILTER_GET(filter_flag, JPEG2)) {
  }
  else if (FILTER_GET(filter_flag, JPEG3)) {
  }
  else if (FILTER_GET(filter_flag, SHRINK) ||
	   FILTER_GET(filter_flag, GREY) ) {
    for (int time=0; time<num_times; time++) {
      int tmp = pfi.size - bytes_read;
      int stream_length = (bytes_send_per_time > tmp? tmp: bytes_send_per_time);

      lines_send_curr = stream_length / pfi.width/3;
      
      unsigned short mark = 0;
      PPMP_Fragment frag(ToBigEndian32(PPMP_PICT_HEADER), ToBigEndian32(curr_frame_num),
			 pfi.buff + bytes_read, 
			 stream_length, fragment_buffer);
      sendresult = this->send_fragment(fragment_buffer, frag.get_frag_length(),
				       src_id, curr_frame_num,
				       filter_flag, mark);

      bytes_read += stream_length;
      usleep(INTER_FRAG_DELAY);
      actualsend += sendresult;
    }
   if (pfi.buff) free(pfi.buff), pfi.buff =NULL;
  }
  else {

    for (int time=0; time<num_times; time++) {
      //Now the PPM pixel data
      int tmp = pfi.size - bytes_read;
      int stream_length = (bytes_send_per_time > tmp? tmp: bytes_send_per_time);

      lines_send_curr = stream_length / pfi.width/3;
      
      if (0/*other img filters*/) {
      }
      else {
	//No Img filters need to be applied
	unsigned short mark = 0;
	PPMP_Fragment frag(ToBigEndian32(PPMP_PICT_HEADER), ToBigEndian32(curr_frame_num),
			   msg_buf + bytes_read, 
			   stream_length, fragment_buffer);
	sendresult = this->send_fragment(fragment_buffer, frag.get_frag_length(),
					 src_id, curr_frame_num,
					 filter_flag, mark);
      }
      
      bytes_read += stream_length;
      usleep(INTER_FRAG_DELAY);
      actualsend += sendresult;
    } /* for (int time=0; time<num_times; time++) */
  } /* if (FILTER_GET(filter_flag, JPEG3) */

  return actualsend;
}
    

int PPMP_Sender::send_preframe(const char *PPMHeader, const int src_id, const int seq, const unsigned int filter_flag)
{
  char* buf;
  int sendresult;
  int PPMHeader_length = PPMP_FRAME_INFO_OFFSET + sizeof(PPM_frame_info);
 
  if (!(buf = (char*)malloc(PPMHeader_length*sizeof(char)))) {
    cerr<<" [PPMP_Sender::send_preframe(): 0ut of mem"<<endl;
    return (-1);
  }
 
  memcpy(buf, PPMHeader, PPMP_FRAME_INFO_OFFSET);
  memcpy(buf+PPMP_FRAME_INFO_OFFSET, &pfi, sizeof(PPM_frame_info));

  unsigned short mark = 0xF;
  sendresult = this->send_fragment(buf, PPMHeader_length, src_id, seq, filter_flag,
				   mark); 
   if (sendresult<0) {
    cerr<<" [PPMP_Sender::send_preframe(): cannot send preframe info"<<endl;
    return (-1);
  }

  if (buf) free(buf);
  return sendresult;
}
    

  

///////////////////////////////////////////////////////////////////////////////

  
 Flag_Array::Flag_Array(int first, int last)
 : start(first), end(last), current(0), available(NULL)
{
  available = (bool*)malloc((end-start+1)*sizeof(bool));

  if (!available)
    cerr<<" [Flag_Array::Cstr(): mem alloc error"<<endl;
}
    

 Flag_Array::Flag_Array()
 : start(0), end(0), current(0), available(NULL)
{
}
    

void Flag_Array::init_available()
{
  for (int i=start; i<=end; i++) {
    available[i] = false;
  }
}
    

void Flag_Array::free_available()
{
  if (available) free(available), available=NULL;
}
    

  



/////////////////////////////////////////////////////////////////////////////


  
 PPMP_Receiver::PPMP_Receiver(int mus)
 : MUS(mus), first(true), BytesReceived(0)
{
  /* For debug */
  fileidx =0;
  img_buffer = NULL;
}
    

int PPMP_Receiver::process_ppm(const char* msg, size_t len, unsigned long PPMFrameNum, PPM_frame_info& pfi)
{
  if (first)
    {
      if (DEBUG_WHERE) printf(" [PPMP_Receiver(): if (first)\n");

      curr_PPM_frame_num = PPMFrameNum;
 
      //P1/P4 : bitmap
      //P2/P5 : greymap
      //P3/P6 : pixmap
      //Update later for X11 display
      bits_per_pixel = (pfi.ppm2 == '6'? 24:8);
      bytes_per_line = pfi.width * bits_per_pixel / 8;
      little_endian = true; //hack

      frame_height = pfi.height; //480;
      frame_width = pfi.width;//640
      img_start_line = 0;
     start_defragment(msg, 0, frame_height-1, 0,
                            (int)((double)MUS/(double)bytes_per_line+.9999)-1,
                            img_start_line);


      first=false;
    }

  bool image_flush = false;

  if (PPMFrameNum != curr_PPM_frame_num) {
    //frame number conflicts. Flush the current accumulated image
    image_flush = true;
    first = true;
    //return false;//Be careful
  }

  char* tmp = accumulate_fragment(msg, len, pfi, image_flush);

  if (!tmp)
    return 1;//Not displayed

  //Display the image
  first = true;

  free_img_buffer();

  if (image_flush)
    return 2;//incomplete but displayed
  else
    return 3;//complete img displayed
}
    

void PPMP_Receiver::free_img_buffer()
{
  if (img_buffer) {
    free(img_buffer);
    img_buffer = NULL;
  }
}
    

void PPMP_Receiver::start_defragment(const char* img, int first, int last, int d_start_line, int d_end_line, int i_start_line)
{
  //init the flag arrary
  line = Flag_Array(first,last);
  line.init_available();

  line_accumulated = 0;

  data_start_line = d_start_line;
  data_end_line = d_end_line;
  img_start_line = i_start_line;

  /* For debugging*/
  BytesReceived = 0;
}
    

char* PPMP_Receiver::accumulate_fragment(const char *frag_buf, size_t frag_len, PPM_frame_info& pfi, bool flushOrNot)
{
  const int first = line.get_start_idx();
  const int last  = pfi.height-1 > line.get_end_idx()?
                              line.get_end_idx() : pfi.height-1;

  const int ys = img_start_line;               // first output line
  const int ye = ys + data_end_line - data_start_line;

  if (NULL == img_buffer) {
    int tmp = pfi.size > frame_height*frame_width*bits_per_pixel/8?
      pfi.size : frame_height*frame_width*bits_per_pixel/8;

    img_buffer = (char*)malloc(tmp*sizeof(char));

    if (!img_buffer) {
      cerr<<" [PPMP_Receiver::accumulate_fragment(): mem alloc error"<<endl;
      exit(-1);
    }
  }

  //If frame # conflicts, flush the curr frame
  if (flushOrNot) {
    return img_buffer;
  }

  //May change each time, depends on MUS and img size ...
  int line_to_accumulate = data_end_line+1 > pfi.height-line_accumulated ?
    pfi.height-line_accumulated : data_end_line+1;
  line_to_accumulate = line_to_accumulate > 0 ? line_to_accumulate:0;

  for (int y=0; y<line_to_accumulate;y++)
    {
      memcpy((void*)(img_buffer+ (y+ys)*bytes_per_line), frag_buf +
	     PPMP_FRAME_INFO_OFFSET + y*bytes_per_line, 
	     bytes_per_line);
      line.set_available(y+ys);
      line.increase_idx(1);
      
      line_accumulated ++;
  
      BytesReceived += bytes_per_line;
    }

  img_start_line += line_to_accumulate;

  if (pfi.size <= BytesReceived) {
    BytesReceived = 0;
  }

  if (false == line.all_available()) 
    return NULL;

  if (DEBUG_WHERE) {
    printf(" \n[PPMP_Receiver::accumulate_fragment(): A whole frame accumulated -------------------------\n\n");
  }

  if (1) {
    process_whole_frame(img_buffer, pfi.size);
  }

  line.free_available();

  return img_buffer;
}
    
