#include "Monitor.h"
#include "ace/OS.h"

#include "ace/Token.h"

int accum_qos_time = 0;

#include "Share_Syn.h"
//local map of the shared mem
extern char* shm, *shm_buf;
extern int semid;
extern union semun sunion;
extern int DeleteSemid;
extern ACE_Shared_Memory_SV* shm_reader;


unsigned int FILTER = 0;
extern unsigned int user_fps;

class Args {
public:
  Args(CORBA::ORB_ptr orb): mutex_(), orb_(orb) 
  {
  }
  
  ACE_Token mutex_;
  CORBA::ORB_ptr orb_;
};

void* setControlCenterServer(void* argument) 
{
  Args* arg = (Args*)argument;
  RECEIVER_MONITOR_CLIENT::instance() -> cci = new ControlCenterImpl();
  ControlCenter_ptr cciptr = RECEIVER_MONITOR_CLIENT::instance()->cci->_this();
  
  ofstream ostr("ControlCenter.ior");
  ostr << arg->orb_->object_to_string(cciptr)<<endl;
  ostr.close();
  
  cout<<" [ReceiverMonitorClient::main(): ControlCenter Server ready...\n";
  //arg->orb_->run();

  while (1) {
    if (arg->orb_->work_pending())
      arg->orb_->perform_work();
    ACE_OS::sleep(1);
  }
}  


int main(int argc, char** argv)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  int result;
  CORBA::ORB_var orb;

  ACE_TRY
    {
      /*CORBA::ORB_var*/ orb = CORBA::ORB_init (argc,
                                            argv,
                                            0,
                                            ACE_TRY_ENV);
      ACE_TRY_CHECK;
 
      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA"
                                           );
      ACE_TRY_CHECK;

      PortableServer::POA_var root_poa
        = PortableServer::POA::_narrow (obj.in ()
                                        );
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager ();
      ACE_TRY_CHECK;

      mgr->activate ();
      ACE_TRY_CHECK;

      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in ()
                                      );
      ACE_TRY_CHECK;

      
      // Initialize the Client.
      /*int*/ result = 0;

      result = RECEIVER_MONITOR_CLIENT::instance ()->init (argc,
							   argv,
							   "ReceiverMonitor",
							   "SenderMonitor",
							   ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result < 0)
	ACE_ERROR_RETURN ((LM_ERROR,
			   "ReceiverMonitorClient::main(): init failed\n"), -1);
      

      /////////////////////////////////////////////////
      //For Measuremnet
      ACE_Shared_Memory_SV shm_reader (SHM_KEY_R, SHMSZ_R);
      
      shm = (char *) shm_reader.malloc ();
      if (shm == 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                           "%p\n\t(%P|%t) Cannot get shared memory segment.\n"
                           ,argv[0]), -1);
      ACE_DEBUG ((LM_INFO,
                  "(%P|%t) Shared Memory is at 0x%x\n",
                  shm ));

      //Get semaphore
      semid = *(int *)shm;
      shm_buf = shm + sizeof(int);
      ACE_DEBUG((LM_INFO," semid is %d\n", semid));

      //DeleteSemid = semid;
      //atexit(&mydelete);
      //signal(SIGINT, &sigdelete);
      //
      /////////////////////////////////////////////////
 

      
      //Init the corba object
      Args arg(orb.in());
      if (ACE_Thread::spawn((ACE_THR_FUNC)setControlCenterServer, (void*)&arg,
			    THR_DETACHED|THR_NEW_LWP) == -1) 
	ACE_DEBUG((LM_DEBUG, " Error in spawning thread\n"));

     
      RECEIVER_MONITOR_CLIENT::instance ()->sendData ();
      ACE_TRY_CHECK;
      
      RECEIVER_MONITOR_CLIENT::instance ()->getCtrlManager().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;

      shm_reader.close();
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"ReceiverMonitor::main(): Exception !\n");
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);
  
  return 0;
}
