
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // Sender.cpp
#include <ace/Get_Opt.h>
#include <ace/OS.h>


#define DEBUG 0

int AV_MAX_BUFSIZ = 16*1024;

int SOURCE_ID =0;


#include "Share_Syn.h"
char* shm, *shm_buf;
int semid;
union semun sunion;
int DeleteSemid = 0;
ACE_Shared_Memory_SV* shm_reader;
ACE_Time_Value now;

unsigned int  FILTER=0;
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1<<(i))
#define FILTER_GET(flag, i) ((flag) & 1<<(i))

int accum_qos_time = 0;

#include "PPMP.h"
#include "ppmudpreader.h"
class PPM_UDP_Reader;

#define MIN_PKT_RATE 1
#define ZERO_ERR .0001
int last_pkt_rate = 10;
float last_missing_pkt_rate = 0;
int INTERVAL; 
int PKT_RATE = 1;

#include "vdev.h"
VDev_T vdev = NULL;
struct VDev_imageSize imageSize;

typedef unsigned char pixval;
int NUM_OF_FRAMES = 0; /* 0 is forever */
#define IMAGE_SIZE  921600 /* 3*640*480, actually ONLY 230400 is used*/
int MUS = 15360;
int MAXPIXELSIZE = 3;
int MAXLINESIZE = 640;
bool NO_CAM = false; /* PPM from file instead of live camera */
char img_0_file[] = "img0.ppm"; char img_1_file[] = "img1.ppm";
int img_0, img_1;
char* img_0_buf = NULL;
char* img_1_buf = NULL;


PPM_frame_info pfi_big, pfi_small, pfi;

/*************** ADAPTATION INFORMATION *******************/
FILE* profile = NULL;

typedef struct adapt_table_t {
        // Avg. Size Reduction factor
        float comp_ratio;

        // reduction in size ?
        // 0 => No reduction
        // 1 => Halve image
        short reqScale;

        // make it a gray scale image?
        // 0 =>  color
        // 1 => grayscale
        short reqGrayscale;

        // Lossless Data Compression
        // 0 => No compression
        // 5, GZIP => GZIP
        // 6, LZO => LZO Compression
        short reqCompress;
       // Lossy Image compression
        // 0 => No compression
        // 7. JPG => JPG Compression
        short reqLossy;
}adaptation_table;

#define A_LEVELS 7
adaptation_table aTable[A_LEVELS] =
                {
                        {0.50, 0, 0, 1, 0}, // GZIP
                        {0.33, 0, 1, 0 , 0}, // GrayScale
                        {0.25, 1, 0, 0 , 0}, // Scale down to 1/2
                        {0.17, 0, 1, 1, 0}, // GZIP + Grayscale
                        {0.13, 1, 0, 1, 0}, // GZIP + Scaling
                        {0.08, 1, 1, 0 , 0}, // Grayscale + Scaling
                        {0.05, 0, 0, 0 , JPEG1}, // JPG
                };

float getEquivFps (unsigned int filterFlag, float pkt_rate)
{
  float fps = pkt_rate;
  static int num_times_table[] = {
    16, //320x240 no filters, 16 pkts / ppm_frame
    5, //Shrink 
    6, //Grey
    2 //Jpeg
  };
  //order is important
  if (!FILTER_GET(filterFlag, SHRINK) && 
      !FILTER_GET(filterFlag, GREY) &&
      !FILTER_GET(filterFlag, JPEG1) ) 
    fps = pkt_rate/num_times_table[0];
  else {
    if (FILTER_GET(filterFlag, GREY))
      fps = pkt_rate/num_times_table[2];
    if (FILTER_GET(filterFlag, SHRINK)) 
      fps = pkt_rate/num_times_table[1];
    if (FILTER_GET(filterFlag, JPEG1)) 
      fps = pkt_rate/num_times_table[3];
  }

  return fps>.1? fps:.1;
}

/************** Adaptable Values from Client **************/
short ifScale, ifGrayscale, ifCompress, ifLossy, ifEncode;

/************** Local Adaptation Information **************/
short haveLZO, haveGZIP, haveLossy, haveEncode, haveGrayscale, haveScale;
#define haveCompress (((haveLZO | haveGZIP)==0)?0:1)


  //<block name="pipe_Sender">

  #include "Sender.h"


extern "C" {
  
    //<block name="filter_ENCRYPT">
#include "encrypt.h"
extern EncryptParam encryptParam;
extern int KEYSIZE;
    //</block>
  
    //<block name="filter_JPEG">
#include "jpgcodec.h"
    //</block>
  
    //<block name="filter_GZIP">
#include "gzip.h"
    //</block>
  
    //<block name="filter_SHRINK">
#include "imgFilters/filters.h"
    //</block>
  
    //<block name="filter_GREY">
#include "imgFilters/filters.h"
    //</block>
  
}    


int SenderStreamEndPoint::get_callback(const char *flowname, TAO_AV_Callback *&callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &this->callback;

  return 0;
}
    

int SenderStreamEndPoint::set_protocol_object(const char *flowname, TAO_AV_Protocol_Object *object)
{
  CtrlManager &ctrlManager =
    SENDER::instance ()->getCtrlManager ();

  ctrlManager.getProtocolObjects().bind (flowname, object);

  ctrlManager.addToStreamCtrlsMap (flowname, this);

  return 0;
}
    

CORBA::Boolean SenderStreamEndPoint::handle_preconnect(AVStreams::flowSpec &flow_spec)
{
  for (unsigned int i = 0; i<flow_spec.length(); i++) {
    TAO_Forward_FlowSpec_Entry entry;
    entry.parse (flow_spec[i].in());

    ACE_CString flowname (entry.flowname());

    CtrlManager& ctrlManager = SENDER::instance()->getCtrlManager();

    int result = ctrlManager.getProtocolObjects().find(flowname);

    if (0==result) {
      ACE_DEBUG ((LM_DEBUG, " Sender changes receivers\n"));
      ctrlManager.destroy(flowname);
    }
  }

  return 0;
}
    

 Sender::~Sender(void)
{
}
    

 Sender::Sender(void)
 : senderMMDevice(0), senderName("Sender")
{
}
    

int Sender::initPipe()
{
  if (!NO_CAM) {
    VDev_init (320, 240);
    if (VDev_numVDevices()<1) cout<<" No camera found !\n";

    vdev = VDev_getVDevice(0);
    if (vdev == NULL || !VDev_isValid(vdev))
      cout<<"Something is wrong\n";

    cout<<"V4L name: "<<VDev_getIntfName(vdev)<<"\n";

    VDev_open(vdev, 2);
    if (VDev_getDescriptor(vdev) < 0)
      cout<<"Something is wrong, what camera are you asking for?\n";

    VDev_getSize(vdev, &imageSize);
    cout<<" imageSize (width, heigth): "<<imageSize.width<<", "<<imageSize.height<<"\n";
  }
  else {
    if (0 > (img_0 = open(img_0_file, O_RDONLY)))
      cout<<" Can't find PPM source file\n", exit(-1);
    if ( NULL == (img_0_buf = (char*)malloc(320*240*3*sizeof(char))))
        cout<<" Can't allocate mem for PPM\n", exit(-1);
    read(img_0, img_0_buf, 16);
    read(img_0, img_0_buf, 320*240*3);

    if (0 > (img_1 = open(img_1_file, O_RDONLY)))
      cout<<" Can't find PPM source file\n", exit(-1);
    if ( NULL == (img_1_buf = (char*)malloc(320*240*3*sizeof(char))))
        cout<<" Can't allocate mem for PPM\n", exit(-1);
    read(img_1, img_1_buf, 16);
    read(img_1, img_1_buf, 320*240*3);
  }

  
    //<block name="filter_ENCRYPT">
  if (1) {
    encryptParam.keySize = KEYSIZE/8;
    encryptParam.ivSize = encryptParam.keySize;
    if (NULL == (encryptParam.key = (char *) malloc(encryptParam.keySize * sizeof(char))) ||
        NULL == (encryptParam.iv = (char *) malloc(encryptParam.ivSize * sizeof(char))))
      cout<<" Encryption key no mem\n", exit(-1);

    char algo[30];
    sprintf(algo, "%s-%d", "rijndael", encryptParam.keySize*8); //KEYSIZE in bytes.
    strncpy(encryptParam.key, "abcdefghijklmnopqrstuvwxyz123456", encryptParam.keySize);
    strncpy(encryptParam.iv, "abcdefghijklmnopqrstuvwxyz123456", encryptParam.keySize);

    if ( MCRYPT_FAILED == (encryptParam.cryptContext = CreateContext(algo, "cbc")))
      cout<<" Encryption error 1\n", exit(-1);
    if (0 > SetParams((void *) &(encryptParam.cryptContext), encryptParam.key,
encryptParam.iv))
      cout<<" Encryption error 2\n", exit(-1);
  }
    //</block>
  
    //<block name="filter_JPEG">
  if (1) {
    int ret = init_jpeg_compress();
    ret = init_jpeg_decompress();
    if (ret < 0)
      cout<<" Jpeg init error\n", exit(-1);
  }
    //</block>
  

  return 0;
}
    

int Sender::init(int argc, char** argv, CORBA::Environment& ACE_TRY_ENV)
{
  int result;

  result = parseArgs (argc, argv);
  if (0!= result) return result;

  result = initPipe();

  shm_reader = new ACE_Shared_Memory_SV(SHM_KEY_S, SHMSZ_S);
  shm = (char *) shm_reader->malloc ();
  if (shm == 0)
    ACE_ERROR_RETURN ((LM_ERROR,
                       "%p\n\t(%P|%t) Cannot get shared memory segment.\n"
                       ,argv[0]), -1);
  ACE_DEBUG ((LM_INFO,
              "(%P|%t) Shared Memory is at 0x%x\n",
              shm ));
  //Get semaphore
  semid = *(int *)shm;
  shm_buf = shm + sizeof(unsigned int);
  ACE_DEBUG((LM_INFO," semid is %d\n", semid));

  if (NULL==(profile = fopen("./frontEnd/src/PROFILE", "r"))) {
    cout<<" File open error\n";
    exit(-1);
  }
  else
    cout<<" File ./frontEnd/src/PROFILE open sucessfully\n";

  char filter_profile[40];
  fscanf(profile, "%s", filter_profile);
  if (!strcmp(filter_profile, "resolution_profile")) {
    haveGZIP = haveLossy = haveEncode = 1;
    haveGrayscale = haveScale = 0;
  }
  else if (!strcmp(filter_profile, "fps_profile")) {
    haveGZIP = haveGrayscale = haveScale = haveLossy = haveEncode = 1;
  }
  else {
    cout<<" No filter profile found !!!!!!!\n";
  }

  cout<<" profile: "<<filter_profile<<endl;
  cout<<" haveScale("<<haveScale<<"), haveGrayscale("<<haveGrayscale<<"), haveLossy("      <<haveLossy<<"), haveCompress("<<haveCompress<<"), haveEncode("<<haveEncode<<")"
      <<endl;
  for (int i = 0;i<A_LEVELS; i++)
    cout<<" Compress_ration[]: "<<aTable[i].comp_ratio<<endl;



  result = senderEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                       TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (senderMMDevice,
                  TAO_MMDevice (&senderEndpointStrategy),
                  -1);

  PortableServer::ServantBase_var safeMMDevice = senderMMDevice;

  AVStreams::MMDevice_var mmdevice = senderMMDevice->_this(ACE_ENV_SINGLE_ARG_PARAMETER);
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToReceivers(senderName,
                              "Receiver",
                              mmdevice.in(),
                              ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToReceivers (mmdevice.in(),
                                  theQos,
                                  0,
                                  ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}
    

int Sender::parseArgs(int argc, char** argv)
{
  if(argc < 1+2){
    ACE_DEBUG((LM_DEBUG, "Usage:\n\n"));
    ACE_DEBUG((LM_DEBUG, "   Sender <-n numOfFrames> [-f] [-s src_id] [-i interval] [-M MTU] [-P maxpixel] [-L maxlinesize]\n"));
    return -1;
  }

  INTERVAL = 500; //in milli-sec

  // Parse command line arguments
  ACE_Get_Opt opts (argc, argv, "n:i::M::P::L::s::f");

  int c;
  while ((c= opts ()) != -1)
    {
      switch (c)
        {
        case 'n':
          NUM_OF_FRAMES = ACE_OS::atoi (opts.optarg);
          break;
        case 'M':
          MUS = ACE_OS::atoi (opts.optarg);
          break;
        case 'P':
          MAXPIXELSIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'L':
          MAXLINESIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'i':
          INTERVAL = ACE_OS::atoi (opts.optarg);
          break;
        case 's':
          SOURCE_ID = ACE_OS::atoi (opts.optarg);
          break;
	case 'f':
          NO_CAM = true;
          break;
        default:
          ACE_DEBUG ((LM_DEBUG, "Unknown Option\n"));
          return -1;
        }
    }

  return 0;
}
    

const char* Sender::getName(void)
{
   return senderName.c_str();
}
    

CtrlManager& Sender::getCtrlManager(void)
{
  return ctrlManager;
}
    

int Sender::sendData(void)
{
  char* img_buf;
  unsigned int sem_flag = 0;
  int sleep_time = (int)(1000000/PKT_RATE);

  bool windowUpdate = false;

  if (!(img_buf = (char*)malloc(IMAGE_SIZE*sizeof(char))))
  {
    printf(" [Sender::sendData(): 0ut of mem\n");
    exit(-1);
  }

  ACE_TRY
    {
      int j;
      int readresult;
      int sendresult;
      ACE_Time_Value start, now;

      //Dynamic adaptation
      float curr_compress_ratio = 1.0;
      float target_compress_ratio = 1.0;
      int last_PKT_RATE = 1;
      unsigned int last_sem_flag;

      PPM_UDP_Reader reader(MUS, MAXPIXELSIZE, MAXLINESIZE);

      char filter_str[9];
      for (int i = 0; NUM_OF_FRAMES==0 || i < NUM_OF_FRAMES; i++) {

        start = ACE_OS::gettimeofday();

        //Now the flowCtrl bit in sem_flag is used to indicate it's dynamic fps control adapation.
        sem_flag = *(unsigned int*)shm_buf;

        FILTER &= 0;

        if ( (sem_flag & 0x80000000)  &&
             ((sem_flag & 0xFF)!= 99) ) {
	  if (DEBUG) {
            ACE_DEBUG((LM_DEBUG," Sender::sendData(): flag in shm indicates flowCtrl applied\n"));
            printf(" sem_flag(%x)\n", sem_flag);
          }
          //Flow Control applied
          int curr_pkt_rate = *(int*)(shm_buf + 3*sizeof(unsigned int));
          int last_pkt_seq = *(int*)(shm_buf + 4*sizeof(unsigned int));
          float missing_pkt_rate = *(float*)(shm_buf +
                                             5*sizeof(unsigned int));

          PKT_RATE = *(int*)(shm_buf + 5*sizeof(unsigned int) + sizeof(float));

          if (PKT_RATE < MIN_PKT_RATE) PKT_RATE=MIN_PKT_RATE;
          //If feedback changed from the last one as according to the
          //information passed from SenderMonitorServer
          if ( (curr_pkt_rate != last_pkt_rate) ||
               (PKT_RATE != last_PKT_RATE) ||
	       (last_sem_flag != sem_flag) ||
               (missing_pkt_rate - last_missing_pkt_rate > ZERO_ERR) ||
               (missing_pkt_rate - last_missing_pkt_rate < -ZERO_ERR) )
            {
	      float equiv_curr_fps, equiv_target_fps;
              windowUpdate = true;

              if (FILTER_GET(sem_flag, GZIP) || FILTER_GET(sem_flag, LZO))
                ifCompress = 1 & haveCompress;
              else
                ifCompress = 0;
              if (FILTER_GET(sem_flag, SHRINK)) ifScale = 1 & haveScale;
              else ifScale = 0;
              if (FILTER_GET(sem_flag, JPEG1)) ifLossy = 1 & haveLossy;
              else ifLossy = 0;
              if (FILTER_GET(sem_flag, ENCRYPT)) ifEncode = 1 & haveEncode;
              else ifEncode = 0;
              if (FILTER_GET(sem_flag, GREY)) ifGrayscale = 1 & haveGrayscale;
              else ifGrayscale = 0;

	      equiv_curr_fps = getEquivFps(last_sem_flag, last_pkt_rate);
	      equiv_target_fps = getEquivFps(sem_flag, PKT_RATE);

	      target_compress_ratio = equiv_curr_fps * curr_compress_ratio / equiv_target_fps;

              last_missing_pkt_rate = missing_pkt_rate;
              last_PKT_RATE = PKT_RATE;
	      last_sem_flag = sem_flag;
	      last_pkt_rate = curr_pkt_rate;

              if (DEBUG) {
                printf(" compress_ratio: %10.3f ==> %10.3f\n",curr_compress_ratio,target_compress_ratio);
                printf("       pkt_rate: %d ==> %d\n", last_pkt_rate, PKT_RATE);
	        printf("            fps: %f ==> %f\n", equiv_curr_fps, equiv_target_fps);
              }
            } //if ( (curr_pkt_rate != last_pkt_rate) ||...


          // Disable all Compression
          if(target_compress_ratio > 0.90)
            {
              FILTER = 0;
              curr_compress_ratio = 1.0;
            }
         else {
            int k=0;
            int last_match = -1;

            for(k=0;k<A_LEVELS;k++)
              {
                if((aTable[k].reqScale != 0) && (ifScale == 0))
                  continue;

                if((aTable[k].reqGrayscale != 0) && (ifGrayscale == 0))
                  continue;

                if((aTable[k].reqCompress != 0) && ((ifCompress) == 0))
                  continue;

                if((aTable[k].reqLossy != 0) && (ifLossy == 0))
                  continue;

                // A matching filter has been found.
                last_match = k;
                if(target_compress_ratio >= aTable[k].comp_ratio)
                  {
                    if (aTable[k].reqCompress) SET_FILTER(GZIP);
                    if (aTable[k].reqLossy) SET_FILTER(JPEG1);

                    if(aTable[last_match].reqScale)
                      SET_FILTER(SHRINK);
                    if(aTable[last_match].reqGrayscale)
                      SET_FILTER(GREY);

                    curr_compress_ratio = aTable[k].comp_ratio;
                    break;
                  }
              }

            // Cannot Satisfy Requirements for current compression ratio
            //
            // So we choose the last possible match
            // if last_match = -1 then we disable all compression
            if(k== A_LEVELS)
              {
                if(last_match == -1)
                  {
                    FILTER = 0;
                    curr_compress_ratio = 1;
                  }
                else
                  {
                    if (aTable[last_match].reqCompress) {
                      SET_FILTER(GZIP);
                      }
                    if (aTable[last_match].reqLossy) {
                      SET_FILTER(JPEG1);
                    }
                    if(aTable[last_match].reqScale) {
                      SET_FILTER(SHRINK);
                    }
                    if(aTable[last_match].reqGrayscale) {
                      SET_FILTER(GREY);
                    }
                    curr_compress_ratio = aTable[last_match].comp_ratio;
                  }
              }
          }// if(target_compress_ratio > .90)

          //Enable Encryption
          if(ifEncode != 0)
            {
              SET_FILTER(ENCRYPT);
            }else{
              //no op because every time FILTER starts from 0 -- default to noencrypt first;
            }

          sleep_time = 1e6/ PKT_RATE;

          if (DEBUG) {
            cout<<" ifScale("<<ifScale<<"), ifGrayscale("<<ifGrayscale<<"), ifLossy("<<ifLossy
                <<"), ifCompress("<<ifCompress<<"), ifEncode("<<ifEncode<<")"<<endl;
            cout<<" haveScale("<<haveScale<<"), haveGrayscale("<<haveGrayscale<<"), haveLossy("
                <<haveLossy<<"), haveCompress("<<haveCompress<<"), haveEncode("<<haveEncode<<")"
                <<endl;
            cout<<" compress_ratio: "<<curr_compress_ratio<<endl;
            cout<<" last_pkt_rate: "
                <<last_pkt_rate
                <<", missing_pkt_rate: "<<last_missing_pkt_rate
                <<", sleep:"<<sleep_time<<endl;
          }

          //Visualize filter
          if (FILTER & 1) filter_str[7] = 'X'; else filter_str[7]='o';
          if (FILTER & 2) filter_str[6] = 'X'; else filter_str[6]='o';
          if (FILTER & 4) filter_str[5] = 'X'; else filter_str[5]='o';
          if (FILTER & 8) filter_str[4] = 'X'; else filter_str[4]='o';
          if (FILTER & 16) filter_str[3] = 'X'; else filter_str[3]='o';
          if (FILTER & 32) filter_str[2] = 'X'; else filter_str[2]='o';
          if (FILTER & 64) filter_str[1] = 'X'; else filter_str[1]='o';
          if (FILTER & 128) filter_str[0] = 'X'; else filter_str[0]='o';
          filter_str[8]='\0';
	  printf(" [%s]%d\n", filter_str,i);
        } //if (sem_flag == 1)
        else if ( sem_flag == 99)  {
          //Sender shall stop
          break;
        }

        pfi.tag = i;
        pfi.ppm1 = 'P';
        pfi.ppm2 = '6';
        if (!NO_CAM) {
          pfi.buff = (char*) VDev_getPPMImage(vdev, 6);
          pfi.size = VDev_getRawSize(vdev);
          pfi.width = imageSize.width;
          pfi.height = imageSize.height;
        }
        else {
          pfi.width = 320;
          pfi.height = 240;
          pfi.size = 320*240*3;
        }

        FILTER &= 0xFF;

        j = 0;

        reader.setPPMFrameInfo (MUS, pfi);
        readresult = pfi.size;
	if (!NO_CAM) {
          sendresult = reader.send_whole_frame(pfi.buff, readresult, i, SOURCE_ID, FILTER);
          if (pfi.buff) free(pfi.buff), pfi.buff = NULL;
        }
         else
          i%2==0?sendresult=reader.send_whole_frame(img_0_buf,readresult,i,SOURCE_ID,FILTER):
            sendresult=reader.send_whole_frame(img_1_buf,readresult,i,SOURCE_ID,FILTER);

        if (sendresult < 0) {
          printf(" [Sender::sendData(): this frame is NOT sent \n");
          exit(-1);
        }

        j += sendresult;

        if (sleep_time > 0 )
          {
            now = ACE_OS::gettimeofday();
            double more_sleep =  sleep_time -
              (now.sec() - start.sec())*1000000
              - now.usec() + start.usec();
            double sleep_st = now.sec() *1000000 + now.usec();
            double sleep_diff = 0;
            if (more_sleep > 10000000) ACE_DEBUG((LM_DEBUG,
                                                  "> 10 sec sleep time !!\n"));
            while (more_sleep > sleep_diff)
              {
                now = ACE_OS::gettimeofday();
                sleep_diff = now.sec()* 1000000 + now.usec()
                  - sleep_st;
              }
          }
      }/* for (int i = 0; NUM_OF_FRAMES==0 || i < NUM_OF_FRAMES; i++) */
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                           " sendData(): exception\n");
      return -1;
    }
  ACE_ENDTRY;

  if (img_buf) free(img_buf);
  if (NO_CAM)
    close(img_0), close(img_1);

  return 0;
}
    

  

  //</block>

     
  
int main(int argc, char **argv)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  ACE_TRY
    {
      CORBA::ORB_var orb = CORBA::ORB_init (argc,
                                            argv,
                                            0,
                                            ACE_TRY_ENV);
      ACE_TRY_CHECK;

      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA" 
	                                   ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POA_var root_poa
        = PortableServer::POA::_narrow (obj.in ()
                                        ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      mgr->activate (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in ()
                                      ACE_ENV_ARG_PARAMETER);	
      ACE_TRY_CHECK;

      // Initialize the Client.
      int result = 0;
      result = SENDER::instance ()->init (argc,
                                          argv,
                                          ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result < 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                           "main(): init failed\n"), -1);

      ACE_OS::sleep(2);

      SENDER::instance ()->sendData ();
      ACE_TRY_CHECK;

      //For the last packet. Hack...
      ACE_OS::sleep (1);

      SENDER::instance ()->getCtrlManager().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"main(): Exception !\n");
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);

  return 0;
}
    

  


#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton <Sender,ACE_Null_Mutex>;
template class TAO_AV_Endpoint_Reactive_Strategy_A<SenderStreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy<SenderStreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton <Sender,ACE_Null_Mutex>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_A<SenderStreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy<SenderStreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */

   