/*
 * $Id: Share_Syn.h,v 1.1.1.1 2003/06/11 19:05:35 wyan Exp $
 * File: Share_Syn.h
 *       For shared mem and
 *       for synchronization between the following processes:
 *       eSender, SenderMonitorServer, SenderMoniterClient, Receiver,
 *       and ReceiverMonitor.
 */


#ifndef _SHARE_SYN_H
#define _SHARE_SYN_H

#include "ace/Shared_Memory_SV.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

/*
#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
// union semun is defined by including <sys/sem.h> 
#else
// according to X/OPEN we have to define it ourselves 
union semun {
  int val;                
  struct semid_ds *buf;   
  unsigned short int *array;
  struct seminfo *__buf;    
};
#endif
*/

#define SN_WRITE 0
#define SN_READ 1
#define SN_LOCK 2

extern int DeleteSemid;

void mydelete(void);
void sigdelete(int signum);
void locksem(int semid, int semnum);
void unlocksem(int semid, int semnum);
void waitzero(int semid, int semnum);
int safesemctl(int semid, int semnum, int cmd, union semun arg);
int safesemop(int semid, struct sembuf *sops, unsigned nsops);


//In bytes. Sender Side stores semaphore_id + QoS adaptation scheme + 
//                             curr_latency + minimum_one_way_latency
//                             + pkt_rate + last_recv'd_pkt_seq_num +
//                             missing_pkt_rate + target_fps
//QoS adaptation scheme = { 0x???????? }
//                         The filterType will consume 1 byte so 
//           0xHH  : is without flowCtrl but with filterType = 0xHH
//  0x80 00 00 HH  : is with flowCtrl and with filterType = 0xHH
#define SHMSZ_S sizeof(int) + 5*sizeof(unsigned int) + sizeof(float) + sizeof(float)
// Play with this, pick a value you like that isn't used by something else.
#define SHM_KEY_S 1111

//Receiver Side stores semaphore_id 
//If Ctrl_msg_type == 2
//                     + Ctrl_msg_type (int) 
//                     + window_bw (float) + window_jitter (int)
//                     + window_recv_rate (int) + window_miss_pkt_rate (float)
//                     + last_pkt_seq_nr (int) + curr_fps (float) 
//If Ctrl_msg_type == 4
//                     + Ctrl_msg_type (int)
//                     + bw (float) + pkt_rate
//                     + miss_pkt_rate 
#define SHMSZ_R sizeof(int) + 4*sizeof(unsigned int) + 3*sizeof(float)
#define SHM_KEY_R 2222





#endif 

