//
//$Id: filters.c,v 1.1.1.1 2003/06/11 19:05:36 wyan Exp $
//
//File: filters.c
//      The filters include shrink, grey, and others
//      The input images should be in raw pixel format.
//      @see ecl filters in the Gatech-UAV demo

#include "filters.h"

int shrinkFilter(const PPM_frame_info_ptr inImage,
                 PPM_frame_info_ptr outImage)
{
  int col;
  int row;
  int indx;
  int outIndx;
  int currIndx;
  int currOutIndx;
  int inOffset;

  outImage->ppm1 = 80;
  outImage->ppm2 = inImage->ppm2;
  outImage->width = inImage->width/2;
  outImage->height = inImage->height/2;

  inOffset = inImage->width * 3;
  for (row = 0; row < (inImage->height - 1); row = row + 2) {
    indx = row * inOffset;
    outIndx = row / 2 * outImage->width * 3;

    for ( col = 0; col < (inImage->width - 1); col = col + 2 ) {
        currIndx = indx + col * 3;
        currOutIndx = outIndx + col / 2 * 3;
        outImage->buff[currOutIndx] = (inImage->buff[currIndx]);
        outImage->buff[currOutIndx+1] = (inImage->buff[currIndx+1]);
        outImage->buff[currOutIndx+2] = (inImage->buff[currIndx+2]);
    }
  }

  outImage->size = inImage->size/4;

  return 1;
}


int greyFilter(const PPM_frame_info_ptr inImage,
               PPM_frame_info_ptr outImage)
{
  int col;
  int row;
  int indx;
  int outIndx;
  int tmp;

  outImage->ppm1 = inImage->ppm1;
  outImage->ppm2 = inImage->ppm2 - 1;
  outImage->width = inImage->width;
  outImage->height = inImage->height;

  indx = 0;
  outIndx = 0;
  for (row = 0; row < inImage->height; row = row + 1) {
    for ( col = 0; col < inImage->width; col = col + 1) {
      tmp = (0.299 * inImage->buff[indx]  + 0.587 * inImage->buff[indx+1] +
             0.114 * inImage->buff[indx+2]) + 0.5;
      outImage->buff[outIndx] = tmp;
      indx = indx + 3;
      outIndx = outIndx + 1;
    }
  }
  outImage->size = outImage->width * outImage->height;

  return 1;
}
