


/**********************
 * Node000.h -- the header file for this node
 *
 **********************/
#ifndef __NODE000_H
#define __NODE000_H 1

// Include the data definitions
#include "datatypes.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <pthread.h>
#include <sched.h>
#include "auth.h"
#include <math.h>

#define GZIP 5 
#define LZO 6 
#define ENCRYPT 0x10	
#define JPG 7

//<block name="pipe_GZIP">

#include "gzip.h"

//</block>

//<block name="pipe_LZO">

//</block>

//<block name="pipe_ENCRYPT">

#include "encrypt.h"
#include <string.h>

//</block>

//<block name="pipe_JPEG">

#include "jpgcodec.h"

//</block>

void infopipeStartup(void);
void infopipeShutdown();

void receiver_node_Node000Receive(void);
int receiveDataPacket(int receiveSocket, void *uHdr);
int processQoSReceiver ( QoSHdrPtr qosHdr, char *in, int in_len, char *out, int *out_len, void *hdr);
void closeSocket(int sock);
void raiseEvent(char* );

void *receiverNodeControl(void* args);


/* Socket Functions */
int receiveData(int sockfd, void *dstruct, int size, int flags);
int sendData(int sockfd, void *dstruct, int size, int flags);

/* Output Function */
int processPPMImage(PPMDataHdr p);

/* Authentication */
int authenticate(int sock_fd);

#endif


