
/*
 * Cleanup File, Contains Global variables for Node000.c
 *
 *
 */

#ifndef __LOCAL_VARS_H
#define __LOCAL_VARS_H 1


#include "datatypes.h"
#include "Node000.h"

// Information about all the structures
int ppmDataHdrLength;
int arrayDataLength;
int ctrlHdrLength;
int authHdrLength;
int sessionHdrLength;
int qosHdrLength;
int dPktHdrLength;

// Start of epoch
struct timeval baseTime;  

// GLOBAL VARIABLES
int PKTCOUNT;
int ARRAYSIZE;
int WINDOWSIZE;

/* Basic Socket and Header information */
int sender_node_Node000SubmitSocket;
unsigned short port;
int ctrlSock;
int control_thread;

dataPacketHdr dpktHdr;
QoSHdr qosHdr;


// Encryption Information
EncryptParam encryptParam;


/* Authentication Information */
R_RSA_PRIVATE_KEY privKey;
R_RSA_PUBLIC_KEY mypubKey;
char pgmName[20];
char *keys_path="./keys/";
int authenticated = 0;
int auth_mode;


// Temporary Buffers
char *temp_buf, *img_buf;

/* Simulating a Text File - Used Only for Data Packets*/
// #define SRCARRAYSIZE 300000
// char *src_buf;
// int MAXSIZE;

// FEEDBACK
int min_lat=10000, curr_lat;
int pkt_rate=1000;
unsigned int sleep_time;
int pkts_sent = 0;
int wind_lat = 0;
int window_count = 0;

int pkt_size_hist, data_size_hist; // Size of data and packet over last few packets
int qos_time_hist;
int header_overhead;

int seq_no;

//stats
int tot_count = 0;
double qos_time=0;

#ifdef STATSvsTIME
int *lat_over_count;
int *bw_over_time;
#endif

#ifdef TIMING_STATS
int *send_ts, *rcv_ts;
int send_idx, rcv_idx;
#endif

int compress_type;
int encrypt_type;
int scale_type;
int JPEGQFactor;

PPMDataHdr Node000OutgoingData;
//ArrayData Node000OutgoingData;



/*************** ADAPTATION INFORMATION *******************/
#define A_LEVELS 9 
adaptation_table aTable[A_LEVELS] = 
		{ 
			{0.50, 0, 0, GZIP, 0}, // GZIP
			{0.33, 0, 1, 0 , 0}, // GrayScale
			{0.25, 1, 0, 0 , 0}, // Scale down to 1/2
			{0.17, 0, 1, GZIP, 0}, // GZIP + Grayscale
			{0.13, 1, 0, GZIP, 0}, // GZIP + Scaling
			{0.08, 1, 1, 0 , 0}, // Grayscale + Scaling
			{0.05, 0, 0, 0 , JPG}, // JPG 
			{0.04, 1, 1, GZIP, 0},  // GZIP + Grayscale +Scaling
			{0.02, 1, 1, 0, JPG}  // GZIP + Grayscale +Scaling
		};
					
/************** Adaptable Values from Client **************/
char ifScale, ifGrayscale, ifCompress, ifLossy, ifEncode;
int target_fps;

/************** Local Adaptation Information **************/
int current_fps;
char haveLZO, haveGZIP, haveLossy, haveEncode, haveGrayscale, haveScale;
#define haveCompress (((haveLZO | haveGZIP)==0)?0:1)
/* Notes:
 * Always ifCompress AND (haveLZO | haveGZIP)
 *        ifScale AND haveScale
 *        ifLossy AND haveJPG
 *        ifEncode AND haveENC
 *        ifGrayscale AND haveENC
 */

#endif

