<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="Sender_Makefile">
<xsl:param name="filters"/>

<file><name>sender/Makefile</name>

<content>

CFLAGS=-ggdb
CC = gcc $(CFLAGS)
LIBPATH=/usr/local/lib/
MYLIBS=../../lib/
INC=../../include
INCRSA=$(INC)/rsaref2

LFLAGS=-lpthread -lm

all:sender

sender: sender.o Node000.o imgfilters.o
	$(CC) $(LFLAGS) -osender sender.o Node000.o -L$(MYLIBS) -lvdev -lmyutils -lrsaref\
<xsl:if test="contains($filters, 'GREY')">	imgfilters.o\
</xsl:if>
<xsl:if test="contains($filters, 'ENCRYPT')">	-lencrypt\
</xsl:if>
<xsl:if test="contains($filters, 'LZO')">	-llzo\
</xsl:if>
<xsl:if test="contains($filters, 'GZIP')">	-lgzip\
</xsl:if>
<xsl:if test="contains($filters, 'JPEG')">	-ljpeg 
</xsl:if>

sender.o: sender.c Node000.h 
	$(CC) -c sender.c -I$(INC) -I$(INCRSA)

Node000.o: Node000.c datatypes.h Node000.h 
	$(CC) -c Node000.c -I$(INCRSA) -I$(INC)

<xsl:choose>

	<xsl:when test="contains($filters, 'GREY')">
imgfilters.o: imgfilters.c datatypes.h
	$(CC) -c imgfilters.c -I$(INC) -I$(INCRSA)
	</xsl:when>
	
	<xsl:otherwise>

		<xsl:if test="contains($filters, 'SHRINK')">
imgfilters.o: imgfilters.c datatypes.h
	$(CC) -c imgfilters.c -I$(INC) -I$(INCRSA)
		</xsl:if>
		
	</xsl:otherwise>
	
</xsl:choose>

clean:
	rm -f *.o sender core*

</content>
</file>
</xsl:template>
</xsl:stylesheet>

