#ifndef __JPEGCODEC_H
#define __JPEGCODEC_H 1

/***************
 * Patched Include file for jpeg
 *
 * *************/

/*
 * Call this function before using any jpeg function
 */
int init_jpeg_compress();

/*
 * Use this for compression- All memory preallocated
 */
int ppm_to_jpeg(const char *image_buffer, // Source Data
								int image_height, // Source Image height
								int image_width, // Source Image width
								char *JPGImageData, // Compressed Image
								int quality, // Quality Factor
								int *size); // Output Size

/*
 * Call at end to free mem
 */
int end_jpeg_compress();

/***************** DECOMPRESSION **********************/

/*
 * Call before compress
 */
int init_jpeg_decompress();

/*
 * Call to decompress- All memory preallocated
 */
int jpeg_to_ppm(const char *jpg_buffer, // Input buf
								int size, // Input Size
								int image_height, 
								int image_width,
								int color,
								char *out_buffer); // Output Buffer

/*
 * Call at end
 */

int end_jpeg_decompress();

#endif
