<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ================================================================= -->
<!-- $Id: Makefile.xsl,v 1.1.1.1 2003/06/11 19:11:43 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->

<xsl:template name="Makefile">
  <xsl:param name="name"/>
  <xsl:param name="sender_files"/>
  <xsl:param name="receiver_files"/>
  <xsl:param name="ctrlmanager_files"/>
  <xsl:param name="datatype_files"/>
  <xsl:param name="pipetype_files"/>
  <xsl:param name="ppmreader_files"/>
  <xsl:param name="ppmdecoder_files"/>
  <xsl:param name="sender_other_files"/>
  <xsl:param name="receiver_other_files"/>


  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
     <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/></name><content>

  <xsl:value-of select="$makefile_header"/>



RESOURCE_DIR=/home/wyan/Infosphere/isg/tests/SOSP
DVDVIEW_DIR=/home/wyan/DVDview

vdevlib = vdev
vdevlibpath = $(RESOURCE_DIR)/vdev/src
vdevinclude = $(RESOURCE_DIR)/vdev/src
LIBS += -l$(vdevlib)
CPPFLAGS +=	-I$(vdevinclude) 
LDFLAGS +=	-L$(vdevlibpath) 


filters = gzip lzo encrypt jpeg
compressionlib = $(addprefix -l, $(filters))
filterslibpath = $(RESOURCE_DIR)/lib
filtersinclude = $(RESOURCE_DIR)/include
LIBS += $(compressionlib)
CPPFLAGS += -I$(filtersinclude)
LDFLAGS += -L$(filterslibpath)


videogfxlib = videogfx
videogfxpath = $(DVDVIEW_DIR)/libvideogfx/libvideogfx/.libs
videogfxinclude = $(DVDVIEW_DIR)/libvideogfx
LIBS += -l$(videogfxlib) -lXext
CPPFLAGS += -I$(videogfxinclude)
LDFLAGS += -L$(videogfxpath) -L/usr/X11R6/lib



  <!-- The LIBS macro -->
  <xsl:text>LIBS += </xsl:text>  
  <xsl:call-template name="Makefile_libs">
    <xsl:with-param name="value">{TAO}{TAO_PortableServer}{TAO_CosNaming}{TAO_AV}{TAO_CosProperty}</xsl:with-param>
  </xsl:call-template>

LIBS += -limgFilters


  <!-- The sender -->
  <xsl:text>
SENDER_FILES = </xsl:text>
  <xsl:call-template name="appended_files"><xsl:with-param
  name="value"><xsl:value-of select="$sender_files"/><xsl:value-of
  select="$ctrlmanager_files"/><xsl:value-of
  select="$datatype_files"/><xsl:value-of
  select="$pipetype_files"/><xsl:value-of
  select="$ppmreader_files"/><xsl:value-of select="$sender_other_files"/></xsl:with-param>
  </xsl:call-template>

  <xsl:text>
SENDER_SRC  = $(addsuffix .cpp, $(SENDER_FILES))
SENDER_OBJS = $(addsuffix .o, $(SENDER_FILES))
</xsl:text>

  <!-- The receiver -->
  <xsl:text>
RECEIVER_FILES = </xsl:text>
  <xsl:call-template name="appended_files"><xsl:with-param
  name="value"><xsl:value-of select="$receiver_files"/><xsl:value-of
  select="$ctrlmanager_files"/><xsl:value-of
  select="$datatype_files"/><xsl:value-of
  select="$pipetype_files"/><xsl:value-of
  select="$ppmdecoder_files"/><xsl:value-of select="$receiver_other_files"/></xsl:with-param>
  </xsl:call-template>

  <xsl:text>
RECEIVER_SRC  = $(addsuffix .cpp, $(RECEIVER_FILES))
RECEIVER_OBJS = $(addsuffix .o, $(RECEIVER_FILES))
</xsl:text>


  <!-- The rest -->
  <xsl:value-of select="$empty_line"/>
  <xsl:text>
#----------------------------------------------------------------------------
#       Include macros and targets
#----------------------------------------------------------------------------

include $(ACE_ROOT)/include/makeinclude/wrapper_macros.GNU
include $(ACE_ROOT)/include/makeinclude/macros.GNU
include $(TAO_ROOT)/rules.tao.GNU
include $(ACE_ROOT)/include/makeinclude/rules.common.GNU
include $(ACE_ROOT)/include/makeinclude/rules.nonested.GNU
include $(ACE_ROOT)/include/makeinclude/rules.bin.GNU
include $(ACE_ROOT)/include/makeinclude/rules.local.GNU
include $(TAO_ROOT)/taoconfig.mk



CPPFLAGS +=	-I. \
		-I$(TAO_ROOT)/orbsvcs/orbsvcs \
		-I$(TAO_ROOT)/orbsvcs/orbsvcs/AV \
		-I$(TAO_ROOT)/orbsvcs \
	        -I./idl


LDFLAGS +=	-L$(TAO_ROOT)/orbsvcs/orbsvcs \
		-L./imgFilters \


BIN = Sender Receiver 


all: $(BIN)


Sender: $(addprefix $(VDIR),$(SENDER_OBJS))
	$(LINK.cc) $(LDFLAGS) -o $@ $^ $(VLDLIBS) $(POSTLINK) 

Receiver: $(addprefix $(VDIR),$(RECEIVER_OBJS))
	$(LINK.cc) $(LDFLAGS) -o $@ $^ $(VLDLIBS) $(POSTLINK) 


# DO NOT DELETE THIS LINE -- g++dep uses it.
# DO NOT PUT ANYTHING AFTER THIS LINE, IT WILL GO AWAY.
</xsl:text>


  </content></file>
</xsl:template>




<!-- ================================== -->
<!--      appended_files                -->
<!-- ================================== -->

<xsl:template name="appended_files">
  <xsl:param name="value"/>
  <xsl:if test="starts-with($value, '{')">
    <xsl:value-of select="substring-before(substring-after($value,'{'),'}')"/><xsl:text> </xsl:text>
  <!-- recursive -->
    <xsl:call-template name="appended_files">
      <xsl:with-param name="value" select="substring-after($value,'}')" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>


<!-- ================================== -->
<!--      Makefile_libs                 -->
<!-- ================================== -->

<xsl:template name="Makefile_libs">
  <xsl:param name="value"/>
  <xsl:if test="starts-with($value, '{')">
    <xsl:text>-l</xsl:text>
    <xsl:value-of select="substring-before(substring-after($value,'{'),'}')"/><xsl:text> </xsl:text>
  <!-- recursive -->
    <xsl:call-template name="Makefile_libs">
      <xsl:with-param name="value" select="substring-after($value,'}')" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>


</xsl:stylesheet>
