<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ================================================================= -->
<!-- $Id: Pipe.xsl,v 1.1.1.1 2003/06/11 19:11:44 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->

<!-- ================================= -->
<!--      The Pipe_CPP template      -->
<!-- ================================= -->

<xsl:template name="Pipe_CPP">
  <xsl:param name="name"/>
  <xsl:param name="filters"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
    <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.cpp</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.cpp')"/>
    </xsl:with-param>
  </xsl:call-template>


  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{stdio.h}{iostream}{ace/OS.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">
      <xsl:value-of select="concat('{',$name,'.h}')"/></xsl:with-param>
  </xsl:call-template>

ACE_Time_Value qos_last, qos_now;
extern int accum_qos_time;

#define DEBUG 0

  <xsl:call-template name="filters_header_include">
    <xsl:with-param name="used_filters">
      <xsl:value-of select="$filters"/>
    </xsl:with-param>
  </xsl:call-template>

extern unsigned int FILTER;
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER &amp;= 1&lt;&lt;(i))
#define FILTER_GET(flag, i) ((flag) &amp; 1&lt;&lt;(i))


EncryptParam encryptParam;
int KEYSIZE = 192;//bits = 24 bytes

  <xsl:value-of select="$empty_line"/>
  <!-- The implementation of related class method -->
  <!-- Cstr -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', $name)"/></xsl:with-param>
    <xsl:with-param name="init">
      <xsl:value-of select="concat('{in (DataFlow())}', '{out (DataFlow())}', '{inC (CtrlFlow())}', '{outC (CtrlFlow())}')"/>
    </xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Cstr() -->

  <!-- Dstr -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::~', $name)"/></xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- Endof Dstr() -->

  <!-- getInDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'getInDataFlow')"/></xsl:with-param>
    <xsl:with-param name="type">DataFlow&amp;</xsl:with-param>
      <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return in;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getInDataFlow() -->

  <!-- getOutDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'getOutDataFlow')"/></xsl:with-param>
      <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="type">DataFlow&amp;</xsl:with-param>
    <xsl:with-param name="content">
{
  return out;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getOutDataFlow() -->


  <!-- setInDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'setInDataFlow')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params"><xsl:value-of select="concat('{const ',
    'INFOP', '&amp; infop}{const Data&amp; data}')"/></xsl:with-param>
    <xsl:with-param name="content">
{
  in.setINFOP(infop);
  in.setPayload(data);
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of setInDataFlow() -->


  <!-- setOutDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'setOutDataFlow')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params"><xsl:value-of select="concat('{const ',
    'INFOP', '&amp; infop}{const Data&amp; data}')"/></xsl:with-param>
    <xsl:with-param name="content">
{
  out.setINFOP(infop);
  out.setPayload(data);
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of setOutDataFlow() -->

  <!-- inDataToOutData() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'inDataToOutData')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params">{unsigned int filterFlag}</xsl:with-param>
    <xsl:with-param name="content">
{
  Data outData, inData;
  outData.buff = inData.buff = NULL;
  int out_len=0;

  in.getPayload(&amp;inData);

  if ((filterFlag &amp; 0x80000000) == 0 &amp;&amp; (filterFlag != 0) ) {
    if (FILTER_GET(filterFlag, GZIP)) {
<xsl:if test="contains($filters, 'GZIP')">
    //&lt;block name="filter_GZIP">
      outData.SIZE=inData.SIZE + 50;
      outData.buff = new Type[outData.SIZE];

      qos_last = ACE_OS::gettimeofday();
      int status = gzip_compress(1, inData.buff, inData.SIZE, outData.buff, &amp;out_len);
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      if (0>status) 
	printf(" [Pipe::inDataToOutData(): GZIP encoding error\n");

      outData.SIZE = out_len;

      SET_INFOP(type, in.infop, filterFlag);
      SET_INFOP(length, in.infop, out_len + sizeof(out.infop));
      SET_INFOP(src_id, in.infop, accum_qos_time);
      setOutDataFlow(in.infop, outData);
    //&lt;/block>
  </xsl:if>
    }
    else if (FILTER_GET(filterFlag, LZO)) {
<xsl:if test="contains($filters, 'LZO')">
    //&lt;block name="filter_LZO">
      outData.SIZE=inData.SIZE + inData.SIZE/64 + inData.SIZE + inData.SIZE/64;
      if (NULL == (outData.buff = new Type[outData.SIZE]))
	printf(" Error\n");
      
      qos_last = ACE_OS::gettimeofday();
      int status = lzo_compress(1, inData.buff, inData.SIZE, outData.buff, &amp;out_len);
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      
      if (0>status) 
	printf(" [Pipe::inDataToOutData(): LZO encoding error\n");

      outData.SIZE = out_len;

      SET_INFOP(type, in.infop, filterFlag);
      SET_INFOP(length, in.infop, out_len + sizeof(out.infop));
      SET_INFOP(src_id, in.infop, accum_qos_time);

      setOutDataFlow(in.infop, outData);
    //&lt;/block>
  </xsl:if>
     }
     else if (FILTER_GET(filterFlag, ENCRYPT)) {
<xsl:if test="contains($filters, 'ENCRYPT')">
    //&lt;block name="filter_ENCRYPT">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): No compression but encryption  ...\n");
      outData.SIZE = inData.SIZE;
      outData.buff = new Type[outData.SIZE];
      memcpy(outData.buff, inData.buff, outData.SIZE);
    //&lt;/block>
  </xsl:if>
    }
    else if ( FILTER_GET(filterFlag, JPEG1) || FILTER_GET(filterFlag, JPEG2)
	      || FILTER_GET(filterFlag, JPEG3) ) {
<xsl:if test="contains($filters, 'JPEG')">
    //&lt;block name="filter_JPEG">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //&lt;/block>
  </xsl:if>
    }
    else if ( FILTER_GET(filterFlag, SHRINK) ) {
<xsl:if test="contains($filters, 'SHRINK')">
    //&lt;block name="filter_SHRINK">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //&lt;/block>
</xsl:if>
    }
    else if ( FILTER_GET(filterFlag, GREY) ) {
<xsl:if test="contains($filters, 'GREY')">
    //&lt;block name="filter_GREY">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //&lt;/block>
</xsl:if>
    }
  
    if ( FILTER_GET(filterFlag, ENCRYPT)) {
<xsl:if test="contains($filters, 'ENCRYPT')">
    //&lt;block name="filter_ENCRYPT">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): encryption, outData.SIZE: %d\n",outData.SIZE);
      int padding = 0; int cpy_size = 0;
      padding = outData.SIZE % encryptParam.keySize;
      
      if (padding != 0) {
	outData.SIZE = outData.SIZE + encryptParam.keySize - padding;
	cpy_size = outData.SIZE + padding -encryptParam.keySize;
      }
      else 
	cpy_size = outData.SIZE;

      Data another;
      another.SIZE = outData.SIZE;
      another.buff = new Type[another.SIZE];
      memcpy(another.buff, outData.buff, cpy_size);
      if (outData.buff) delete [] outData.buff, outData.buff = NULL;

      qos_last = ACE_OS::gettimeofday();
      int status = Encrypt((void *) &amp;(encryptParam.cryptContext), another.buff, another.SIZE, &amp;out_len);
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());
      
      if (0 != status) 
	printf(" [Pipe::inDataToOutData(): Encryption error\n");

      outData.SIZE = out_len + 2 ;//Add two bytes to store the length of the padding. if 0 means no padding.
      outData.buff = new Type[outData.SIZE];
      memcpy(outData.buff, another.buff, outData.SIZE -2);
      *(unsigned short*)(outData.buff + outData.SIZE-2) = padding;
      
      SET_INFOP(type, in.infop, filterFlag);
      SET_INFOP(length, in.infop, out_len + 2 + sizeof(out.infop));
      SET_INFOP(src_id, in.infop, accum_qos_time);
      setOutDataFlow(in.infop, outData);

      if (another.buff) delete [] another.buff, another.buff = NULL;
    //&lt;/block>
</xsl:if>
     }
    }
  else if ((filterFlag &amp; 0x80000000) == 0x80000000 &amp;&amp; (filterFlag != 0)) {
    //This is decryption, decompression or both
    //This is decryption
    if (FILTER_GET(filterFlag, ENCRYPT)) {
<xsl:if test="contains($filters, 'ENCRYPT')">
    //&lt;block name="filter_ENCRYPT">
      int padding = *(unsigned short*)(inData.buff + inData.SIZE - 2);

      Data another;
      another.SIZE = inData.SIZE - 2;
      another.buff = new Type[another.SIZE];
      memcpy(another.buff, inData.buff, another.SIZE);
      
      if (inData.buff) delete [] inData.buff, inData.buff = NULL;
      
      qos_last = ACE_OS::gettimeofday();
      int status = Decrypt((void *) &amp;(encryptParam.cryptContext), another.buff, another.SIZE, &amp;out_len);
      if(0 != status)
	printf(" [Pipe::inDataToOutData(): Decryption error\n");	
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());
     
      if(padding > 0)
	out_len = out_len + padding - encryptParam.keySize;

      inData.SIZE = out_len;
      inData.buff = new Type[inData.SIZE];
      memcpy(inData.buff, another.buff, out_len);

      if (another.buff) delete [] another.buff, another.buff = NULL;
    //&lt;/block>
</xsl:if>
    }
    if (FILTER_GET(filterFlag, GZIP)) {
<xsl:if test="contains($filters, 'GZIP')">
    //&lt;block name="filter_GZIP">

      outData.SIZE=inData.SIZE*10;
      outData.buff = new Type[outData.SIZE];

      qos_last = ACE_OS::gettimeofday();
      int status = gzip_decompress(inData.buff, inData.SIZE, outData.buff, &amp;out_len);
      
      if (0>status) 
	printf(" [Pipe::inDataToOutData(): GZIP decoding error\n");
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      outData.SIZE = out_len;

      SET_INFOP(length, in.infop, out_len);

      setOutDataFlow(in.infop, outData);
    //&lt;/block>
</xsl:if>
    }
    else if (FILTER_GET(filterFlag, LZO)) {
<xsl:if test="contains($filters, 'LZO')">
    //&lt;block name="filter_LZO">

      outData.SIZE=inData.SIZE*10;
      outData.buff = new Type[outData.SIZE];

      qos_last = ACE_OS::gettimeofday();
      int status = lzo_decompress(inData.buff, inData.SIZE, outData.buff, &amp;out_len);

      if (0>status) 
	printf(" [Pipe::inDataToOutData(): LZO decoding error\n");
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      outData.SIZE = out_len;

      SET_INFOP(length, in.infop, out_len);

      setOutDataFlow(in.infop, outData);
    //&lt;/block>
</xsl:if>
    }
    else if (FILTER_GET(filterFlag, ENCRYPT) )
      {
<xsl:if test="contains($filters, 'ENCRYPT')">
    //&lt;block name="filter_ENCRYPT">
	setOutDataFlow(in.infop, inData);
    //&lt;/block>
</xsl:if>
      }
    else if ( FILTER_GET(filterFlag, JPEG1) || FILTER_GET(filterFlag, JPEG2)
	     || FILTER_GET(filterFlag, JPEG3) )
      {
<xsl:if test="contains($filters, 'JPEG')">
    //&lt;block name="filter_JPEG">
	setOutDataFlow(in.infop, inData);
    //&lt;/block>
</xsl:if>
      }
    else if ( FILTER_GET(filterFlag, SHRINK) )
      {
<xsl:if test="contains($filters, 'SHRINK')">
    //&lt;block name="filter_SHRINK">
	setOutDataFlow(in.infop, inData);
    //&lt;/block>
</xsl:if>
      }
    else if ( FILTER_GET(filterFlag, GREY) ) 
      {
<xsl:if test="contains($filters, 'GREY')">
    //&lt;block name="filter_GREY">
	setOutDataFlow(in.infop, inData);
    //&lt;/block>
</xsl:if>
      }
  }
  else if (filterFlag == 0 )
    {
    if (DEBUG) printf(" [Pipe::inDataToOutData(): NO filters  ...\n");
    out = in;
    }

  if (outData.buff) delete [] outData.buff, outData.buff = NULL;
  if (inData.buff) delete [] inData.buff, inData.buff = NULL;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of inDataToOutData() -->


  <!-- importInDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'importInDataFlow')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
      <xsl:with-param name="params">{char* inbuf}{int inbuf_len}</xsl:with-param>
    <xsl:with-param name="content">
{
  Data d; d.buff = NULL;
  INFOP infop;

  memcpy(&amp;infop, inbuf, INFOP_HEADER_SIZE);
  d.SIZE = (inbuf_len - INFOP_HEADER_SIZE)/sizeof(Type);

  d.buff = new Type[d.SIZE];
  memcpy(d.buff, inbuf + INFOP_HEADER_SIZE, inbuf_len - INFOP_HEADER_SIZE);

  setInDataFlow(infop, d);

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of importInDataFlow() -->


  <!-- exportOutDataFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'exportOutDataFlow')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
      <xsl:with-param name="params">{char* outbuf}{int outbuf_len}</xsl:with-param>
    <xsl:with-param name="content">
{
  Data d; d.buff=NULL;

  out.getPayload(&amp;d);
  INFOP infop = out.getHeader();

  if (outbuf_len &lt; INFOP_HEADER_SIZE + d.SIZE) {
    printf(" Warning: Pipe::exportOutDataFlow(): buffer size not large engouth\n");    return -1;
  }

  int size =0 ;
  memcpy(outbuf, &amp;infop, INFOP_HEADER_SIZE);
  size += INFOP_HEADER_SIZE;
  memcpy(outbuf + INFOP_HEADER_SIZE, d.buff, d.SIZE);
  size += d.SIZE;

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return size;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of exportOutDataFlow() -->


//======================================================================================

  <!-- getInCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'getInCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">CtrlFlow&amp;</xsl:with-param>
      <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return inC;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getInCtrlFlow() -->

  <!-- getOutCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'getOutCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">CtrlFlow&amp;</xsl:with-param>
      <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return outC;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getOutCtrlFlow() -->


  <!-- setInCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'setInCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params"><xsl:value-of select="concat('{const ',
    'INFOCP', '&amp; infocp}{const Data&amp; data}')"/></xsl:with-param>
    <xsl:with-param name="content">
{
  inC.setINFOCP(infocp);
  inC.setPayload(data);
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of setInCtrlFlow() -->


  <!-- setOutCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'setOutCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params"><xsl:value-of select="concat('{const ',
    'INFOCP', '&amp; infocp}{const Data&amp; data}')"/></xsl:with-param>
    <xsl:with-param name="content">
{
  outC.setINFOCP(infocp);
  outC.setPayload(data);
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of setOutCtrlFlow() -->

  <!-- inCtrlToOutCtrl() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'inCtrlToOutCtrl')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
      <xsl:with-param name="params">{unsigned int filterFlag}</xsl:with-param>
    <xsl:with-param name="content">
{
  outC = inC;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of inDataToOutData() -->


  <!-- importInCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'importInCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
      <xsl:with-param name="params">{char* inbuf}{int inbuf_len}</xsl:with-param>
    <xsl:with-param name="content">
{
  Data d; d.buff = NULL;
  INFOCP infocp;

  memcpy(&amp;infocp, inbuf, INFOCP_HEADER_SIZE);
  d.SIZE = (inbuf_len - INFOCP_HEADER_SIZE)/sizeof(Type);

  d.buff = new Type[d.SIZE];
  memcpy(d.buff, inbuf + INFOCP_HEADER_SIZE, inbuf_len - INFOCP_HEADER_SIZE);

  setInCtrlFlow(infocp, d);

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of importInDataFlow() -->


  <!-- exportOutCtrlFlow() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', 'exportOutCtrlFlow')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
      <xsl:with-param name="params">{char* outbuf}{int outbuf_len}</xsl:with-param>
    <xsl:with-param name="content">
{
  Data d; d.buff=NULL;

  outC.getPayload(&amp;d);
  INFOCP infocp = outC.getHeader();

  if (outbuf_len &lt; INFOCP_HEADER_SIZE + d.SIZE) {
    printf(" Warning: Pipe::exportOutCtrlFlow(): buffer size not large engouth\n");    return -1;
  }

  int size =0 ;
  memcpy(outbuf, &amp;infocp, INFOCP_HEADER_SIZE);
  size += INFOCP_HEADER_SIZE;
  memcpy(outbuf + INFOCP_HEADER_SIZE, d.buff, d.SIZE);
  size += d.SIZE;

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return size;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of exportOutDataFlow() -->



   </content></file>
</xsl:template>
<!-- ================================= -->
<!--  End of The Pipe_CPP template   -->
<!-- ================================= -->









  
<!-- ================================= -->
<!--      The Pipe_H template        -->
<!-- ================================= -->


<xsl:template name="Pipe_H">
  <xsl:param name="name"/>
  <xsl:param name="filters"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
     <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.h</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.h')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- include ifdef-endif -->

#ifndef _<xsl:value-of select="$name_all_capital"/>_H_
#define _<xsl:value-of select="$name_all_capital"/>_H_

#include &quot;DataFlow.h&quot;

  <xsl:value-of select="$empty_line"/>

  <!-- Pipe class -->
  <!-- =============================== -->
  <!-- The Pipe  class -->
  <!--                                 -->

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat('class', $name)"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->

  <xsl:call-template name="class">
    <xsl:with-param name="name">Pipe</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->

  <xsl:call-template name="method">
    <xsl:with-param name="name">Pipe</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="concat('~','Pipe')"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getInDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">DataFlow&amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getInCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">CtrlFlow&amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getOutDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">DataFlow&amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getOutCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">CtrlFlow&amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  //Just a no-op now.
  virtual int initPipe() = 0;

  <xsl:call-template name="method">
    <xsl:with-param name="name">setInDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{const INFOP&amp; infop}{const Data&amp; data}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">setInCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{const INFOCP&amp; infocp}{const Data&amp; data}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">setOutDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{const INFOP&amp; infop}{const Data&amp; data}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">setOutCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{const INFOCP&amp; infocp}{const Data&amp; data}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">inDataToOutData</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual void</xsl:with-param>
    <xsl:with-param name="params">{unsigned int filterFlag}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">inCtrlToOutCtrl</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual void</xsl:with-param>
    <xsl:with-param name="params">{unsigned int filterFlag}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">exportOutDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
    <xsl:with-param name="params">{char* outbuf}{int outbuf_len}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">exportOutCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
    <xsl:with-param name="params">{char* outbuf}{int outbuf_len}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">importInDataFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
    <xsl:with-param name="params">{char* inbuf}{int inbuf_len}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">importInCtrlFlow</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
    <xsl:with-param name="params">{char* inbuf}{int inbuf_len}</xsl:with-param>
  </xsl:call-template>


  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">in</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">DataFlow</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">out</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">DataFlow</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">inC</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">CtrlFlow</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">outC</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">CtrlFlow</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->

  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="$name"/>


<xsl:text>


</xsl:text>


#endif // _<xsl:value-of select="$name_all_capital"/>_H_



  </content></file>

</xsl:template>











</xsl:stylesheet>
