<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ================================================================= -->
<!-- $Id: Receiver.xsl,v 1.3 2003/06/28 21:31:12 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->

<!-- ================================= -->
<!--      The Receiver_H template      -->
<!-- ================================= -->

<xsl:template name="Receiver_H">
  <xsl:param name="name"/>
  <xsl:param name="classname"/>
  <xsl:param name="filters"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <!-- opening tag for isg post-processing -->
  <file><name>
     <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.h</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.h')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- include ifdef-endif -->
<xsl:text>
#ifndef _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
#define _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
</xsl:text>

  <xsl:value-of select="$empty_line"/>

  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{orbsvcs/AV/Endpoint_Strategy.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">{CtrlManager.h}{Pipe.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- ======================================= -->
  <!-- The Receiver__Callback class -->
  <!--                                         -->

  //&lt;block name="pipe_<xsl:value-of select="$classname"/>">

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'Callback class: AVStreams calls this class when data shows up from a sender.')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'Callback')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_AV_Callback}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'Callback')"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>


  <xsl:call-template name="method">
    <xsl:with-param name="name">receive_frame</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{ACE_Message_Block* frame}{TAO_AV_frame_info* frame_info}{const ACE_Addr &amp;peer_address}</xsl:with-param>
  </xsl:call-template>


  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="concat($name, '_Callback')"/>
<xsl:text>

</xsl:text>


  <!-- ======================================= -->
  <!-- The Receiver_StreamEndPoint class -->
  <!--                                         -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'StreamEndPoint class: Defines a sender stream endpoint.')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'StreamEndPoint')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_Server_StreamEndPoint}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">get_callback</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
  </xsl:call-template>

  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">callback</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ReceiverCallback</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="concat($name, 'StreamEndPoint')"/>
<xsl:text>

</xsl:text>

  <!-- =============================== -->
  <!--  The other global staff: just   -->
  <!--  treat it as plain text         -->
  <!-- =============================== -->
typedef TAO_AV_Endpoint_Reactive_Strategy_B
          &lt;<xsl:value-of select="concat($name, 'StreamEndPoint')"/>,
           TAO_VDev,
           AV_Null_MediaCtrl&gt;
        <xsl:value-of select="$name_all_capital"/>_ENDPOINT_STRATEGY;


  <!-- =============================== -->
  <!-- The Receiver           class -->
  <!--                                 -->
  <xsl:value-of select="$empty_line"/>

  <!-- The comment -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
       <xsl:value-of select="concat($name,' class')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The local include -->
  
  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
    <xsl:with-param name="parents">{public Pipe}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="concat('~', $name)"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">init</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char ** argv}{CORBA::Environment &amp;ACE_TRY_ENV}
    </xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getCtrlManager</xsl:with-param>
    <xsl:with-param name="type">CtrlManager &amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getName</xsl:with-param>
    <xsl:with-param name="type">const char*</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">parseArgs</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}</xsl:with-param>
  </xsl:call-template>


  <xsl:call-template name="method">
    <xsl:with-param name="name">initPipe</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>



  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">ctrlManager</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">CtrlManager</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">receiverEndpointStrategy</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type"><xsl:value-of
    select="concat($name_all_capital, '_ENDPOINT_STRATEGY')"/></xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">receiverMMDevice</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_MMDevice*</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">senderName</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ACE_CString</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name_all_small, 'Name')"/>
    </xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ACE_CString</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text><xsl:value-of select="$name"/><xsl:text>

</xsl:text>

    //&lt;/block>

  <!-- ================================ -->
  <!-- The Singleton typedef for Receiver -->
  <!-- ================================ -->

  <xsl:text>typedef ACE_Singleton&lt;</xsl:text><xsl:value-of
  select="$name"/><xsl:text>, ACE_Null_Mutex&gt; </xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>;
</xsl:text>

  <xsl:value-of select="$empty_line"/>
<xsl:text>
#endif // _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
</xsl:text>



  </content></file>


</xsl:template>

<!--                                   -->
<!--  End of The Receiver_H template -->
<!-- ================================= -->











<!-- ================================= -->
<!--      The Receiver_CPP template -->
<!-- ================================= -->

<xsl:template name="Receiver_CPP">
  <xsl:param name="name"/>
  <xsl:param name="classname"/>
  <xsl:param name="filters"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
     <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.cpp</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.cpp')"/>
    </xsl:with-param>
  </xsl:call-template>

#define NEW_DISPLAYER
  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{ace/Get_Opt.h}{math.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">
      <xsl:value-of select="concat('{',$name,'.h}')"/></xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>

#define DEBUG 0

#include "PPMP.h"
#include "ppmdecoder.h"
class PPMDecoder;

typedef unsigned char pixval;
#define IMAGE_SIZE  921600 /* 3*640*480 */
int MUS = 15360;
int MAXPIXELSIZE = 3;
int MAXLINESIZE = 640;
int PORTNO = 0;

PPM_frame_info pfi;
int curr_frame_nr = 0;

#include "Share_Syn.h"
char* shm, *shm_buf;
int semid;
union semun sunion;
int DeleteSemid = 0;
ACE_Shared_Memory_SV* shm_writer;

int WINDOW_SIZE = 64;
DataFlow df;
INFOP infop;
Data data;
ACE_Time_Value last, now;
int* window_delta_t;
int nr_pkt_received = 0;
int window_nr_pkt_received = 0;
int accum_pkt_size = 0;//in bytes
int window_accum_pkt_size = 0;
int accum_time = 0;//in micro sec
int window_accum_time =0;
int window_proc_time = 0;//recv side playback time accumulated
int accum_qos_time = 0;//qos processing time at the receiver side
int accum_qos_time_sender = 0;//this is the src_id field in the header of the sender msg
int accum_jitter = 0;//in micro sec
int window_accum_jitter = 0;
int accum_missing_pkt = 0;
int window_accum_missing_pkt = 0;
int pktnr_seqnr_diff = 0;//used to find missing packet

unsigned long last_sender;

extern "C" char* dejpgImage = NULL;
Type* global_buf;
int global_buf_length;

unsigned int  FILTER=0;//the filter flag
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1&lt;&lt;(i))
#define FILTER_GET(flag, i) ((flag) &amp; 1&lt;&lt;(i))


  <xsl:call-template name="filters_header_include">
    <xsl:with-param name="used_filters">
      <xsl:value-of select="$filters"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- The Helper class declaration -->
//Helper class
class Signal_Handler : public ACE_Event_Handler
{
public:
  Signal_Handler() : exit_requested(0) { }

  int handle_signal(int signum, siginfo_t*,ucontext_t*) {
    exit_requested = 1;

    if (shm_writer->remove () &lt; 0)
      ACE_ERROR ((LM_ERROR,
                  "%p\n",
                  "remove"));
    return 0;
  }

  int exit_requested;
};

  


  <!-- The implementation of related class method -->
  <!-- get_callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'StreamEndPoint::get_callback')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &amp;this->callback;

  return 0;

}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of get_callback() -->


  <!-- Receiver_Callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'Callback::', $name, 'Callback')"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Receiver_Receiver_Callback() -->

  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'Callback::', 'receive_frame')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{ACE_Message_Block* frame}{TAO_AV_frame_info* frame_info}{const ACE_Addr &amp;peer_address}</xsl:with-param>
    <xsl:with-param name="content">
{
  while (0 != frame) {
    global_buf = (Type*)(frame->rd_ptr());
    global_buf_length = frame->length();

    frame = frame->cont();
  }

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>


  //&lt;block name="pipe_<xsl:value-of select="$classname"/>">

  <!-- Receiver() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="init">
      <xsl:value-of select="concat('{', 'senderName(',
      '&quot;')"/><xsl:value-of
      select="/xip/composedPipe/connections/connection/from/attribute::pipe"/>
<xsl:value-of select="concat( '&quot;', ')', '}{', $name_all_small,
      'Name(', '&quot;')"/><xsl:value-of select="$name"/><xsl:value-of
      select="concat( '&quot;', ')}', '{receiverMMDevice(0)}', '{Pipe()}')"/>    </xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Receiver() -->

  <!-- ~Receiver() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat( $name, '::~', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of ~Receiver() -->
    
  <!-- parseArgs() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::parseArgs')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}</xsl:with-param>
    <xsl:with-param name="content">
{
  if(argc &lt; 1){
    ACE_DEBUG((LM_DEBUG, "Usage:\n\n"));
    ACE_DEBUG((LM_DEBUG, "   Receiver [-M MTU] [-P maxpixel] [-L maxlinesize] [-p portno]\n"));

    return -1;
  }

  ACE_Get_Opt opts (argc, argv, "M:P:L:p:");

  int c;
  while ((c= opts ()) != -1)
    {
      switch (c)
        {
        case 'M':
          MUS = ACE_OS::atoi (opts.optarg);
          break;
        case 'P':
          MAXPIXELSIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'L':
          MAXLINESIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'p':
          PORTNO = ACE_OS::atoi (opts.optarg);
          break;
        default:
          ACE_DEBUG ((LM_DEBUG, "Unknown Option\n"));
        }
    }
  return 0;
}
  </xsl:with-param>
  </xsl:call-template>


  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::initPipe')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="content">
{
  return 0;
}
  </xsl:with-param>
  </xsl:call-template>

  <!-- init() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::init')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}{CORBA::Environment&amp; ACE_TRY_ENV}</xsl:with-param>
    <xsl:with-param name="content">
{
  int result;

  result = receiverEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                         TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = parseArgs (argc, argv);
  if (0!= result) return result;

  if (NULL== (window_delta_t = (int*)malloc(sizeof(int)*WINDOW_SIZE-1)))
    ACE_ERROR_RETURN((LM_ERROR,
                      " Cannot create array\n"),-1);

  for (int i=0;i&lt;WINDOW_SIZE-1;i++)
    window_delta_t[i]=0;

  <xsl:call-template name="filters_necessary_init">
    <xsl:with-param name="used_filters">
      <xsl:value-of select="$filters"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:if test="contains($filters, 'JPEG')">
  if (1) {
    if (NULL==(dejpgImage = (char*)malloc(sizeof(char)*260000)))
      cout&lt;&lt;" mem alloc error\n";
  }
  </xsl:if>

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (receiverMMDevice,
                  TAO_MMDevice (&amp;<xsl:value-of select="$name_all_small"/>EndpointStrategy),
                  -1);

  AVStreams::MMDevice_var mmdevice = receiverMMDevice->_this(ACE_ENV_SINGLE_ARG_PARAMETER);
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToSender (senderName,
                            receiverName,
                            mmdevice.in(),
                            ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToSender (theQos,
                               0,
                               ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of init() -->



  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::getCtrlManager</xsl:with-param>
    <xsl:with-param name="type">CtrlManager &amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{ 
  return ctrlManager;
}
    </xsl:with-param>
  </xsl:call-template>


  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::getName</xsl:with-param>
    <xsl:with-param name="type">const char*</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{ 
  return receiverName.c_str();
}
    </xsl:with-param>
  </xsl:call-template>


    //&lt;/block>

  <!-- main() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">main</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc, char **argv}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;

  ACE_TRY
    {
      CORBA::ORB_var orb = CORBA::ORB_init (argc,
                                            argv,
                                            0,
                                            ACE_TRY_ENV);
      ACE_TRY_CHECK;

      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA"
                                           ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POA_var root_poa
        = PortableServer::POA::_narrow (obj.in ()
                                        ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      mgr->activate (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in ()
                                      ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      // Initialize the Client.
      int result = 0;

      <xsl:value-of select="$name"/>* receiver = <xsl:value-of select="$name_all_capital"/>::instance();

      shm_writer = new ACE_Shared_Memory_SV (SHM_KEY_R, SHMSZ_R,
                  ACE_Shared_Memory_SV::ACE_CREATE);

      shm = (char *) shm_writer->malloc ();
      if (shm == 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                       "%p\n\t(%P|%t) Cannot create shared memory segment.\n"
                           ,argv[0]), -1);
      ACE_DEBUG ((LM_INFO,
                  "(%P|%t) Shared Memory is at 0x%x\n",
                  shm ));

      //Create semaphore
      if (-1==(semid = semget(IPC_PRIVATE, 3, SHM_R|SHM_W))) {
        perror("  semaphore error:\n");
        ACE_ERROR_RETURN((LM_ERROR,
                          "(%P|%t) Cannot create semaphore\n"),-1);

      }
      else
        ACE_DEBUG((LM_DEBUG,
                   "(%P|%t) Create semaphore with id: %d\n", semid));

      DeleteSemid = semid;
      atexit(&amp;mydelete);
      signal(SIGINT, &amp;sigdelete);
      sunion.val = 1;
      safesemctl(semid, SN_WRITE, SETVAL, sunion);
      safesemctl(semid, SN_LOCK, SETVAL, sunion);
      sunion.val = 0;
      safesemctl(semid, SN_READ, SETVAL, sunion);
      //store the semid to shm
      *(int*)shm = semid;
      shm_buf = shm+sizeof(int);

      result = receiver->init (argc,
                               argv,
                               ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result &lt; 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                           "Receiver::main(): init failed\n"), -1);

      Signal_Handler signal_handler;

      data.SIZE=0; data.buff=NULL;
      global_buf = NULL;

      int pkt_seq_nr = 0; int infop_seq_nr = 0; int infop_seq_base = 0;
      bool start_bookkeeping = false;

      bool jpgFrame = false;

      PPMDecoder decoder(MUS, MAXPIXELSIZE, MAXLINESIZE);

      unsigned int last_PPM_frame_num = 0;

      while (!signal_handler.exit_requested) {
        orb->perform_work(ACE_ENV_SINGLE_ARG_PARAMETER);

        if (!global_buf)
          continue;

        now = ACE_OS::gettimeofday();
        nr_pkt_received ++, window_nr_pkt_received++;

        jpgFrame = false;

        <xsl:value-of select="$name_all_capital"/>::instance() ->
          importInDataFlow((char*)global_buf, global_buf_length);

        df = <xsl:value-of select="$name_all_capital"/>::instance() -> getInDataFlow();

        infop = df.getHeader();
/*
        cout&lt;&lt;" infop: size = "&lt;&lt;sizeof(infop)&lt;&lt;endl;
        cout&lt;&lt;" infop: ver("&lt;&lt;infop.ver&lt;&lt;"), pad("&lt;&lt;infop.pad
            &lt;&lt;"), extension("&lt;&lt;infop.extension&lt;&lt;"), marker("&lt;&lt;infop.marker
            &lt;&lt;"), type("&lt;&lt;infop.type&lt;&lt;"), seq("&lt;&lt;infop.seq
            &lt;&lt;"), time("&lt;&lt;infop.time&lt;&lt;"), length("&lt;&lt;infop.length
            &lt;&lt;"), src_id("&lt;&lt;infop.src_id&lt;&lt;")"&lt;&lt;endl;
*/
        {///////////////////////////////////////////////////////////////////
          /////
          if (infop_seq_nr - infop.seq > 32768) infop_seq_base += 65536;
          pkt_seq_nr = infop_seq_base + infop.seq;
          infop_seq_nr = infop.seq;

          if (pkt_seq_nr - nr_pkt_received != pktnr_seqnr_diff) {
            if (pkt_seq_nr - nr_pkt_received &lt; pktnr_seqnr_diff) {
             cout&lt;&lt;" packet seq # out of order panic !!!!!!!!!!!"&lt;&lt;endl;
            }
            else {
              accum_missing_pkt += pkt_seq_nr - nr_pkt_received -
        	    pktnr_seqnr_diff;     
	      window_accum_missing_pkt += pkt_seq_nr - nr_pkt_received - pktnr_seqnr_diff;
              pktnr_seqnr_diff = pkt_seq_nr - nr_pkt_received;
            }
          }
          if (1 >= nr_pkt_received ) {
            //no-op
          }
          else {
            int tmp_time = (now.sec() - last.sec())* 1000000 + (now.usec() - last.usec());
            if (tmp_time&lt;0) tmp_time = -tmp_time;
            accum_time += tmp_time;

            if (1 &lt; window_nr_pkt_received) {
              window_accum_time += tmp_time;
              window_delta_t[window_nr_pkt_received -2] = tmp_time;
            }
          }

          last = now;

          if (!start_bookkeeping) {
            pktnr_seqnr_diff = infop.seq - nr_pkt_received;
            start_bookkeeping = true;
            cout&lt;&lt;" init pktnr_seqnr_diff: "&lt;&lt;pktnr_seqnr_diff&lt;&lt;endl;
          }

          accum_pkt_size += infop.length, window_accum_pkt_size += infop.length;

          if (window_nr_pkt_received >= WINDOW_SIZE )
            {
              //Calculating the Recv Side jitter first.
              double sum = 0; double mean = 0;
              for (int i=0;i&lt;window_nr_pkt_received-1;i++)
                sum += window_delta_t[i];

              mean = (double)sum / (window_nr_pkt_received-1);
              sum = 0;
              for (int i=0;i&lt;window_nr_pkt_received-1;i++)
                sum += (window_delta_t[i] - mean)*(window_delta_t[i] - mean);

              window_accum_jitter = sqrt(sum/(window_nr_pkt_received-2));
            }

          last_sender = infop.time;
          ////
        }/////////////////////////////////////////////////////////////////


        unsigned int filterFlag = 0;
        filterFlag |= infop.type;
        if (filterFlag != 0)
          filterFlag |= 0x80000000; //Means it's decoding instead of encoding or ...

        <xsl:value-of select="$name_all_capital"/>::instance() -> inDataToOutData (filterFlag);

        df = RECEIVER::instance() -> getOutDataFlow();
        df.getPayload(&amp;data);

  <xsl:if test="contains($filters, 'JPEG')">
        //if jpeg.
        //Assume the whole frame has been compressed into the come-in jpeg.
        if (FILTER_GET(filterFlag, JPEG1)) {
          int ret0 = init_jpeg_decompress();
          if (ret0 &lt; 0)
            cout&lt;&lt;" Jpeg init error\n", exit(-1);

          if (infop.marker == 0xF) {
            //it's a PPM_info struct, doesn't need to be dejpeg'ed.
            //skip the first 4 bytes
            char* buf = data.buff + PPMP_FRAME_NO_OFFSET;
            //retrieve the new frame #
            memcpy(&amp;curr_frame_nr, buf, sizeof(unsigned long));
            //Now the struct PPM_frame_info
            buf += sizeof(unsigned long);
            memcpy(&amp;pfi, buf, sizeof(PPM_frame_info));

            if (DEBUG) printf(" [Receiver::main() 1: curr_frame_nr=%d, pfi: tag=%d,ppm1=%c,ppm2=%c,size=%d,width=%d,height=%d,*buff=%x\n",curr_frame_nr,pfi.tag,pfi.ppm1,pfi.ppm2,pfi.size,pfi.width,pfi.height,pfi.buff);

            decoder.decode_jpg (data.buff, data.SIZE);
          }
          else if (infop.marker == 0) {
            //Be careful there're 8 bytes header in front of each jpg'ed frame.
            //char header[PPMP_FRAME_INFO_OFFSET];
            char* tmp_buf = NULL;
	    if (pfi.size > IMAGE_SIZE || pfi.size &lt; 1) {
            }
	    else {
              if (!(tmp_buf = (char*)malloc((pfi.size + PPMP_FRAME_INFO_OFFSET)
                                          * sizeof(char)))) {
                printf(" [Receiver::main(): 0ut of mem\n");
                exit(-1);
              }
              int ret = jpeg_to_ppm (data.buff + PPMP_FRAME_INFO_OFFSET,
                                   data.SIZE - PPMP_FRAME_INFO_OFFSET,
                                   pfi.height,//infop.src_id,
                                   pfi.width,
                                   255,
                                   dejpgImage);

              if (0>ret) cout&lt;&lt;" Jpeg decompression error"&lt;&lt;endl;

              memcpy (tmp_buf, data.buff, PPMP_FRAME_INFO_OFFSET);
              memcpy (tmp_buf+PPMP_FRAME_INFO_OFFSET, dejpgImage, pfi.size);
              decoder.decode_jpg (tmp_buf, pfi.size + PPMP_FRAME_INFO_OFFSET);
              if (tmp_buf) free(tmp_buf);
            }
          }/* if (infop.marker) */

          jpgFrame = true;
          int r1 = end_jpeg_decompress();
          if (r1 &lt; 0) cout&lt;&lt;" end_jpeg_decompress() error\n";

        } /* IF JPEG1 */
  </xsl:if>

        if (!jpgFrame) {

          decoder.decode_ppm (data.buff, data.SIZE);

        }

        if (DEBUG)
          ACE_DEBUG((LM_DEBUG," [Receiver::main(): nr_packet_rec: %d\n", nr_pkt_received));


        if (window_nr_pkt_received >= WINDOW_SIZE ) {
          *(unsigned int*)shm_buf = 0x2;
          *(float*)(shm_buf + 4) = (float)((double)window_accum_pkt_size*8/window_accum_time
                                             *1.0485);
          *(int*)(shm_buf + 8) = (int)window_accum_jitter;
          *(int*)(shm_buf + 12) = (int)((double)window_nr_pkt_received*1000000/window_accum_time);
          *(float*)(shm_buf + 16) = (float)
                                   ((double)window_accum_missing_pkt/window_nr_pkt_received);
          *(int*)(shm_buf + 20) = pkt_seq_nr;
	  *(float*)(shm_buf + 24) = (decoder.getCurrPPMFrameNum() - last_PPM_frame_num)
	                            *1e6/window_accum_time;	

	  last_PPM_frame_num = decoder.getCurrPPMFrameNum();

          if (DEBUG) {
            ACE_DEBUG((LM_DEBUG,
                       "(%P|%t) main(): wwwwwwwwwwwwwwwwwww %dth packet last!\n\n",                       nr_pkt_received));
          }
        }

        //Prepare for the next window if necessary
        if (window_nr_pkt_received >= WINDOW_SIZE) {
          window_accum_pkt_size = 0, window_nr_pkt_received = 0,
            window_accum_time = 0, window_accum_jitter = 0;
          window_accum_missing_pkt = 0;
          window_proc_time = 0;
          for (int i=0;i&lt;WINDOW_SIZE-1;i++)
            window_delta_t[i]=0;
        }

        if (DEBUG) {
        cout&lt;&lt;" infop: size = "&lt;&lt;sizeof(infop)&lt;&lt;endl;
        cout&lt;&lt;" infop: ver("&lt;&lt;infop.ver&lt;&lt;"), pad("&lt;&lt;infop.pad
            &lt;&lt;"), extension("&lt;&lt;infop.extension&lt;&lt;"), marker("&lt;&lt;infop.marker
            &lt;&lt;"), type("&lt;&lt;infop.type&lt;&lt;"), seq("&lt;&lt;infop.seq
            &lt;&lt;"), time("&lt;&lt;infop.time&lt;&lt;"), length("&lt;&lt;infop.length
            &lt;&lt;"), src_id("&lt;&lt;infop.src_id&lt;&lt;")"&lt;&lt;endl;
        cout&lt;&lt;" data: ["&lt;&lt;data.buff[0]&lt;&lt;":"&lt;&lt;data.buff[1]&lt;&lt;":"
            &lt;&lt;data.buff[2]&lt;&lt;":"&lt;&lt;data.buff[3]&lt;&lt;
          "]"&lt;&lt;", size: "&lt;&lt;data.SIZE&lt;&lt;endl;
        cout&lt;&lt;"=============================================="&lt;&lt;endl;
        }

      }

      //////////////////////////////////////////////////////////////////////
      // If the ctrl-C is pressed, then update the shm for the last ctrl msg
      {
        *(unsigned int*)shm_buf = 0x4;
        *(float*)(shm_buf + 4) = (float)((double)accum_pkt_size*8/accum_time*1.0485);
        *(int*)(shm_buf + 8) = (int)((double)nr_pkt_received*1000000/accum_time);
        *(float*)(shm_buf + 12) = (float)((double)accum_missing_pkt/nr_pkt_received);
        if (DEBUG) {
          ACE_DEBUG((LM_DEBUG,"(%P|%t) main(): FFFFFFFFFFFFFFFFFFFFF %dth packet returned!\n\n",
                     nr_pkt_received));
        }
      }

      if (window_delta_t) free(window_delta_t);
      //
      //////////////////////////////////////////////////////////////////////

      ACE_OS::sleep(3);
      <xsl:value-of select="$name_all_capital"/>::instance ()->getCtrlManager().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;

      ACE_OS::sleep (1);

      if (shm_writer->remove () &lt; 0)
        ACE_ERROR ((LM_ERROR,
                    "%p\n",
                    "remove"));

      orb->destroy (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"Receiver::main(): Exception !\n");
      if (shm_writer->remove () &lt; 0)
        ACE_ERROR ((LM_ERROR,
                    "%p\n",
                    "remove"));
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- end of main() -->

  <!-- The ending declaration -->
#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy_B&lt;<xsl:value-of select="$name"/>StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_B&lt;<xsl:value-of select="$name"/>StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */


    </content></file> 

</xsl:template>


<!-- ================================= -->
<!--  End of The Receiver_CPP template   -->
<!-- ================================= -->


  



</xsl:stylesheet>
