<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ================================================================= -->
<!-- $Id: Sender.xsl,v 1.3 2003/06/28 21:31:12 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->

<!-- ================================= -->
<!--      The Sender_CPP template      -->
<!-- ================================= -->

<xsl:template name="Sender_CPP">
  <xsl:param name="name"/>
  <xsl:param name="classname"/>
  <xsl:param name="filters"/>
  
  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
    <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.cpp</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.cpp')"/>
    </xsl:with-param>
  </xsl:call-template>


  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{ace/Get_Opt.h}{ace/OS.h}</xsl:with-param>
  </xsl:call-template>

#define DEBUG 0

int AV_MAX_BUFSIZ = 16*1024;

int SOURCE_ID =0;


#include &quot;Share_Syn.h&quot;
char* shm, *shm_buf;
int semid;
union semun sunion;
int DeleteSemid = 0;
ACE_Shared_Memory_SV* shm_reader;
ACE_Time_Value now;

unsigned int  FILTER=0;
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1&lt;&lt;(i))
#define FILTER_GET(flag, i) ((flag) &amp; 1&lt;&lt;(i))

int accum_qos_time = 0;

#include &quot;PPMP.h&quot;
#include &quot;ppmudpreader.h&quot;
class PPM_UDP_Reader;

#define MIN_PKT_RATE 1
#define ZERO_ERR .0001
int last_pkt_rate = 10;
float last_missing_pkt_rate = 0;
int INTERVAL; 
int PKT_RATE = 1;

#include &quot;vdev.h&quot;
VDev_T vdev = NULL;
struct VDev_imageSize imageSize;

typedef unsigned char pixval;
int NUM_OF_FRAMES = 0; /* 0 is forever */
#define IMAGE_SIZE  921600 /* 3*640*480, actually ONLY 230400 is used*/
int MUS = 15360;
int MAXPIXELSIZE = 3;
int MAXLINESIZE = 640;
bool NO_CAM = false; /* PPM from file instead of live camera */
char img_0_file[] = "img0.ppm"; char img_1_file[] = "img1.ppm";
int img_0, img_1;
char* img_0_buf = NULL;
char* img_1_buf = NULL;


PPM_frame_info pfi_big, pfi_small, pfi;

/*************** ADAPTATION INFORMATION *******************/
FILE* profile = NULL;

typedef struct adapt_table_t {
        // Avg. Size Reduction factor
        float comp_ratio;

        // reduction in size ?
        // 0 => No reduction
        // 1 => Halve image
        short reqScale;

        // make it a gray scale image?
        // 0 =>  color
        // 1 => grayscale
        short reqGrayscale;

        // Lossless Data Compression
        // 0 => No compression
        // 5, GZIP => GZIP
        // 6, LZO => LZO Compression
        short reqCompress;
       // Lossy Image compression
        // 0 => No compression
        // 7. JPG => JPG Compression
        short reqLossy;
}adaptation_table;

#define A_LEVELS 7
adaptation_table aTable[A_LEVELS] =
                {
                        {0.50, 0, 0, 1, 0}, // GZIP
                        {0.33, 0, 1, 0 , 0}, // GrayScale
                        {0.25, 1, 0, 0 , 0}, // Scale down to 1/2
                        {0.17, 0, 1, 1, 0}, // GZIP + Grayscale
                        {0.13, 1, 0, 1, 0}, // GZIP + Scaling
                        {0.08, 1, 1, 0 , 0}, // Grayscale + Scaling
                        {0.05, 0, 0, 0 , JPEG1}, // JPG
                };

float getEquivFps (unsigned int filterFlag, float pkt_rate)
{
  float fps = pkt_rate;
  static int num_times_table[] = {
    16, //320x240 no filters, 16 pkts / ppm_frame
    5, //Shrink 
    6, //Grey
    2 //Jpeg
  };
  //order is important
  if (!FILTER_GET(filterFlag, SHRINK) &amp;&amp; 
      !FILTER_GET(filterFlag, GREY) &amp;&amp;
      !FILTER_GET(filterFlag, JPEG1) ) 
    fps = pkt_rate/num_times_table[0];
  else {
    if (FILTER_GET(filterFlag, GREY))
      fps = pkt_rate/num_times_table[2];
    if (FILTER_GET(filterFlag, SHRINK)) 
      fps = pkt_rate/num_times_table[1];
    if (FILTER_GET(filterFlag, JPEG1)) 
      fps = pkt_rate/num_times_table[3];
  }

  return fps>.1? fps:.1;
}

/************** Adaptable Values from Client **************/
short ifScale, ifGrayscale, ifCompress, ifLossy, ifEncode;

/************** Local Adaptation Information **************/
short haveLZO, haveGZIP, haveLossy, haveEncode, haveGrayscale, haveScale;
#define haveCompress (((haveLZO | haveGZIP)==0)?0:1)


  //&lt;block name="pipe_<xsl:value-of select="$classname"/>">

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">
      <xsl:value-of select="concat('{',$name,'.h}')"/></xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="filters_header_include">
    <xsl:with-param name="used_filters">
      <xsl:value-of select="$filters"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>


  <!-- The implementation of related class method -->
  <!-- get_callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'StreamEndPoint::get_callback')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &amp;this->callback;

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of get_callback() -->

  <!-- set_protocol_object() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'StreamEndPoint::set_protocol_object')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Protocol_Object *object}</xsl:with-param>
    <xsl:with-param name="content">
{
  CtrlManager &amp;ctrlManager =
    <xsl:value-of select="$name_all_capital"/>::instance ()->getCtrlManager ();

  ctrlManager.getProtocolObjects().bind (flowname, object);

  ctrlManager.addToStreamCtrlsMap (flowname, this);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of set_protocol_0bject -->  

  <!-- handle_preconnect() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, 'StreamEndPoint::handle_preconnect')"/></xsl:with-param>
    <xsl:with-param name="type">CORBA::Boolean</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::flowSpec &amp;flow_spec}</xsl:with-param>
    <xsl:with-param name="content">
{
  for (unsigned int i = 0; i&lt;flow_spec.length(); i++) {
    TAO_Forward_FlowSpec_Entry entry;
    entry.parse (flow_spec[i].in());

    ACE_CString flowname (entry.flowname());

    CtrlManager&amp; ctrlManager = <xsl:value-of select="$name_all_capital"/>::instance()->getCtrlManager();

    int result = ctrlManager.getProtocolObjects().find(flowname);

    if (0==result) {
      ACE_DEBUG ((LM_DEBUG, &quot; <xsl:value-of select="$name"/> changes receivers\n&quot;));
      ctrlManager.destroy(flowname);
    }
  }

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of handle_preconnect -->


  <!-- ~Sender() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::~', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of ~Sender() -->

  <!-- Sender() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="init">
      <xsl:value-of select="concat('{', $name_all_small, 'MMDevice(0)}{', $name_all_small,
      'Name(', '&quot;')"/><xsl:value-of
      select="$name"/><xsl:value-of select="concat( '&quot;', ')}')"/>      
    </xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Sender() -->


  <!-- initPipe() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::initPipe')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="content">
{
  if (!NO_CAM) {
    VDev_init (320, 240);
    if (VDev_numVDevices()&lt;1) cout&lt;&lt;" No camera found !\n";

    vdev = VDev_getVDevice(0);
    if (vdev == NULL || !VDev_isValid(vdev))
      cout&lt;&lt;"Something is wrong\n";

    cout&lt;&lt;"V4L name: "&lt;&lt;VDev_getIntfName(vdev)&lt;&lt;"\n";

    VDev_open(vdev, 2);
    if (VDev_getDescriptor(vdev) &lt; 0)
      cout&lt;&lt;"Something is wrong, what camera are you asking for?\n";

    VDev_getSize(vdev, &amp;imageSize);
    cout&lt;&lt;" imageSize (width, heigth): "&lt;&lt;imageSize.width&lt;&lt;", "&lt;&lt;imageSize.height&lt;&lt;"\n";
  }
  else {
    if (0 > (img_0 = open(img_0_file, O_RDONLY)))
      cout&lt;&lt;" Can't find PPM source file\n", exit(-1);
    if ( NULL == (img_0_buf = (char*)malloc(320*240*3*sizeof(char))))
        cout&lt;&lt;" Can't allocate mem for PPM\n", exit(-1);
    read(img_0, img_0_buf, 16);
    read(img_0, img_0_buf, 320*240*3);

    if (0 > (img_1 = open(img_1_file, O_RDONLY)))
      cout&lt;&lt;" Can't find PPM source file\n", exit(-1);
    if ( NULL == (img_1_buf = (char*)malloc(320*240*3*sizeof(char))))
        cout&lt;&lt;" Can't allocate mem for PPM\n", exit(-1);
    read(img_1, img_1_buf, 16);
    read(img_1, img_1_buf, 320*240*3);
  }

  <xsl:call-template name="filters_necessary_init">
    <xsl:with-param name="used_filters">
      <xsl:value-of select="$filters"/>
    </xsl:with-param>
  </xsl:call-template>

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>



  <!-- init() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::init')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}{CORBA::Environment&amp; ACE_TRY_ENV}</xsl:with-param>
    <xsl:with-param name="content">
{
  int result;

  result = parseArgs (argc, argv);
  if (0!= result) return result;

  result = initPipe();

  shm_reader = new ACE_Shared_Memory_SV(SHM_KEY_S, SHMSZ_S);
  shm = (char *) shm_reader->malloc ();
  if (shm == 0)
    ACE_ERROR_RETURN ((LM_ERROR,
                       "%p\n\t(%P|%t) Cannot get shared memory segment.\n"
                       ,argv[0]), -1);
  ACE_DEBUG ((LM_INFO,
              "(%P|%t) Shared Memory is at 0x%x\n",
              shm ));
  //Get semaphore
  semid = *(int *)shm;
  shm_buf = shm + sizeof(unsigned int);
  ACE_DEBUG((LM_INFO," semid is %d\n", semid));

  if (NULL==(profile = fopen("./frontEnd/src/PROFILE", "r"))) {
    cout&lt;&lt;" File open error\n";
    exit(-1);
  }
  else
    cout&lt;&lt;" File ./frontEnd/src/PROFILE open sucessfully\n";

  char filter_profile[40];
  fscanf(profile, "%s", filter_profile);
  if (!strcmp(filter_profile, "resolution_profile")) {
    haveGZIP = haveLossy = haveEncode = 1;
    haveGrayscale = haveScale = 0;
  }
  else if (!strcmp(filter_profile, "fps_profile")) {
    haveGZIP = haveGrayscale = haveScale = haveLossy = haveEncode = 1;
  }
  else {
    cout&lt;&lt;" No filter profile found !!!!!!!\n";
  }

  cout&lt;&lt;" profile: "&lt;&lt;filter_profile&lt;&lt;endl;
  cout&lt;&lt;" haveScale("&lt;&lt;haveScale&lt;&lt;"), haveGrayscale("&lt;&lt;haveGrayscale&lt;&lt;"), haveLossy("      &lt;&lt;haveLossy&lt;&lt;"), haveCompress("&lt;&lt;haveCompress&lt;&lt;"), haveEncode("&lt;&lt;haveEncode&lt;&lt;")"
      &lt;&lt;endl;
  for (int i = 0;i&lt;A_LEVELS; i++)
    cout&lt;&lt;" Compress_ration[]: "&lt;&lt;aTable[i].comp_ratio&lt;&lt;endl;



  result = senderEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                       TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (<xsl:value-of select="$name_all_small"/>MMDevice,
                  TAO_MMDevice (&amp;<xsl:value-of select="$name_all_small"/>EndpointStrategy),
                  -1);

  PortableServer::ServantBase_var safeMMDevice = <xsl:value-of select="$name_all_small"/>MMDevice;

  AVStreams::MMDevice_var mmdevice = <xsl:value-of select="$name_all_small"/>MMDevice->_this(ACE_ENV_SINGLE_ARG_PARAMETER);
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToReceivers(<xsl:value-of select="$name_all_small"/>Name,
                              "<xsl:value-of select="/xip/composedPipe/connections/connection/to/attribute::pipe"/>",
                              mmdevice.in(),
                              ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToReceivers (mmdevice.in(),
                                  theQos,
                                  0,
                                  ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of init() -->


  <!-- parseArgs() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::parseArgs')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}</xsl:with-param>
    <xsl:with-param name="content">
{
  if(argc &lt; 1+2){
    ACE_DEBUG((LM_DEBUG, "Usage:\n\n"));
    ACE_DEBUG((LM_DEBUG, "   Sender &lt;-n numOfFrames> [-f] [-s src_id] [-i interval] [-M MTU] [-P maxpixel] [-L maxlinesize]\n"));
    return -1;
  }

  INTERVAL = 500; //in milli-sec

  // Parse command line arguments
  ACE_Get_Opt opts (argc, argv, "n:i::M::P::L::s::f");

  int c;
  while ((c= opts ()) != -1)
    {
      switch (c)
        {
        case 'n':
          NUM_OF_FRAMES = ACE_OS::atoi (opts.optarg);
          break;
        case 'M':
          MUS = ACE_OS::atoi (opts.optarg);
          break;
        case 'P':
          MAXPIXELSIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'L':
          MAXLINESIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'i':
          INTERVAL = ACE_OS::atoi (opts.optarg);
          break;
        case 's':
          SOURCE_ID = ACE_OS::atoi (opts.optarg);
          break;
	case 'f':
          NO_CAM = true;
          break;
        default:
          ACE_DEBUG ((LM_DEBUG, "Unknown Option\n"));
          return -1;
        }
    }

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of parseArgs() -->

  <!-- getName()-->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::getName</xsl:with-param>
    <xsl:with-param name="type">const char*</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
   return <xsl:value-of select="$name_all_small"/>Name.c_str();
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getName() -->

  <!-- getCtrlManager() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::getCtrlManager</xsl:with-param>
    <xsl:with-param name="type">CtrlManager&amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return ctrlManager;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of getCtrlManager() -->


  <!-- sendData() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::sendData</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  char* img_buf;
  unsigned int sem_flag = 0;
  int sleep_time = (int)(1000000/PKT_RATE);

  bool windowUpdate = false;

  if (!(img_buf = (char*)malloc(IMAGE_SIZE*sizeof(char))))
  {
    printf(" [Sender::sendData(): 0ut of mem\n");
    exit(-1);
  }

  ACE_TRY
    {
      int j;
      int readresult;
      int sendresult;
      ACE_Time_Value start, now;

      //Dynamic adaptation
      float curr_compress_ratio = 1.0;
      float target_compress_ratio = 1.0;
      int last_PKT_RATE = 1;
      unsigned int last_sem_flag;

      PPM_UDP_Reader reader(MUS, MAXPIXELSIZE, MAXLINESIZE);

      char filter_str[9];
      for (int i = 0; NUM_OF_FRAMES==0 || i &lt; NUM_OF_FRAMES; i++) {

        start = ACE_OS::gettimeofday();

        //Now the flowCtrl bit in sem_flag is used to indicate it's dynamic fps control adapation.
        sem_flag = *(unsigned int*)shm_buf;

        FILTER &amp;= 0;

        if ( (sem_flag &amp; 0x80000000)  &amp;&amp;
             ((sem_flag &amp; 0xFF)!= 99) ) {
	  if (DEBUG) {
            ACE_DEBUG((LM_DEBUG," Sender::sendData(): flag in shm indicates flowCtrl applied\n"));
            printf(" sem_flag(%x)\n", sem_flag);
          }
          //Flow Control applied
          int curr_pkt_rate = *(int*)(shm_buf + 3*sizeof(unsigned int));
          int last_pkt_seq = *(int*)(shm_buf + 4*sizeof(unsigned int));
          float missing_pkt_rate = *(float*)(shm_buf +
                                             5*sizeof(unsigned int));

          PKT_RATE = *(int*)(shm_buf + 5*sizeof(unsigned int) + sizeof(float));

          if (PKT_RATE &lt; MIN_PKT_RATE) PKT_RATE=MIN_PKT_RATE;
          //If feedback changed from the last one as according to the
          //information passed from SenderMonitorServer
          if ( (curr_pkt_rate != last_pkt_rate) ||
               (PKT_RATE != last_PKT_RATE) ||
	       (last_sem_flag != sem_flag) ||
               (missing_pkt_rate - last_missing_pkt_rate > ZERO_ERR) ||
               (missing_pkt_rate - last_missing_pkt_rate &lt; -ZERO_ERR) )
            {
	      float equiv_curr_fps, equiv_target_fps;
              windowUpdate = true;

              if (FILTER_GET(sem_flag, GZIP) || FILTER_GET(sem_flag, LZO))
                ifCompress = 1 &amp; haveCompress;
              else
                ifCompress = 0;
              if (FILTER_GET(sem_flag, SHRINK)) ifScale = 1 &amp; haveScale;
              else ifScale = 0;
              if (FILTER_GET(sem_flag, JPEG1)) ifLossy = 1 &amp; haveLossy;
              else ifLossy = 0;
              if (FILTER_GET(sem_flag, ENCRYPT)) ifEncode = 1 &amp; haveEncode;
              else ifEncode = 0;
              if (FILTER_GET(sem_flag, GREY)) ifGrayscale = 1 &amp; haveGrayscale;
              else ifGrayscale = 0;

	      equiv_curr_fps = getEquivFps(last_sem_flag, last_pkt_rate);
	      equiv_target_fps = getEquivFps(sem_flag, PKT_RATE);

	      target_compress_ratio = equiv_curr_fps * curr_compress_ratio / equiv_target_fps;

              last_missing_pkt_rate = missing_pkt_rate;
              last_PKT_RATE = PKT_RATE;
	      last_sem_flag = sem_flag;
	      last_pkt_rate = curr_pkt_rate;

              if (DEBUG) {
                printf(" compress_ratio: %10.3f ==> %10.3f\n",curr_compress_ratio,target_compress_ratio);
                printf("       pkt_rate: %d ==> %d\n", last_pkt_rate, PKT_RATE);
	        printf("            fps: %f ==> %f\n", equiv_curr_fps, equiv_target_fps);
              }
            } //if ( (curr_pkt_rate != last_pkt_rate) ||...


          // Disable all Compression
          if(target_compress_ratio > 0.90)
            {
              FILTER = 0;
              curr_compress_ratio = 1.0;
            }
         else {
            int k=0;
            int last_match = -1;

            for(k=0;k&lt;A_LEVELS;k++)
              {
                if((aTable[k].reqScale != 0) &amp;&amp; (ifScale == 0))
                  continue;

                if((aTable[k].reqGrayscale != 0) &amp;&amp; (ifGrayscale == 0))
                  continue;

                if((aTable[k].reqCompress != 0) &amp;&amp; ((ifCompress) == 0))
                  continue;

                if((aTable[k].reqLossy != 0) &amp;&amp; (ifLossy == 0))
                  continue;

                // A matching filter has been found.
                last_match = k;
                if(target_compress_ratio >= aTable[k].comp_ratio)
                  {
                    if (aTable[k].reqCompress) SET_FILTER(GZIP);
                    if (aTable[k].reqLossy) SET_FILTER(JPEG1);

                    if(aTable[last_match].reqScale)
                      SET_FILTER(SHRINK);
                    if(aTable[last_match].reqGrayscale)
                      SET_FILTER(GREY);

                    curr_compress_ratio = aTable[k].comp_ratio;
                    break;
                  }
              }

            // Cannot Satisfy Requirements for current compression ratio
            //
            // So we choose the last possible match
            // if last_match = -1 then we disable all compression
            if(k== A_LEVELS)
              {
                if(last_match == -1)
                  {
                    FILTER = 0;
                    curr_compress_ratio = 1;
                  }
                else
                  {
                    if (aTable[last_match].reqCompress) {
                      SET_FILTER(GZIP);
                      }
                    if (aTable[last_match].reqLossy) {
                      SET_FILTER(JPEG1);
                    }
                    if(aTable[last_match].reqScale) {
                      SET_FILTER(SHRINK);
                    }
                    if(aTable[last_match].reqGrayscale) {
                      SET_FILTER(GREY);
                    }
                    curr_compress_ratio = aTable[last_match].comp_ratio;
                  }
              }
          }// if(target_compress_ratio > .90)

          //Enable Encryption
          if(ifEncode != 0)
            {
              SET_FILTER(ENCRYPT);
            }else{
              //no op because every time FILTER starts from 0 -- default to noencrypt first;
            }

          sleep_time = 1e6/ PKT_RATE;

          if (DEBUG) {
            cout&lt;&lt;" ifScale("&lt;&lt;ifScale&lt;&lt;"), ifGrayscale("&lt;&lt;ifGrayscale&lt;&lt;"), ifLossy("&lt;&lt;ifLossy
                &lt;&lt;"), ifCompress("&lt;&lt;ifCompress&lt;&lt;"), ifEncode("&lt;&lt;ifEncode&lt;&lt;")"&lt;&lt;endl;
            cout&lt;&lt;" haveScale("&lt;&lt;haveScale&lt;&lt;"), haveGrayscale("&lt;&lt;haveGrayscale&lt;&lt;"), haveLossy("
                &lt;&lt;haveLossy&lt;&lt;"), haveCompress("&lt;&lt;haveCompress&lt;&lt;"), haveEncode("&lt;&lt;haveEncode&lt;&lt;")"
                &lt;&lt;endl;
            cout&lt;&lt;" compress_ratio: "&lt;&lt;curr_compress_ratio&lt;&lt;endl;
            cout&lt;&lt;" last_pkt_rate: "
                &lt;&lt;last_pkt_rate
                &lt;&lt;", missing_pkt_rate: "&lt;&lt;last_missing_pkt_rate
                &lt;&lt;", sleep:"&lt;&lt;sleep_time&lt;&lt;endl;
          }

          //Visualize filter
          if (FILTER &amp; 1) filter_str[7] = 'X'; else filter_str[7]='o';
          if (FILTER &amp; 2) filter_str[6] = 'X'; else filter_str[6]='o';
          if (FILTER &amp; 4) filter_str[5] = 'X'; else filter_str[5]='o';
          if (FILTER &amp; 8) filter_str[4] = 'X'; else filter_str[4]='o';
          if (FILTER &amp; 16) filter_str[3] = 'X'; else filter_str[3]='o';
          if (FILTER &amp; 32) filter_str[2] = 'X'; else filter_str[2]='o';
          if (FILTER &amp; 64) filter_str[1] = 'X'; else filter_str[1]='o';
          if (FILTER &amp; 128) filter_str[0] = 'X'; else filter_str[0]='o';
          filter_str[8]='\0';
	  printf(" [%s]%d\n", filter_str,i);
        } //if (sem_flag == 1)
        else if ( sem_flag == 99)  {
          //Sender shall stop
          break;
        }

        pfi.tag = i;
        pfi.ppm1 = 'P';
        pfi.ppm2 = '6';
        if (!NO_CAM) {
          pfi.buff = (char*) VDev_getPPMImage(vdev, 6);
          pfi.size = VDev_getRawSize(vdev);
          pfi.width = imageSize.width;
          pfi.height = imageSize.height;
        }
        else {
          pfi.width = 320;
          pfi.height = 240;
          pfi.size = 320*240*3;
        }

        FILTER &amp;= 0xFF;

        j = 0;

        reader.setPPMFrameInfo (MUS, pfi);
        readresult = pfi.size;
	if (!NO_CAM) {
          sendresult = reader.send_whole_frame(pfi.buff, readresult, i, SOURCE_ID, FILTER);
          if (pfi.buff) free(pfi.buff), pfi.buff = NULL;
        }
         else
          i%2==0?sendresult=reader.send_whole_frame(img_0_buf,readresult,i,SOURCE_ID,FILTER):
            sendresult=reader.send_whole_frame(img_1_buf,readresult,i,SOURCE_ID,FILTER);

        if (sendresult &lt; 0) {
          printf(" [Sender::sendData(): this frame is NOT sent \n");
          exit(-1);
        }

        j += sendresult;

        if (sleep_time > 0 )
          {
            now = ACE_OS::gettimeofday();
            double more_sleep =  sleep_time -
              (now.sec() - start.sec())*1000000
              - now.usec() + start.usec();
            double sleep_st = now.sec() *1000000 + now.usec();
            double sleep_diff = 0;
            if (more_sleep > 10000000) ACE_DEBUG((LM_DEBUG,
                                                  "> 10 sec sleep time !!\n"));
            while (more_sleep > sleep_diff)
              {
                now = ACE_OS::gettimeofday();
                sleep_diff = now.sec()* 1000000 + now.usec()
                  - sleep_st;
              }
          }
      }/* for (int i = 0; NUM_OF_FRAMES==0 || i &lt; NUM_OF_FRAMES; i++) */
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                           " sendData(): exception\n");
      return -1;
    }
  ACE_ENDTRY;

  if (img_buf) free(img_buf);
  if (NO_CAM)
    close(img_0), close(img_1);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of sendData() -->

  //&lt;/block>

  <!-- The main() -->   
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">main</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc, char **argv}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;

  ACE_TRY
    {
      CORBA::ORB_var orb = CORBA::ORB_init (argc,
                                            argv,
                                            0,
                                            ACE_TRY_ENV);
      ACE_TRY_CHECK;

      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA" 
	                                   ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POA_var root_poa
        = PortableServer::POA::_narrow (obj.in ()
                                        ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      mgr->activate (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in ()
                                      ACE_ENV_ARG_PARAMETER);	
      ACE_TRY_CHECK;

      // Initialize the Client.
      int result = 0;
      result = <xsl:value-of select="$name_all_capital"/>::instance ()->init (argc,
                                          argv,
                                          ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result &lt; 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                           "main(): init failed\n"), -1);

      ACE_OS::sleep(2);

      <xsl:value-of select="$name_all_capital"/>::instance ()->sendData ();
      ACE_TRY_CHECK;

      //For the last packet. Hack...
      ACE_OS::sleep (1);

      <xsl:value-of select="$name_all_capital"/>::instance ()->getCtrlManager().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"main(): Exception !\n");
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of main() -->


#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex>;
template class TAO_AV_Endpoint_Reactive_Strategy_A&lt;<xsl:value-of select="$name"/>StreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy&lt;<xsl:value-of select="$name"/>StreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_A&lt;<xsl:value-of select="$name"/>StreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy&lt;<xsl:value-of select="$name"/>StreamEndPoint,TAO_VDev,AV_Null_MediaCtrl>
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */

   </content></file>
</xsl:template>
<!-- ================================= -->
<!--  End of The Sender_CPP template   -->
<!-- ================================= -->










  
<!-- ================================= -->
<!--      The Sender_H template        -->
<!-- ================================= -->


<xsl:template name="Sender_H">
  <xsl:param name="name"/>
  <xsl:param name="classname"/>
  <xsl:param name="filters"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
     <xsl:value-of select="$dir_output_root"/><xsl:value-of select="$name"/>.h</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.h')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- include ifdef-endif -->

#ifndef _<xsl:value-of select="$name_all_capital"/>_H_
#define _<xsl:value-of select="$name_all_capital"/>_H_


  <xsl:value-of select="$empty_line"/>

  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{orbsvcs/AV/Endpoint_Strategy.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">{CtrlManager.h}{Pipe.h}{Sender_h_other.h}</xsl:with-param>
  </xsl:call-template>


class <xsl:value-of select="concat($name, 'StreamEndPoint')"/>;
class <xsl:value-of select="$name"/>;  

  <xsl:value-of select="$empty_line"/>
  <!-- =============================== -->
  <!-- The Sender_StreamEndPoint class -->
  <!--                                 -->
  //&lt;block name="pipe_<xsl:value-of select="$classname"/>">

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'StreamEndPoint class: Defines a $name stream endpoint.')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'StreamEndPoint')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_Client_StreamEndPoint}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">get_callback</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">set_protocol_object</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Protocol_Object *object}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">handle_preconnect</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">CORBA::Boolean</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::flowSpec &amp;flowspec}</xsl:with-param>
  </xsl:call-template>
  
  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">callback</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_AV_Callback</xsl:with-param>
  </xsl:call-template>
  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="concat($name, '_StreamEndPoint')"/>
<xsl:text>

</xsl:text>

  <!-- =============================== -->
  <!--  The other global staff: just   -->
  <!--  treat it as plain text         -->
  <!-- =============================== -->
  <xsl:variable name="tmp">
   <xsl:value-of select="$name"/>
  </xsl:variable>
  typedef TAO_AV_Endpoint_Reactive_Strategy_A
          &lt;<xsl:value-of select="concat($tmp, 'StreamEndPoint')"/>,
           TAO_VDev,
           AV_Null_MediaCtrl&gt;
        <xsl:value-of select="$name_all_capital"/>_ENDPOINT_STRATEGY;
  


  <!-- =============================== -->
  <!-- The Sender                class -->
  <!--                                 -->
  <xsl:value-of select="$empty_line"/>

  <!-- The comment -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
       <xsl:value-of select="concat($name,' class')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The local include -->
  
  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
    <xsl:with-param name="parents">{public Pipe}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="concat('~',$name)"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">init</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}{CORBA::Environment&amp;}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">sendData</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getCtrlManager</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">CtrlManager &amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">getName</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">const char*</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">initPipe</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">virtual int</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">parseArgs</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}</xsl:with-param>
  </xsl:call-template>

  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">ctrlManager</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">CtrlManager</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name"><xsl:value-of select="concat($name_all_small, 'EndpointStrategy')"/></xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type"><xsl:value-of select="$name_all_capital"/>_ENDPOINT_STRATEGY</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name"><xsl:value-of select="concat($name_all_small, 'MMDevice')"/></xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_MMDevice*</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name"><xsl:value-of select="concat($name_all_small, 'Name')"/></xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ACE_CString</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">PPM_UDP_Reader</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">friend class</xsl:with-param>
  </xsl:call-template>


  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text><xsl:value-of select="$name"/><xsl:text>

</xsl:text>
    //&lt;/block>

  <!-- ================================ -->
  <!-- The Singleton typedef for Sender -->
  <!-- ================================ -->

  typedef ACE_Singleton&lt;<xsl:value-of
  select="$name"/><xsl:text>, ACE_Null_Mutex&gt; </xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>;
</xsl:text>

  <xsl:value-of select="$empty_line"/>

#endif // _<xsl:value-of select="$name_all_capital"/>_H_



  </content></file>

</xsl:template>

</xsl:stylesheet>
