<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!-- this is a mapping of the infopipe types -->
<xsl:variable name="maptables" select="document('ECho2mapTables.xml')/mapTables"/>

<xsl:template name="oneHeader">
<xsl:for-each select="/xip/composedPipe/declarations/pipe">
<xsl:variable name="thisPipeClass" select="@class"/>
<xsl:variable name="thisPipeName" select="@name"/>
<file>
<name><xsl:value-of select="../../@name" />/<xsl:value-of select="@name"/>/<xsl:value-of select="@name"/>.h</name>
<content>
// &lt;block name="pipe_<xsl:value-of select="$thisPipeClass"/>"&gt;
/////////////////////////////////////////////////////////////////////////////
// <xsl:value-of select="@name"/>.h -- the header file for this node
/////////////////////////////////////////////////////////////////////////////

// Include the data definitions
#include "../allNodes.h"


// exported functions

// start up the pipe
void infopipeStart_<xsl:value-of select="@name"/>(  );

// shut down the pipe
void infopipeStop_<xsl:value-of select="@name"/>( );


<xsl:for-each select="/xip/pipes/pipe[@name=$thisPipeClass]/outport">
<xsl:variable name="portName" select="@name"/>
<nodePipeOutConnect mark="true">
// Outgoing submission channel
//int <xsl:value-of select="$thisPipeName"/><pipeName/>_<connType/>_<xsl:value-of select="$portName"/><connName/>Submit( <dataTypeName/>CarrierStruct * );
//int <xsl:value-of select="$thisPipeName"/>_<connType/>_<xsl:value-of select="$portName"/><connName/>Submit(  );
int <xsl:value-of select="$thisPipeName"/><pipeName/>_<connType/>_<xsl:value-of select="$portName"/><connName/>Submit( <xsl:value-of select="@type"/>Struct_ptr  );
</nodePipeOutConnect>
</xsl:for-each>

<xsl:for-each select="/xip/pipes/pipe[@name=$thisPipeClass]/inport">
int uninstallLastFilter_<xsl:value-of select="$thisPipeName"/>( void );
int installFilter_<xsl:value-of select="$thisPipeName"/>( char *filterName, void *filterParams );
</xsl:for-each>
char *getFilterStackString();

struct infopipeState_<xsl:value-of select="@name"/> {
  char *upstream;
  char *downstream;
  int  sink_connected;
  int  source_connected;
};
// &lt;/block&gt;
</content>
</file>
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
