<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:variable name="varType" select="/xip/absMachines/absMachine[@name='java']/mapTable[@name='typeMatching']/mapping"/>

<xsl:template name="java_datatype">
  <xsl:param name="datatype"/>
  <xsl:for-each select="$datatype">
<file>
<name>InfopipeDataType_<xsl:value-of select="@name"/>.java</name>
<content>
/* &lt;block name="datatype_<xsl:value-of select="@name"/>"&gt; */
/* 
   This file is generated by Infopipe Stub Generater 
   using java socket template ver. 0.2 created by Younggyun Koh 
*/

import java.net.*;
import java.util.*;
import java.io.*;

import org.w3c.dom.*;
import org.xml.sax.*;
import org.apache.xerces.parsers.DOMParser;
import org.apache.xalan.xpath.xml.*;

public class InfopipeDataType_<xsl:value-of select="@name"/> {

	<xsl:for-each select="arg"><xsl:variable name="argType" select="@type"/>public <xsl:value-of select="$varType[@from=$argType]/@to"/><xsl:text> </xsl:text><xsl:value-of select="@name"/>;
	</xsl:for-each>
	public void parseXML(String str) throws Exception {
		Reader in = new StringReader(str);
		this.parseXML(in);
	}

	public void parseXML(Reader in) throws Exception {
		InputSource inputSource = new InputSource(in);
		DOMParser parser = new DOMParser();

		try {
			parser.parse(inputSource);
		} catch (IOException ioe) {
			ioe.printStackTrace();
			throw new Exception(ioe.getMessage());
		} catch (SAXException se) {
			se.printStackTrace();
			throw new Exception(se.getMessage());
		}

		Node root = parser.getDocument().getDocumentElement();
		Node dataNode = null;
		Node currNode = null;
		NodeList nodeList = null;

		try {
			dataNode = XPathAPI.selectSingleNode(root, "dataContent");
			if (dataNode == null || !((Element)dataNode).getAttribute("type").equals("<xsl:value-of select="@name"/>"))
			{
				throw new Exception("InfopipeDataType_<xsl:value-of select="@name"/>: invalid data");
			}

			currNode = null;
<xsl:for-each select="arg">
			currNode = XPathAPI.selectSingleNode(dataNode, "<xsl:value-of select="@name"/>/text()");
			if (currNode != null) {
				if (currNode.getNodeType() == Node.TEXT_NODE) {
					<xsl:value-of select="@name"/> = currNode.getNodeValue();
				}
				else {
					throw new Exception("InfopipeDataType_<xsl:value-of select="../@name"/>: this node type cannot be treated...");
				}
			} else {
				throw new Exception("InfopipeDataType_<xsl:value-of select="../@name"/>: <xsl:value-of select="@name"/> is null");
			}
</xsl:for-each>
		} catch (SAXException se) {
			se.printStackTrace();
			throw new Exception(se.getMessage());
		}

	}

	public String formatToXML() {

		String doc = new String();
		doc = "&lt;infopipeDataFormat version=\"0.1\"&gt;&lt;dataContent type=\"<xsl:value-of select="@name"/>\"&gt;";
<xsl:for-each select="arg">
		if (<xsl:value-of select="@name"/> == null) {
			doc = doc + "&lt;<xsl:value-of select="@name"/>&gt;&lt;/<xsl:value-of select="@name"/>&gt;";
		}
		else {
			doc = doc + "&lt;<xsl:value-of select="@name"/>&gt;" + <xsl:value-of select="@name"/> + "&lt;/<xsl:value-of select="@name"/>&gt;";
		}
</xsl:for-each>
		doc = doc + "&lt;/dataContent&gt;&lt;/infopipeDataFormat&gt;";

		return doc;
	}

	public void formatToXML(Writer out) throws Exception {
		out.write(this.formatToXML());
		out.flush();
	}
}

/* &lt;/block&gt; */
</content>
</file>
  </xsl:for-each>
</xsl:template>
</xsl:stylesheet>
