
//////////////////////////////////////////////////////////////////////////////////////////
// Node000.cpp -- the implementation file for this node
/////////////////////////////////////////////////////////////////////////////
#include "../allNodes.hpp"
#include <sys/types.h>
#include <sys/stat.h>
#include <fstream.h>
#include <errno.h>

// definition of publish types
#define PUBLISH_FILE  0x0001

static  CManager cm;
static  EControlContext ec;






typedef struct Raw_dataCarrierStructDef
{
  
  Raw_dataStruct payload;
} Raw_dataCarrierStruct, *Raw_dataCarrierStruct_ptr;

typedef struct Raw_data_2CCarrierStructDef
{
  
  Raw_data_2CStruct payload;
} Raw_data_2CCarrierStruct, *Raw_data_2CCarrierStruct_ptr;

typedef struct Raw_data_2GCarrierStructDef
{
  
  Raw_data_2GStruct payload;
} Raw_data_2GCarrierStruct, *Raw_data_2GCarrierStruct_ptr;

typedef struct Raw_data_3CCarrierStructDef
{
  
  Raw_data_3CStruct payload;
} Raw_data_3CCarrierStruct, *Raw_data_3CCarrierStruct_ptr;

typedef struct Raw_data_3GCarrierStructDef
{
  
  Raw_data_3GStruct payload;
} Raw_data_3GCarrierStruct, *Raw_data_3GCarrierStruct_ptr;

typedef struct Raw_data_4CCarrierStructDef
{
  
  Raw_data_4CStruct payload;
} Raw_data_4CCarrierStruct, *Raw_data_4CCarrierStruct_ptr;

typedef struct Raw_data_4GCarrierStructDef
{
  
  Raw_data_4GStruct payload;
} Raw_data_4GCarrierStruct, *Raw_data_4GCarrierStruct_ptr;




static IOField Raw_dataFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_dataStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_dataStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_dataStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_dataStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_dataStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_dataStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_dataStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_dataStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_dataFormatList[] = 
{

  {"Raw_dataStruct",Raw_dataFieldList},
  { NULL, NULL}
};

static IOField Raw_dataCarrierFieldList[] = {
  
  {"payload","Raw_dataStruct", sizeof(Raw_dataStruct), IOOffset( Raw_dataCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_2CFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_2CStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_2CStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_2CStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_2CFormatList[] = 
{

  {"Raw_data_2CStruct",Raw_data_2CFieldList},
  { NULL, NULL}
};

static IOField Raw_data_2CCarrierFieldList[] = {
  
  {"payload","Raw_data_2CStruct", sizeof(Raw_data_2CStruct), IOOffset( Raw_data_2CCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_2GFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_2GStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_2GStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_2GStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_2GStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_2GStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_2GStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_2GStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_2GStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_2GFormatList[] = 
{

  {"Raw_data_2GStruct",Raw_data_2GFieldList},
  { NULL, NULL}
};

static IOField Raw_data_2GCarrierFieldList[] = {
  
  {"payload","Raw_data_2GStruct", sizeof(Raw_data_2GStruct), IOOffset( Raw_data_2GCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_3CFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_3CStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_3CStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_3CStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_3CStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_3CStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_3CStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_3CStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_3CStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_3CFormatList[] = 
{

  {"Raw_data_3CStruct",Raw_data_3CFieldList},
  { NULL, NULL}
};

static IOField Raw_data_3CCarrierFieldList[] = {
  
  {"payload","Raw_data_3CStruct", sizeof(Raw_data_3CStruct), IOOffset( Raw_data_3CCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_3GFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_3GStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_3GStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_3GStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_3GStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_3GStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_3GStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_3GStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_3GStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_3GFormatList[] = 
{

  {"Raw_data_3GStruct",Raw_data_3GFieldList},
  { NULL, NULL}
};

static IOField Raw_data_3GCarrierFieldList[] = {
  
  {"payload","Raw_data_3GStruct", sizeof(Raw_data_3GStruct), IOOffset( Raw_data_3GCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_4CFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_4CStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_4CStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_4CStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_4CStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_4CStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_4CStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_4CStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_4CStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_4CFormatList[] = 
{

  {"Raw_data_4CStruct",Raw_data_4CFieldList},
  { NULL, NULL}
};

static IOField Raw_data_4CCarrierFieldList[] = {
  
  {"payload","Raw_data_4CStruct", sizeof(Raw_data_4CStruct), IOOffset( Raw_data_4CCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


static IOField Raw_data_4GFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_4GStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_4GStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_4GStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_4GStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_4GStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_4GStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_4GStruct*, maxval)},
  {"buff", "",sizeof(), IOOffset( Raw_data_4GStruct*, buff)},
  
  
  {NULL, NULL, 0, 0}
};

static CMFormatRec Raw_data_4GFormatList[] = 
{

  {"Raw_data_4GStruct",Raw_data_4GFieldList},
  { NULL, NULL}
};

static IOField Raw_data_4GCarrierFieldList[] = {
  
  {"payload","Raw_data_4GStruct", sizeof(Raw_data_4GStruct), IOOffset( Raw_data_4GCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


// variables to track

// channel vars for sending info 
static ECSourceHandle Raw_data2C_node_Node000SendHandle;
static EChannel Raw_data2C_node_Node000SendChannel;
Raw_data_2CCarrierStruct Node000_outgoingData;




// prototypes for the functions in the implementation file
void infopipeStartup( );
void infopipeShutdown( );

// functions publishing and looking up
static int publish(char *pipe, char *connType, char *connName, char *str, int type);
static int publishFile(char *pipe, char *connType, char *connName, char *str);
static int unpublish(char *pipe, char *connType, char *connName, int type);
static int unpublishFile(char *pipe, char *connType, char *connName);
static char *lookup(char *pipe, char *nodeOrBranch, char *connPoint, int type, char *str);
static char *lookupFile(char *pipe, char *connType, char *connName, char *str);


int Raw_data2C_node_Node000Submit( Raw_data_2CCarrierStruct * );







 



int makePathDir(char *path, mode_t mode = 0755)
{
  char *dir; 
  char *p;

  dir = new char[strlen(path) + 1];

  p = path;

  while(1)
  {
    p = strchr(p, '/');
    if (p == NULL) 
    {
      delete dir;
      return 0;
    }

    p++;
    // get first dir name including '/'
    memcpy(dir, path, p - path);
    dir[p - path] = 0;

    // make directory
    if (mkdir(dir, mode))
    {
      // if dir exists already, continue
      // otherwise(error occurs), return -1
      if (errno != EEXIST)
      {
        delete dir;
        return -1;
      }
    }
  }

  // cannot reach here
  return 0;
}

// publish
static int publish(char *pipe, char *connType, char *connName, char *str, int type)
{
  if (type & PUBLISH_FILE)
  {
    publishFile(pipe, connType, connName, str);
  }

  return 0;
}

static int publishFile(char *pipe, char *connType, char *connName, char *str)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  makePathDir(filename);

  cout << "publishing file = " << filename << endl;

  ofstream ofile(filename);
  if (ofile.is_open())
  {
    ofile << str << endl;
  }
  else
    cout << "Error in publishing file " << filename << endl;

  return 0;
}


static int unpublish(char *pipe, char *connType, char *connName, int type)
{
  if (type & PUBLISH_FILE)
  {
    unpublishFile(pipe, connType, connName);
  }

  return 0;
}

static int unpublishFile(char *pipe, char *connType, char *connName)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  return remove(filename);
}


static char *lookup(char *pipe, char *connType, char *connName, int type, char *str)
{
  if (type & PUBLISH_FILE)
  {
    return lookupFile(pipe, connType, connName, str);
  }

}


static char *lookupFile(char *pipe, char *connType, char *connName, char *str)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  ifstream ifile(filename);
  if (ifile.is_open())
  {
    ifile >> str;
  }
  else
    cout << "Error in looking up file " << filename << endl;

  return str;
}


void infopipeStartup(  )
{
  char lookupStr[512];
  int forked;

  gen_pthread_init();

  // create the connection manager
  cm = CManager_create();

  // fork network manager thread
  forked = CMfork_comm_thread( cm );
  if( !forked )
    {
    cerr << "Fork of communications thread failed, exiting" << endl;
    exit( 1 );
    }

  // initialize the CM
  ec = ECho_CM_init( cm );




  /////////////////////////////////
  // OUTGOING 
  // create the outgoing channel
  Raw_data2C_node_Node000SendChannel = EChannel_typed_create( ec, Raw_data_2CCarrierFieldList, Raw_data_2CFormatList ); 
  if(Raw_data2C_node_Node000SendChannel == NULL )
    cerr << "Error creating Raw_data2C_node_Node000SendChannel" << endl;
  publish( "Raw_data2C", "node","Node000", ECglobal_id(Raw_data2C_node_Node000SendChannel), PUBLISH_FILE );
  //Raw_data2C = EChannel_open( ec, ECglobal_id(Raw_data2CSendChannel));
  // subscribe as a source 
  Raw_data2C_node_Node000SendHandle = ECsource_typed_subscribe( Raw_data2C_node_Node000SendChannel, Raw_data_2CCarrierFieldList, Raw_data_2CFormatList);





  // install signal handler
}

// shuts down the infopipe system and cleans out directory entries
void infopipeShutdown( )
{

// shutdown our outgoing pipes - the incoming pipes will
// be shutdown by the nodes upstream from us

  EChannel_destroy( Raw_data2C_node_Node000SendChannel );


  // unpublish our server info
  Raw_data2C_node_Node000SendChannel = EChannel_typed_create( ec, Raw_data_2CFieldList, NULL ); 
  if(Raw_data2C_node_Node000SendChannel == NULL )
    cerr << "Error creating Raw_data2C_node_Node000SendChannel" << endl;
  unpublish( "Raw_data2C", "node","Node000", PUBLISH_FILE );


  // closing down comm
  CManager_close(cm);


  // clean up threads?
}




/////////////////////////////////////////////////////////////////////////////
// functions for submitting data to net
//int Raw_data2C_node_Node000Submit( Raw_data_2CCarrierStruct *outgoingData )
int Raw_data2C_node_Node000Submit(  )
{

  
  ECsubmit_typed_event( Raw_data2C_node_Node000SendHandle, Node000_outgoingData );
  return 0;
}

// ENDING OF IMP FILE FOR A NODE

int main( void )
{
  // start the pipe
  infopipeStartup();
  
  while( 1 )
    sleep( 1 );

  // close down the pipes
  infopipeShutdown();

  // normal termination
  return 0;
}
