
//////////////////////////////////////////////////////////////////////////////////////////
// Node000.cpp -- the implementation file for this node
/////////////////////////////////////////////////////////////////////////////
extern "C" {
#include "avs_sender_node.h"
}
#include <fstream.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

extern "C"
{
#include <cm.h>
#include <echo.h>
#include <gen_thread.h>
}


extern "C" {
CManager cm;
EControlContext ec;
}





//typedef struct Raw_data_2CCarrierStructDef
//{
  
//  Raw_data_2CStruct payload;
//} Raw_data_2CCarrierStruct, *Raw_data_2CCarrierStruct_ptr;

/*
extern "C" {
IOField Raw_data_2CFieldList[];

CMFormatRec Raw_data_2CFormatList[];

IOField Raw_data_2CCarrierFieldList[];
}
*/

IOField Raw_data_2CFieldList[] = {
  {"tag", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, tag)},
  {"ppm1", "char",sizeof(char), IOOffset( Raw_data_2CStruct*, ppm1)},
  {"ppm2", "char",sizeof(char), IOOffset( Raw_data_2CStruct*, ppm2)},
  {"size", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, size)},
  {"width", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, width)},
  {"height", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, height)},
  {"maxval", "integer",sizeof(int), IOOffset( Raw_data_2CStruct*, maxval)},
  {"buff", IOArrayDecl(char, AVSIMAGE2C), sizeof(char), IOOffset( Raw_data_2CStruct*, buff[0])},
  
  
  {NULL, NULL, 0, 0}
};

CMFormatRec Raw_data_2CFormatList[] = 
{

  {"Raw_data_2CStruct",Raw_data_2CFieldList},
  { NULL, NULL}
};

IOField Raw_data_2CCarrierFieldList[] = {
  
  {"payload","Raw_data_2CStruct", sizeof(Raw_data_2CStruct), IOOffset( Raw_data_2CCarrierStruct*, payload) },
  {NULL, NULL, 0, 0}
};


// variables to track

// channel vars for sending info 
extern "C" {
ECSourceHandle Raw_data2C_node_Node000SendHandle;
EChannel Raw_data2C_node_Node000SendChannel;
Raw_data_2CCarrierStruct* Node000_outgoingData;
}



// prototypes for the functions in the implementation file
extern "C" {
void infopipeStartup( );
void infopipeShutdown( );
  int makePathDir(char* path, mode_t mode = 0755);
}
 



int makePathDir(char *path, mode_t mode = 0755)
{
  char *dir; 
  char *p;

  dir = new char[strlen(path) + 1];

  p = path;

  while(1)
  {
    p = strchr(p, '/');
    if (p == NULL) 
    {
      delete dir;
      return 0;
    }

    p++;
    // get first dir name including '/'
    memcpy(dir, path, p - path);
    dir[p - path] = 0;

    // make directory
    if (mkdir(dir, mode))
    {
      // if dir exists already, continue
      // otherwise(error occurs), return -1
      if (errno != EEXIST)
      {
        delete dir;
        return -1;
      }
    }
  }

  // cannot reach here
  return 0;
}

// publish
int publish(char *pipe, char *connType, char *connName, char *str, int type)
{
  if (type & PUBLISH_FILE)
  {
    publishFile(pipe, connType, connName, str);
  }

  return 0;
}

int publishFile(char *pipe, char *connType, char *connName, char *str)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  makePathDir(filename);

  cout << "publishing file = " << filename << endl;

  ofstream ofile(filename);
  if (ofile.is_open())
  {
    ofile << str << endl;
  }
  else
    cout << "Error in publishing file " << filename << endl;

  return 0;
}


int unpublish(char *pipe, char *connType, char *connName, int type)
{
  if (type & PUBLISH_FILE)
  {
    unpublishFile(pipe, connType, connName);
  }

  return 0;
}

int unpublishFile(char *pipe, char *connType, char *connName)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  return remove(filename);
}


char *lookup(char *pipe, char *connType, char *connName, int type, char *str)
{
  if (type & PUBLISH_FILE)
  {
    return lookupFile(pipe, connType, connName, str);
  }

}


char *lookupFile(char *pipe, char *connType, char *connName, char *str)
{
  char *publishRoot;
  char *filename;

  if ((publishRoot = getenv("INFOPIPE_PUBLISH_ROOT")) == NULL)
  {
    // if no INFOPIPE_PUBLISH_ROOT is defined, use current directory
    publishRoot = getenv("PWD");
  }

  filename = new char[strlen(publishRoot) + strlen(pipe) + 
		      strlen(connType) + strlen(connName) + 10];

  // make filename = ""
  filename[0] = 0;
  strcat(filename, publishRoot);

  // if the path does not have the last '/', add '/'
  if (filename[strlen(publishRoot)-1] != '/')
    strcat(filename, "/");

  strcat(filename, pipe);
  strcat(filename, "/");
  strcat(filename, connType);
  strcat(filename, "/");
  strcat(filename, connName);

  ifstream ifile(filename);
  if (ifile.is_open())
  {
    ifile >> str;
  }
  else
    cout << "Error in looking up file " << filename << endl;

  return str;
}


void infopipeStartup(  )
{
  char lookupStr[512];
  int forked;

  gen_pthread_init();

  // create the connection manager
  cm = CManager_create();

  // fork network manager thread
  forked = CMfork_comm_thread( cm );
  if( !forked )
    {
    cerr << "Fork of communications thread failed, exiting" << endl;
    exit( 1 );
    }

  // initialize the CM
  ec = ECho_CM_init( cm );




  /////////////////////////////////
  // OUTGOING 
  // create the outgoing channel
  Raw_data2C_node_Node000SendChannel = EChannel_typed_create( ec, Raw_data_2CFieldList, NULL/*Raw_data_2CFormatList*/ ); 
  if(Raw_data2C_node_Node000SendChannel == NULL )
    cerr << "Error creating Raw_data2C_node_Node000SendChannel" << endl;
  publish( "Raw_data2C", "node","Node000", ECglobal_id(Raw_data2C_node_Node000SendChannel), PUBLISH_FILE );
  //Raw_data2C = EChannel_open( ec, ECglobal_id(Raw_data2CSendChannel));
  // subscribe as a source 
  Raw_data2C_node_Node000SendHandle = ECsource_typed_subscribe( Raw_data2C_node_Node000SendChannel, Raw_data_2CFieldList, NULL/*Raw_data_2CFormatList*/);





  // install signal handler
}

// shuts down the infopipe system and cleans out directory entries
void infopipeShutdown( )
{

// shutdown our outgoing pipes - the incoming pipes will
// be shutdown by the nodes upstream from us

  EChannel_destroy( Raw_data2C_node_Node000SendChannel );


  // unpublish our server info
  Raw_data2C_node_Node000SendChannel = EChannel_typed_create( ec, Raw_data_2CFieldList, NULL ); 
  if(Raw_data2C_node_Node000SendChannel == NULL )
    cerr << "Error creating Raw_data2C_node_Node000SendChannel" << endl;
  unpublish( "Raw_data2C", "node","Node000", PUBLISH_FILE );


  // closing down comm
  CManager_close(cm);


  // clean up threads?
}




/////////////////////////////////////////////////////////////////////////////
// functions for submitting data to net
//int Raw_data2C_node_Node000Submit( Raw_data_2CCarrierStruct *outgoingData )
int Raw_data2C_node_Node000Submit(  )
{

  
  ECsubmit_typed_event( Raw_data2C_node_Node000SendHandle, Node000_outgoingData );
  return 0;
}

// ENDING OF IMP FILE FOR A NODE

