/*
 * $Id: const.c,v 1.1.1.1 2003/06/11 21:16:00 wyan Exp $
 * $Log: const.c,v $
 * Revision 1.1.1.1  2003/06/11 21:16:00  wyan
 * demoHarness
 *
 * Revision 1.7  2002/11/22 00:34:10  wyan
 * *** empty log message ***
 *
 * Revision 1.5  2002/11/06 21:51:20  wyan
 * *** empty log message ***
 *
 * Revision 1.4  2002/07/12 16:56:24  wyan
 *
 * autoconf targeting for python package
 *
 * Revision 1.3  2002/07/05 20:37:39  wyan
 * *** empty log message ***
 *
 * Revision 1.2  2002/07/03 03:54:07  wyan
 * *** empty log message ***
 *
 * $Revision: 1.1.1.1 $
 */

//#define GTK_ENABLE_BROKEN

#include "const.h"
#include "interface.h"
#include "cfg_info_parse.h"
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include <unistd.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "callbacks.h"
//#include "csiplex.h"
#include "sipParser.h"

extern FILE* OUT;

GList* ALL_DEMO;
gchar* dflt_demo;

char** DEMO_SRC_FILE;
char** SIP_FILE;
char** XIP_FILE;
char** GENCODE_FILE;
char** DEMO_ISG_FILE;
char** REAL_SIP_FILE;
char** REAL_XIP_FILE;

gchar* STATS_FILE;
FILE* stats_input;

gchar* RUN_ISG_SCRIPT;

int NR_DEMO_SRC_FILE =1;
int NR_SIP_FILE =1;
int NR_XIP_FILE =1;
int NR_GENCODE_FILE= 1;
int NR_DEMO_ISG_FILE =1;

//Flags
gboolean SIP_file_created = TRUE;
gboolean XIP_file_created = TRUE;
gboolean gencode_file_created = TRUE;


/* Obsolete */
/*
gchar* XIP_START_BLK_TAGS[]={"<dataDef",
			     "<pipe",
			     NULL};

gchar* XIP_END_BLK_TAGS[]={"</dataDef>",
			  "</pipe>",
			   NULL};
*/


gchar* ALL_SIP_BLK_TAGS[] = {SIP_BLK_TAG_OTHER_1,
			 SIP_BLK_TAG_OTHER_2,
			 SIP_START_BLK_TAG,
			 SIP_END_BLK_TAG};

gchar* ALL_XIP_BLK_TAGS[] = {XIP_START_BLK_TAG,
			     XIP_END_BLK_TAG};


C_SRC_FONT_SIZE font_size = MEDIUM;

GdkColor color_white, color_red, color_black;
GdkColor color_basic, color_highlight;
GdkColormap *cmap;

//The str const corresponds to the define's
gchar* str_demo_src_root;
gchar* str_demo_isg_root;
gchar* str_isg_root;


//The Tag table
//GtkTextTagTable* text_tag_table;
GtkTextTag* hidden_tag;
GtkTextTag* highlight_tag;
GtkTextTag* normal_tag;



#define CHECK_PRINT_STR(ptr) \
 do {\
  if (NULL!=ptr) \
    MSG1( " %s ", ptr);\
  else \
    MSG(" NULL ");\
 } while (0)


#define DSTRY_WIDGET(a) \
do {\
 if (a) \
  gtk_widget_destroy(GTK_WIDGET(a));\
} while (0)

#define DSTRY_WIDGETS(n, w) \
do {\
 gint i;\
 for (i=0;i<(n); i++) {\
  DSTRY_WIDGET((w)[i]);\
 }\
} while (0)


#define UNREF_IF_EXST(a) \
if (a) \
  g_object_unref(a)

#define FREE_IF_EXST(a) \
if (a) {\
  g_free(a);\
  (a) = NULL;\
} 



#define SET_TO_NULL(a) (a=NULL)








/*
 * Read all the information from the demos.rc in order to start the 
 * demo.
 */
void init_rc() {
  int i;
  gint file;
  GScanner* gs;
  demo_info* df;

  if ((file = open_file_fd(DEMO_RC_FILE, O_RDONLY)) < 0 ) {
    ERR1(" [init_rc(): file %s open error!\n",DEMO_RC_FILE);
    exit(-1);
  }

  //Get the conf file names first
  gs = g_scanner_new(&gsconfig);
  g_scanner_input_file (gs, file);
  parse_all_demo (gs);
  //g_scanner_destroy (gs);

  for (i=0; i<g_list_length(ALL_DEMO); i++) {
    df = (demo_info*)g_list_nth_data(ALL_DEMO, i);

    if (NULL != df) {
      //Parse the conf file for each different demo
      if ((file = open_file_fd (df->cfg_file, O_RDONLY)) < 0 ) {
	ERR1( " [init_rc(): file %s open error!\n", df->cfg_file);
	exit(-1);
      }

      MSG1(" [init_rc(): %s opened file ", df->cfg_file);
      g_scanner_input_file (gs, file);
      parse_conf_file(df->name, gs);
    }
    else 
      ERR1(" [init_rc(): %d element in GList ALL_DEMO missing!\n",
	      i);

    MSG2( " demo: %s, path: %s\n", 
            df->name, 
            df->cfg_file);
  }

  g_scanner_destroy (gs);

#ifdef DEBUG
  dump_ALL_DEMO();
#endif

  //assign the first demo name to the default demo name
  if ( NULL != ALL_DEMO && 
       (df=(demo_info*)g_list_nth_data(ALL_DEMO,0)) != NULL) {
    curr_demo = df;
    dflt_demo = g_strdup(df->name);
  }
  else {
    ERR(" [init_rc(): GList ALL_DEMO empty or default demo not found!");
    exit(-1);
  }

  /*
  //Set up the GtkTextTagTable
  //text_tag_table = gtk_text_tag_table_new();
  {
    //The hidden text is just white
    hidden_tag = gtk_text_tag_new("hidden");
    g_object_set(G_OBJECT(hidden_tag), "style", PANGO_STYLE_ITALIC, NULL);
    //gtk_text_tag_table_add(text_tag_table, hidden_tag);
    //The hightlighted text is red
    highlight_tag = gtk_text_tag_new("highlight");
    g_object_set(G_OBJECT(highlight_tag), "foreground", "red", NULL);
    //gtk_text_tag_table_add(text_tag_table, highlight_tag);
    //Normal 
    normal_tag = gtk_text_tag_new("normal");
    g_object_set(G_OBJECT(normal_tag),NULL);
    //gtk_text_tag_table_add(text_tag_table, normal_tag);
  }
  */

  //Set all the information for the current demo
  set_curr_demo(df);
}





/*
 * Reset each field in curr_demo to NULL
 */
void reset_curr_demo() 
{
  gint i;
  if (curr_demo->name) g_free(curr_demo->name); 
  if (curr_demo->cfg_file) g_free(curr_demo->cfg_file);
  if (curr_demo->demo_src_file) { 
    for (i=0; i<g_list_length(curr_demo->demo_src_file); i++) 
      if (g_list_nth_data(curr_demo->demo_src_file, i)) 
	g_free(g_list_nth_data(curr_demo->demo_src_file,i));

    g_free(curr_demo->demo_src_file);
  }

  if (curr_demo->demo_isg_file) {
    for (i=0; i<g_list_length(curr_demo->demo_isg_file); i++) 
      if (g_list_nth_data(curr_demo->demo_isg_file, i)) 
	g_free(g_list_nth_data(curr_demo->demo_isg_file,i));
    
    g_free(curr_demo->demo_isg_file);
  }

  if (curr_demo->gencode_file) { 
    for (i=0; i<g_list_length(curr_demo->gencode_file); i++) 
      if (g_list_nth_data(curr_demo->gencode_file, i)) 
	g_free(g_list_nth_data(curr_demo->gencode_file,i));

    g_free(curr_demo->gencode_file);
  }

  if (curr_demo->SIP_file) { 
    for (i=0; i<g_list_length(curr_demo->SIP_file); i++) 
      if (g_list_nth_data(curr_demo->SIP_file, i)) 
	g_free(g_list_nth_data(curr_demo->SIP_file,i));

    g_free(curr_demo->SIP_file);
  }

  if (curr_demo->REAL_SIP_file) { 
    for (i=0; i<g_list_length(curr_demo->REAL_SIP_file); i++) 
      if (g_list_nth_data(curr_demo->REAL_SIP_file, i)) 
	g_free(g_list_nth_data(curr_demo->REAL_SIP_file,i));

    g_free(curr_demo->REAL_SIP_file);
  }

  if (curr_demo->XIP_file) { 
    for (i=0; i<g_list_length(curr_demo->XIP_file); i++) 
      if (g_list_nth_data(curr_demo->XIP_file, i)) 
	g_free(g_list_nth_data(curr_demo->XIP_file,i));

    g_free(curr_demo->XIP_file);
  }

  if (curr_demo->REAL_XIP_file) { 
    for (i=0; i<g_list_length(curr_demo->REAL_XIP_file); i++) 
      if (g_list_nth_data(curr_demo->REAL_XIP_file, i)) 
	g_free(g_list_nth_data(curr_demo->REAL_XIP_file,i));

    g_free(curr_demo->REAL_XIP_file);
  }

  if (curr_demo->stats_file) 
    g_free(curr_demo->stats_file);

  if (curr_demo->run_isg_script)
    g_free(curr_demo->run_isg_script);

  curr_demo->name = curr_demo->cfg_file = curr_demo->demo_src_file
    = curr_demo->demo_isg_file = curr_demo->gencode_file 
    = curr_demo->SIP_file = curr_demo->REAL_SIP_file=
    curr_demo->XIP_file = curr_demo->REAL_XIP_file = curr_demo->stats_file
    = curr_demo->run_isg_script = NULL;
}





/*
 * Copy the values from di to curr_demo.
 * Since the value in ALL_DEMO is valid thru all the life of the 
 * demo, it's OK (no mem leakage) to just readjust the pointer in 
 * curr_demo pionting
 * to different setup in ALL_DEMO[element].
 */  
void set_curr_demo(demo_info* di)
{
  gint i;
  if (NULL == di) {
    ERR( " [set_curr_demo(): NULL ptr exception");
    exit(-1);
  }
  
  curr_demo = di;

  //free the name strings
  if (DEMO_SRC_FILE) {
    for (i=0;i<NR_DEMO_SRC_FILE;i++) g_free(DEMO_SRC_FILE[i]);
    g_free(DEMO_SRC_FILE);
  }

  if (DEMO_ISG_FILE) {
    for (i=0;i<NR_DEMO_ISG_FILE;i++) g_free(DEMO_ISG_FILE[i]);
    g_free(DEMO_ISG_FILE);
  }

  if (GENCODE_FILE) {
    for (i=0;i<NR_GENCODE_FILE;i++) g_free(GENCODE_FILE[i]);
    g_free(GENCODE_FILE);
  }
  
  if (SIP_FILE) {
    for (i=0;i<NR_SIP_FILE;i++) g_free(SIP_FILE[i]);
    g_free(SIP_FILE);
  }

  if (REAL_SIP_FILE) {
    for (i=0;i<NR_SIP_FILE;i++) g_free(REAL_SIP_FILE[i]);
    g_free(REAL_SIP_FILE);
  }

  if (XIP_FILE) {
    for (i=0;i<NR_XIP_FILE;i++) g_free(XIP_FILE[i]);
    g_free(XIP_FILE);
  }

  if (REAL_XIP_FILE) {
    for (i=0;i<NR_XIP_FILE;i++) g_free(REAL_XIP_FILE[i]);
    g_free(REAL_XIP_FILE);
  }

  if (STATS_FILE) {
    g_free(STATS_FILE);
    STATS_FILE = NULL;
    stats_input = 0;
  }

  if (RUN_ISG_SCRIPT) {
    g_free(RUN_ISG_SCRIPT);
    RUN_ISG_SCRIPT = NULL;
  }

  NR_DEMO_SRC_FILE = g_list_length(curr_demo->demo_src_file);
  NR_DEMO_ISG_FILE = g_list_length(curr_demo->demo_isg_file);
  NR_GENCODE_FILE  = g_list_length(curr_demo->gencode_file);
  NR_SIP_FILE      = g_list_length(curr_demo->SIP_file);
  NR_XIP_FILE      = g_list_length(curr_demo->XIP_file);

  if (dflt_demo) { g_free(dflt_demo); dflt_demo=(gchar*)g_strdup
					(curr_demo->name); }
  
  DEMO_SRC_FILE = (gchar**)g_malloc(NR_DEMO_SRC_FILE*sizeof(gchar*));
  for (i=0;i<NR_DEMO_SRC_FILE;i++)  
    DEMO_SRC_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->demo_src_file,i));

  DEMO_ISG_FILE = (gchar**)g_malloc(NR_DEMO_ISG_FILE*sizeof(gchar*));
  for (i=0;i<NR_DEMO_ISG_FILE;i++)  
    DEMO_ISG_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->demo_isg_file,i));

  GENCODE_FILE = (gchar**)g_malloc(NR_GENCODE_FILE*sizeof(gchar*));
  for (i=0;i<NR_GENCODE_FILE;i++)  
    GENCODE_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->gencode_file,i));

  SIP_FILE = (gchar**)g_malloc(NR_SIP_FILE*sizeof(gchar*));  
  for (i=0;i<NR_SIP_FILE;i++)  
    SIP_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->SIP_file,i));

  REAL_SIP_FILE = (gchar**)g_malloc(NR_SIP_FILE*sizeof(gchar*));  
  for (i=0;i<NR_SIP_FILE;i++)  
    REAL_SIP_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->REAL_SIP_file,i));

  XIP_FILE = (gchar**)g_malloc(NR_XIP_FILE*sizeof(gchar*));
  for (i=0;i<NR_XIP_FILE;i++)  
    XIP_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->XIP_file,i));

  REAL_XIP_FILE = (gchar**)g_malloc(NR_XIP_FILE*sizeof(gchar*));
  for (i=0;i<NR_XIP_FILE;i++)  
    REAL_XIP_FILE[i] = (gchar*)g_strdup(g_list_nth_data
					(curr_demo->REAL_XIP_file,i));

  STATS_FILE = (gchar*)g_strdup(di->stats_file);

  RUN_ISG_SCRIPT = (gchar*)g_strdup(di->run_isg_script);
}




void recreate_notebooks_widgets()
{
  make_notebook_pages("demo_src",NR_DEMO_SRC_FILE);
  make_notebook_pages("SIP",NR_SIP_FILE);
  make_notebook_pages("XIP",NR_XIP_FILE);
  make_notebook_pages("gencode",NR_GENCODE_FILE);
  make_notebook_pages("demo_isg",NR_DEMO_ISG_FILE);
}




void clear_text_stats ()
{
  GtkTextIter    iter1, iter2;

  if (text_stats_buf) {
    gtk_text_buffer_get_start_iter(text_stats_buf, &iter1);
    gtk_text_buffer_get_end_iter(text_stats_buf, &iter2);
    gtk_text_buffer_delete(text_stats_buf, &iter1, &iter2);
  }
}




  
void destroy_dialog_widgets() 
{
  if (SIP_dialog_window_text_buf) 
    DSTRY_WIDGETS(NR_SIP_FILE, SIP_dialog_window_text_buf);

  if (SIP_dialog_window_text) 
    DSTRY_WIDGETS(NR_SIP_FILE, SIP_dialog_window_text);

  if (SIP_dialog_window)
    DSTRY_WIDGETS(NR_SIP_FILE, SIP_dialog_window);

  FREE_IF_EXST(SIP_dialog_window);
  FREE_IF_EXST(SIP_dialog_window_text);
  FREE_IF_EXST(SIP_dialog_window_text_buf);

  if (XIP_dialog_window_text_buf) 
    DSTRY_WIDGETS(NR_XIP_FILE, XIP_dialog_window_text_buf);

  if (XIP_dialog_window_text) 
    DSTRY_WIDGETS(NR_XIP_FILE, XIP_dialog_window_text);

  if (XIP_dialog_window)
    DSTRY_WIDGETS(NR_XIP_FILE, XIP_dialog_window);
  
  FREE_IF_EXST(XIP_dialog_window);
  FREE_IF_EXST(XIP_dialog_window_text);
  FREE_IF_EXST(XIP_dialog_window_text_buf);

  if (gencode_dialog_window_text_buf) 
    DSTRY_WIDGETS(NR_GENCODE_FILE, gencode_dialog_window_text_buf);

  if (gencode_dialog_window_text) 
    DSTRY_WIDGETS(NR_GENCODE_FILE, gencode_dialog_window_text);

  if (gencode_dialog_window)
    DSTRY_WIDGETS(NR_GENCODE_FILE, gencode_dialog_window);

  FREE_IF_EXST(gencode_dialog_window);
  FREE_IF_EXST(gencode_dialog_window_text);
  FREE_IF_EXST(gencode_dialog_window_text_buf);

  //invalidate the globle flag
  SIP_XIP_windows_popped = FALSE;
  SIP_file_created = TRUE;
  GENCODE_windows_popped = FALSE;
  gencode_file_created = FALSE;
}





void destroy_notebooks_widgets()
{
  gint i;

  if (text_demo_src_file) 
    DSTRY_WIDGETS(NR_DEMO_SRC_FILE, text_demo_src_file);
  if (scrolledwindow_demo_src)
    DSTRY_WIDGETS(NR_DEMO_SRC_FILE, scrolledwindow_demo_src);
    //Must be put at last!!!???
  if (label_demo_src_file)
    DSTRY_WIDGETS(NR_DEMO_SRC_FILE, label_demo_src_file);

  for (i=0;i<NR_DEMO_SRC_FILE;i++) {
    gtk_notebook_remove_page(GTK_NOTEBOOK(notebook_demo_src), i);
  }

  FREE_IF_EXST(text_demo_src_file);
  FREE_IF_EXST(text_demo_src_file_buf);
  FREE_IF_EXST(label_demo_src_file);

  if (text_demo_isg_file) 
    DSTRY_WIDGETS(NR_DEMO_ISG_FILE, text_demo_isg_file);
  if (scrolledwindow_demo_isg)
    DSTRY_WIDGETS(NR_DEMO_ISG_FILE, scrolledwindow_demo_isg);
  if (label_demo_isg_file)
    DSTRY_WIDGETS(NR_DEMO_ISG_FILE, label_demo_isg_file);

  for (i=0;i<NR_DEMO_ISG_FILE; i++) {
    gtk_notebook_remove_page(GTK_NOTEBOOK(notebook_demo_isg), i);
  }

  FREE_IF_EXST(text_demo_isg_file);
  FREE_IF_EXST(text_demo_isg_file_buf);
  FREE_IF_EXST(label_demo_isg_file);

  if (text_gencode_file) 
    DSTRY_WIDGETS(NR_GENCODE_FILE, text_gencode_file);
  if (scrolledwindow_gencode)
    DSTRY_WIDGETS(NR_GENCODE_FILE, scrolledwindow_gencode);
  if (label_gencode_file)
    DSTRY_WIDGETS(NR_GENCODE_FILE, label_gencode_file);

  for (i=0;i<NR_GENCODE_FILE;i++) {
    gtk_notebook_remove_page(GTK_NOTEBOOK(notebook_gencode), i);
  }

  FREE_IF_EXST(text_gencode_file);
  FREE_IF_EXST(text_gencode_file_buf);
  FREE_IF_EXST(label_gencode_file);

  if (text_SIP_file) 
    DSTRY_WIDGETS(NR_SIP_FILE, text_SIP_file);
  if (scrolledwindow_SIP)
    DSTRY_WIDGETS(NR_SIP_FILE, scrolledwindow_SIP);
  if (label_SIP_file)
    DSTRY_WIDGETS(NR_SIP_FILE, label_SIP_file);

  for (i=0;i<NR_SIP_FILE;i++) {
    gtk_notebook_remove_page(GTK_NOTEBOOK(notebook_SIP), i);
  }

  FREE_IF_EXST(text_SIP_file);
  FREE_IF_EXST(text_SIP_file_buf);
  FREE_IF_EXST(label_SIP_file);

  if (text_XIP_file) 
    DSTRY_WIDGETS(NR_XIP_FILE, text_XIP_file);
  if (scrolledwindow_XIP)
    DSTRY_WIDGETS(NR_XIP_FILE, scrolledwindow_XIP);
  if (label_XIP_file)
    DSTRY_WIDGETS(NR_XIP_FILE, label_XIP_file);
  
  for (i=0;i<NR_XIP_FILE;i++) {
    gtk_notebook_remove_page(GTK_NOTEBOOK(notebook_XIP), i);
  }

  FREE_IF_EXST(text_XIP_file);
  FREE_IF_EXST(text_XIP_file_buf);
  FREE_IF_EXST(label_XIP_file);

  //Free GList* file_text_list
  //Note the other members of struct file_text are deallocated by somewhere
  //else in the program.
  if (file_text_list) {
    int j;
    blk_info* tmp_blk_info;
    for (i=0;i<g_list_length(file_text_list);i++) {
      file_text* tmp=g_list_nth_data(file_text_list,i);
      if (tmp) {
	if (tmp->blk_list) {
	  for (j=0; j<g_list_length(tmp->blk_list); j++) {
	    tmp_blk_info = g_list_nth_data( tmp->blk_list, j);
	    if (tmp_blk_info) {
	      FREE_IF_EXST(tmp_blk_info->block_name);
	      //May 5, 2003
	      free(tmp_blk_info);
	    }
	  }
	  //May 5, 2003
	  g_list_free(tmp->blk_list);
	}
      }

      FREE_IF_EXST(tmp);
    }
    file_text_list=NULL;
  }
    
}



int int_to_str(char* str, int i) {
  if (i<0 || i>99) {
    ERR(" Error in int_to_str(), at most 99 \n");
    return -1;
  }
  
  sprintf(str,"%d",i);
  if (i<10)
    str[1] = '\0';
  else
    str[2] = '\0';

  return 0;
}





char* concat(char* s1, char* s2) {
  char* join = malloc((strlen(s1)+strlen(s2)+1)*sizeof(char));
  strcpy(join,s1);
  strcat(join,s2);
  join[strlen(s1) + strlen(s2)] = '\0';

  return join;
}





#if 0
/*
 * Read the files from the infomation file under /conf.
 * The file names will be recorded in the file_list. Necessary 
 * mem is allocated.
 * @path: the infomation file under /conf
 * @file_list_ptr: the file list contains all the files
 * @nr: the # of files need to be read in
 * @dir: needs to be prepended to the file names listed in the conf file
 */
int read_src_file_list(char* path, char*** file_list_ptr, int* nr, char* dir) 
{
  FILE* info_file;
  char name[30];
  int i=0;
  MSG1("path=:>%s<",path);

  info_file = open_file(path,"r");
  if (NULL!=info_file) {
    while (fscanf(info_file,"%s\n",name) != EOF) {
      MSG1(" [read_src_file_list(): name >%s<",name);
      i++;
    }
    
    rewind(info_file);
    *nr = i;
    *file_list_ptr = malloc((*nr) *sizeof(char*));
    for (i=0; i< (*nr); i++) {
      if (fscanf(info_file,"%s\n",name) == EOF) 
	break;
      (*file_list_ptr)[i] = concat(dir,name);
      MSG1(" [read_src_file_list(): file >%s<",(*file_list_ptr)[i]);
    }      
    return (*nr);
  }
  return 0;
}
#endif 




/* 
 * Create a node of type file_text and appended in GList* file_text_list
 * Pollute the info into struct file_text.
 * The following fields in file_text are modified:
 * type, file, name.
 */
void update_file_text_list_file(demo_file_type type, char* file, 
				const gchar* widget_name)
{
  file_text* tmp;

  if (type == SIP) {
    tmp = (file_text*)malloc(sizeof(file_text));
    tmp->type = SIP;
    tmp->file = file;
    tmp->name = (gchar*)widget_name;
    file_text_list = g_list_append(file_text_list, tmp);
  }
  else if (type == XIP) {
    tmp = (file_text*)malloc(sizeof(file_text));
    tmp->type = XIP;
    tmp->file = file;
    tmp->name = (gchar*)widget_name;
    file_text_list = g_list_append(file_text_list, tmp);
  }
  else if (type == GENCODE) {
    tmp = (file_text*)malloc(sizeof(file_text));      
    tmp->type = GENCODE;
    tmp->file = file;
    tmp->name = (gchar*)widget_name;
    file_text_list = g_list_append(file_text_list, tmp);
  }

  MSG2("[update_file_text_list_file(): file %d: %s in file_text_list", g_list_length(file_text_list)-1, ((file_text*)g_list_nth_data(file_text_list,g_list_length(file_text_list)-1))->file);
}





/* 
 * Pollute the info into struct file_text.
 * The following fields in file_text are modified:
 * text, text_buf.
 */
void update_file_text_list_text(GtkWidget* text, GtkTextBuffer* text_buf, const gchar* widget_name)
{
  int i;
  if (NULL==file_text_list) {
    ERR(" [update_file_text_list_text(): GList(file_text_list) not init\n");
    return;
  }
  for (i=0;i<g_list_length(file_text_list);i++){
    int tmp = find_node_in_file_text_list(widget_name);
    if (-1 < tmp)
      {
	((file_text*)g_list_nth_data(file_text_list,tmp))->text=text;
        ((file_text*)g_list_nth_data(file_text_list,tmp))->text_buf=text_buf;
	MSG2( " [update_file_text_list_text(): text(%p), text_buf(%p)",((file_text*)g_list_nth_data(file_text_list,tmp))->text, ((file_text*)g_list_nth_data(file_text_list,tmp))->text_buf);
 	break;
      }
  }
}





/*
 * return the node number in file_text_list.
 * There may have serveral nodes in the file_text_list that have
 * the same file name => ie. duplicated windows for the same file.
 * 
 */
int find_node_in_file_text_list(const gchar* widget_name)
{
  int i;

  for (i=0;i<g_list_length(file_text_list);i++) {
    if (0==g_strcasecmp(widget_name,
			((file_text*)g_list_nth_data(file_text_list,i))->name))
      {
	//MSG2("   [find_node_in_file_text_list(): found widget %s, i=%d\n",widget_name,i);
	return i;
      }
  }
  return -1;
}





/* 
 * Pollute the info into struct file_text.
 * The following fields in file_text are modified:
 * GList* blk_list.
 */
void update_file_text_list_blk_list(GtkTextBuffer* text,
				    const gchar* widget_name)
{
  int pos;
  GList* blk_list;

  if (NULL==file_text_list) {
    ERR(" [update_file_text_list_blk_list(): GList(file_text_list) not init");
    return;
  }

  pos= find_node_in_file_text_list(widget_name);
  if (-1<pos) {//found
    blk_list = parse_text(text,widget_name);
    ((file_text*)g_list_nth_data(file_text_list,pos))->blk_list = blk_list;
    MSG1( " [update_file_text_list_blk_list(): blk_list(%p)",blk_list);
  }
}





/*
 * Assume the xml version of SIP, XIP, and GENCODE are well formed
 */  
GList* parse_text(GtkTextBuffer* text, const gchar* widget_name)
{
  GList* l = NULL;
  demo_file_type type;
  int pos;

  if (NULL==text) {
    ERR("  [parse_text(): text area not init\n");
    return l;
  }
  
  pos = find_node_in_file_text_list(widget_name);
  if (-1 >= pos) 
    return l;
  
  type = ((file_text*)g_list_nth_data(file_text_list,pos)) -> type;

  if (type == SIP) {
    collect_blk_info_SIP(&l,text,SIP_BLK_NUM_TAG, SIP_START_BLK_TAG, 
		     SIP_END_BLK_TAG);
  }
  else if (type == XIP) {
    //collect_blk_info_XIP(&l,text,XIP_BLK_NUM_TAG, XIP_START_BLK_TAGS,
    //		 XIP_END_BLK_TAGS);
    collect_blk_info_SIP(&l,text,XIP_BLK_NUM_TAG, XIP_START_BLK_TAG,
			 XIP_END_BLK_TAG);
  }
  else if (type == GENCODE) {
    //collect_blk_info_SIP(&l,text,GENCODE_BLK_NUM_TAG, GENCODE_START_BLK_TAG,
    //   GENCODE_END_BLK_TAG);
    collect_blk_info_SIP(&l,text,SIP_BLK_NUM_TAG, SIP_START_BLK_TAG,
			 SIP_END_BLK_TAG);
  }

  return l;
}




    
void dump_curr_demo()
{
  int j;

  if (NULL != curr_demo) {
      MSG( " \n\n[dump_curr_demo(): ");
      CHECK_PRINT_STR(curr_demo->name);
      CHECK_PRINT_STR(curr_demo->cfg_file);

      MSG("\n");

      if (NULL != curr_demo->demo_src_file) {
	MSG(" \ndemo_src_file: ");
	for (j = 0; j<g_list_length(curr_demo->demo_src_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->demo_src_file,j));
	}
      }
      else 
	ERR( " demo_src_file list has no element!\n");

      if (NULL != curr_demo->demo_isg_file) {
	MSG(" \ndemo_isg_file: ");
	for (j = 0; j<g_list_length(curr_demo->demo_isg_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->demo_isg_file,j));
	}
      }
      else 
	ERR(" demo_isg_file list has no element!\n");

      if (NULL != curr_demo->gencode_file) {
	MSG(" \ngencode_file: ");
	for (j = 0; j<g_list_length(curr_demo->gencode_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->gencode_file,j));
	}
      }
      else 
	ERR(" gencode_file list has no element!\n");

      if (NULL != curr_demo->SIP_file) {
	MSG(" \nSIP_file: ");
	for (j = 0; j<g_list_length(curr_demo->SIP_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->SIP_file,j));
	}
      }
      else 
	ERR(" SIP_file list has no element!\n");
    

      if (NULL != curr_demo->XIP_file) {
	MSG(" \nXIP_file: ");
	for (j = 0; j<g_list_length(curr_demo->XIP_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->XIP_file,j));
	}
      }
      else 
	ERR(" XIP_file list has no element!\n");

      if (NULL != curr_demo->REAL_SIP_file) {
	MSG(" \nREAL_SIP_file: ");
	for (j = 0; j<g_list_length(curr_demo->REAL_SIP_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->REAL_SIP_file,j));
	}
      }
      else 
	ERR(" REAL_SIP_file list has no element!\n");

      if (NULL != curr_demo->REAL_XIP_file) {
	MSG(" \nREAL_XIP_file: ");
	for (j = 0; j<g_list_length(curr_demo->REAL_XIP_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(curr_demo->REAL_XIP_file,j));
	}
      }
      else 
	ERR(" REAL_XIP_file list has no element!\n");

      }
    else 
      ERR( " [dump_curr_demo(): NULL pointer error!\n");
}






void dump_ALL_DEMO()
{
  int i,j;
  demo_info* di;

  for (i=0; i<g_list_length(ALL_DEMO); i++) {
    di = (demo_info*)g_list_nth_data(ALL_DEMO, i);
    if (NULL != di) {
      MSG(" \n\n[dump_ALL_DEMO(): ");
      CHECK_PRINT_STR(di->name);
      CHECK_PRINT_STR(di->cfg_file);

      MSG("\n");

      if (NULL != di->demo_src_file) {
	MSG(" \ndemo_src_file: ");
	for (j = 0; j<g_list_length(di->demo_src_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->demo_src_file,j));
	}
      }
      else 
	ERR(" demo_src_file list has no element!\n");

      if (NULL != di->demo_isg_file) {
	MSG(" \ndemo_isg_file: ");
	for (j = 0; j<g_list_length(di->demo_isg_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->demo_isg_file,j));
	}
      }
      else 
	ERR(" demo_isg_file list has no element!\n");

      if (NULL != di->gencode_file) {
	MSG(" \ngencode_file: ");
	for (j = 0; j<g_list_length(di->gencode_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->gencode_file,j));
	}
      }
      else 
        ERR(" gencode_file list has no element!\n");

      if (NULL != di->SIP_file) {
	MSG( " \nSIP_file: ");
	for (j = 0; j<g_list_length(di->SIP_file); j++) {
	  MSG( "\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->SIP_file,j));
	}
      }
      else 
	ERR(" SIP_file list has no element!\n");
    

      if (NULL != di->XIP_file) {
	MSG(" \nXIP_file: ");
	for (j = 0; j<g_list_length(di->XIP_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->XIP_file,j));
	}
      }
      else 
	ERR( " XIP_file list has no element!\n");

      if (NULL != di->REAL_SIP_file) {
	MSG(" \nREAL_SIP_file: ");
	for (j = 0; j<g_list_length(di->REAL_SIP_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->REAL_SIP_file,j));
	}
      }
      else 
	ERR(" REAL_SIP_file list has no element!\n");

      if (NULL != di->REAL_XIP_file) {
	MSG(" \nREAL_XIP_file: ");
	for (j = 0; j<g_list_length(di->REAL_XIP_file); j++) {
	  MSG("\n              ");             
	  CHECK_PRINT_STR((gchar*)g_list_nth_data(di->REAL_XIP_file,j));
	}
      }
      else 
	ERR(" REAL_XIP_file list has no element!\n");

      if (NULL != di->stats_file) {
	MSG(" \nstats_file: ");
	MSG("\n              ");             
	CHECK_PRINT_STR(di->stats_file);
      }
      else 
	ERR( " stats_file is empty!\n");

      if (NULL != di->run_isg_script) {
	MSG(" \nscript: ");
	MSG("\n              ");             
	CHECK_PRINT_STR(di->run_isg_script);
      }
      else 
	ERR( " cannot find the script!\n");

    }
    else 
      ERR1(" [dump_ALL_DEMO(): %d element in GList ALL_DEMO missing!\n",  i);
  }
}







void dump_file_text_list() 
{
  int i,j;
  file_text* ft;
  blk_info* bi;

  for (i=0; i< g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);
    if (NULL != ft) {
      MSG1( " [dump_file_text_list(): list node %d :",i);
      MSG2( "       type: %d, file: %s",ft->type,ft->file);
      MSG1( "       name: %s",ft->name);
      MSG1( "       text: %p",ft->text);
      MSG1( "       text_buf: %p",ft->text_buf);
      MSG( "       blk_list: ");
      
      if (NULL!= (ft->blk_list)) {
	for (j=0;j<g_list_length(ft->blk_list);j++) {
	  bi = (blk_info*)g_list_nth_data(ft->blk_list,j);
	  dump_blk_info(bi);
	}
      }
      else {
	MSG("         null\n");
      }
    }
    else {
      MSG( "       null\n");
    }
  }
}







void dump_blk_info(blk_info* bi)
{
  if (NULL!=bi) {
    fprintf(OUT, "             blk_nr: %d, blk_name: %s, start_l: %d, end_l: %d, start_p: %d, end_p: %d\n", bi->block_num,bi->block_name,bi->start_line,bi->end_line,bi->start_char,bi->end_char);
  }
  else {
    fprintf(OUT, "             null\n");
  }
}









/* 
 * Since the strings[] being searched has possibly more than 1
 * string, only the result about the found string comes first
 * is returned.
 * The found iters are passed back thru start , end.
 * The index of the string in strings[index] is passed back by idx.
 */
gboolean forward_search_strings(GtkTextIter* from, gchar** strings, gint* idx,
				GtkTextSearchFlags sflag,
				GtkTextIter* start, GtkTextIter* end,
				GtkTextIter* limit)
{
  gint  min_line_nr, nr_strings;
  GtkTextIter from_cpy, min_iter_s, min_iter_e, tmp1, tmp2;
  gint i=0;
  gboolean result = FALSE;

  if (!strings || NULL==strings[0]) 
    return FALSE;

  from_cpy = *from;

  //Get number of strings first
  min_line_nr = i = 0;
  while (NULL!=strings[i++])
    ;

  nr_strings = i-1;
  //MSG1("   [forward_search_strings(): line0:<%s>",gtk_text_iter_get_slice(start, limit));
  //search for the first tag
  for (i=0;i<nr_strings;i++) {
    if (!gtk_text_iter_forward_search(&from_cpy, strings[i], sflag,
				    &min_iter_s, &min_iter_e, limit)) 
    {
    result |= FALSE;
    continue;
    }
    else {
      *idx = i;
      result |= TRUE;
      break;
    }
  }

  if (result) 
    min_line_nr = gtk_text_iter_get_line(&min_iter_s);

  i++;
  while (NULL != strings[i] && i<nr_strings) {
    if (gtk_text_iter_forward_search(&from_cpy, strings[i], sflag,
				     &tmp1, &tmp2, limit)) {
      result |= TRUE;

      if (gtk_text_iter_get_line(&tmp1) < min_line_nr) {
	min_iter_s = tmp1;
	min_iter_e = tmp2;
	min_line_nr = gtk_text_iter_get_line(&min_iter_s);
	*idx = i;
      }
    }
    else 
      ERR1("  [forward_search_strings(): Not found %s\n",strings[i]);

    i++;
  }
  
  if (result) {
    *start = min_iter_s; *end = min_iter_e;
  }
  return result;
}







#if 0

void collect_blk_info_XIP (GList** l, GtkTextBuffer* text, char* nr_tag, 
			   char** blk_start_tags, char** blk_end_tags) 

{
    int line_nr = -1;
    int found_num_TAG = 0;
    int end_finding_blk = 1;
    int j;
    gchar* line;//[256];
    int blk_nr, start_l, start_pos, end_l, end_pos;
    char* substr_pos;

    GtkTextIter iter, iter_limit, iter_s, iter_e;
    GtkTextSearchFlags sflag;
    gint index;

    if (!text) {
      fprintf(OUT, "  [collect_blk_info_XIP(): %p, %p. NULL pointer not allowed!\n",(*l),text);
      exit(-1);
    }

    gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text),&iter);
    gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text),&iter_limit);

    blk_nr=start_l=start_pos=end_l=end_pos=-1;

    while (forward_search_strings(&iter,
				  blk_start_tags, &index,
				  sflag,
				  &iter_s,
				  &iter_e, &iter_limit)) 
      {
	line_nr = gtk_text_iter_get_line(&iter_s);;
	gtk_text_iter_forward_sentence_end(&iter_e);
	line = gtk_text_iter_get_slice(&iter_s, &iter_e);

	if ((substr_pos = g_strrstr(line,nr_tag)) != NULL) {
	  //found block num tag
	  found_num_TAG = 1;
	  end_finding_blk = 0;
	  blk_nr = get_blk_nr(line);
	}
	if ((substr_pos = g_strrstr(line,blk_start_tags[index])) != NULL) 
	  {
	    start_l = line_nr;
	    start_pos = gtk_text_iter_get_offset(&iter_s);
	  }	
	
	//forward iter
	gtk_text_iter_set_offset(&iter, gtk_text_iter_get_offset(&iter_e));
	//forward search for the matching closing tag
	if (!forward_search_strings(&iter, blk_end_tags, &index,
				    sflag,
				    &iter_s, &iter_e, &iter_limit))
	  {
	    end_l = gtk_text_iter_get_line(&iter_e +1);
	    end_pos = gtk_text_iter_get_offset(&iter_e) +
	      gtk_text_iter_get_chars_in_line(&iter_e);
	  }
	else {
	  line = gtk_text_iter_get_slice(&iter_s, &iter_e);
	  fprintf(OUT, "  [collect_blk_info_XIP(): 2 line=<%s>\n",line);
	  if ((substr_pos = g_strrstr(line,blk_end_tags[index]))!=NULL) {
	    end_l = gtk_text_iter_get_line(&iter_s);
	    end_pos = gtk_text_iter_get_offset(&iter_e) - 1;
	    if (found_num_TAG)
	      end_finding_blk = 1;
	    else /* bad formed */
	      found_num_TAG = 0;
	  }
	}
	
	if (found_num_TAG && end_finding_blk) {
	  *l = update_blk_list(*l,blk_nr, start_l,end_l,start_pos,
			       end_pos);
	  found_num_TAG = 0;
	  end_finding_blk = 0;
	}
	
	gtk_text_iter_set_offset(&iter, gtk_text_iter_get_offset(&iter_e));
      }
    //    return l;
}

#endif









void collect_blk_info_SIP (GList** l, GtkTextBuffer* text, char* nr_tag, 
		       char* blk_start_tag,
		       char* blk_end_tag) 
{
  collect_blk_info_SIP_real(0,l,text,nr_tag,blk_start_tag,blk_end_tag);
}








/* The return value shall be the cursor position which even has been
   forwarded in the recursion */
int collect_blk_info_SIP_real (int start_from, GList** l, 
				GtkTextBuffer* text, char* nr_tag, 
				char* blk_start_tag,
				char* blk_end_tag) 
{
    int line_nr = -1;
    int found_num_TAG = 0;
    int end_finding_blk = 1;
    gchar* line;//[256];
    int blk_nr;
    gchar* blk_name = NULL;
    int start_l,start_pos,end_l,end_pos;
    gchar* substr_pos;

    GtkTextIter iter, iter_limit, iter_s, iter_e;
    GtkTextIter iter_tmp_1_s, iter_tmp_1_e;// iter_tmp_2_s, iter_tmp_2_e;
    int tmp_1;
    int tmp_2;
    GtkTextSearchFlags sflag;

    if (!text) {
      ERR2("  [collect_blk_info_SIP(): %p, %p. NULL pointer not allowed!\n",(*l),text);
      exit(-1);
    }

    gtk_text_buffer_get_start_iter(text,&iter);
    gtk_text_iter_set_offset(&iter, start_from);
    gtk_text_buffer_get_end_iter(text,&iter_limit);

    blk_nr=start_l=start_pos=end_l=end_pos=-1;
    //gtk_text_set_point(GTK_TEXT(text),0);//start
    //j =gtk_text_get_point(GTK_TEXT(text));
    //fprintf(OUT, " [collect_blk_info_SIP(): after get...iter()\n");
    while (gtk_text_iter_forward_search(&iter,
					blk_start_tag,
					sflag,
					&iter_s,
					&iter_e, &iter_limit) &&
	   !found_num_TAG) 
      {
	tmp_1 = tmp_2 =0;
	line_nr = gtk_text_iter_get_line(&iter_s);
	//Assume <block num="?"> finished in the same one line
	gtk_text_iter_forward_sentence_end(&iter_e);
	line = gtk_text_iter_get_slice(&iter_s, &iter_e);

	//MSG1("  [collect_blk_info_SIP(): 1 line=<%s>",line);
	//parse the line
	if ((substr_pos = g_strrstr(line,nr_tag)) != NULL) {
	  //found block name tag
	  found_num_TAG = 1;
	  end_finding_blk = 0;
	  //blk_nr = get_blk_nr(line);
	  blk_name = get_blk_name(line);
	}
	if ((substr_pos = g_strrstr(line,blk_start_tag)) != NULL) {
	  start_l = line_nr;
	  start_pos = gtk_text_iter_get_offset(&iter_s);
	}	

	//forward iter
	gtk_text_iter_set_offset(&iter, gtk_text_iter_get_offset(&iter_e));

	//Considering nested blk
	if (gtk_text_iter_forward_search(&iter, blk_start_tag, sflag,
					 &iter_tmp_1_s, &iter_tmp_1_e,
					 &iter_limit)) 
	  {
	    tmp_1 = gtk_text_iter_get_offset(&iter_tmp_1_s);
	  }
	else 
	  tmp_1 = -1;

	if (gtk_text_iter_forward_search(&iter, blk_end_tag, sflag,
					 &iter_tmp_1_s, &iter_tmp_1_e,
					 &iter_limit))
	  {
	    tmp_2 = gtk_text_iter_get_offset(&iter_tmp_1_s);
	  }
	else 
	  tmp_2 = -1;

	if (tmp_1 < tmp_2 && tmp_1 != -1 && tmp_2 != -1) {
	  int i;
	  //Recursive Call !!!!!!!
	  i = gtk_text_iter_get_offset(&iter);
	  start_from = collect_blk_info_SIP_real (i, l, text, SIP_BLK_NUM_TAG,
				     SIP_START_BLK_TAG, 
			       SIP_END_BLK_TAG);
	  gtk_text_iter_set_offset(&iter, start_from);	  
	}
	
	//forward search for the matching </block>
	if (!gtk_text_iter_forward_search(&iter, blk_end_tag, sflag,
					  &iter_s, &iter_e, &iter_limit))
	  {
	    ERR("  [collect_blk_info_SIP(): Unmatched blk tag! Default value assigned!\n");
	    end_l = gtk_text_iter_get_line(&iter +1);
	    end_pos = gtk_text_iter_get_offset(&iter_e) +
	      gtk_text_iter_get_chars_in_line(&iter_e);
	  }
	else {
	  line = gtk_text_iter_get_slice(&iter_s, &iter_e);
	  MSG1( "  [collect_blk_info_SIP(): 2 line=<%s>",line);
	  if ((substr_pos = strstr(line,blk_end_tag))!=NULL) {
	    end_l = gtk_text_iter_get_line(&iter_s);
	    end_pos = gtk_text_iter_get_offset(&iter_e) - 1;
	    if (found_num_TAG)
	      end_finding_blk = 1;
	    else /* bad formed */
	      found_num_TAG = 0;
	  }
	}	

	if (found_num_TAG && end_finding_blk) {
	  *l = update_blk_list(*l,blk_nr,blk_name,start_l,end_l,start_pos,
			       end_pos);
	  found_num_TAG = 0;
	  end_finding_blk=0;
	}
	
	gtk_text_iter_set_offset(&iter, gtk_text_iter_get_offset(&iter_e));
      }
    return (gtk_text_iter_get_offset(&iter));;
}







void get_line_from_text(GtkWidget* text, guint start_point, gchar* line)
{
  int cursor = start_point;
  int i=0;
  gchar* ch=NULL;
  
  do {
    if (ch) g_free(ch);
    ch = gtk_editable_get_chars(GTK_EDITABLE(text),cursor,cursor+1);
    cursor++;
    line[i++]=ch[0];
  } while (10!=ch[0] && 13!=ch[0] && EOF!=ch[0]);
  
  g_free(ch);
  line[i] = '\0';
  
  gtk_editable_set_position(GTK_EDITABLE(text),start_point+i);
}

  








GList* update_blk_list(GList* l, int blk_nr, gchar* blk_name, int start_l, 
  int end_l,int start_pos, int  end_pos)
{
  blk_info* bi = malloc(sizeof(blk_info));
  bi->block_name = malloc(strlen(blk_name)+1);

  bi->block_num = blk_nr;
  bi->block_name = g_strdup(blk_name);
  bi->start_line = start_l;
  bi->end_line = end_l;
  bi->start_char = start_pos;
  bi->end_char = end_pos;
  l = g_list_append(l,bi);

  g_free(blk_name);

  return l;
} 






/* 
 * Assume blk_nr is quoted in the format of `num="*"`
 * SIP_BLK_NUM_TAG is `num="`
 *                          ^start
 */
int get_blk_nr(char* str) {
  int i=0;
  int start;
  int sum=0;//the return value

  char* s = NULL;

  do {
    s = strstr(&str[i++],SIP_BLK_NUM_TAG);
  } while (s != NULL);
  
  start = i + strlen(SIP_BLK_NUM_TAG) - 1;
  while (str[start] != '"') {
    sum = sum*10 + (str[start] - '0');
    start++;
  }
  
  return sum;
}







/*
 * This is for the updated version of the SIP=>XIP Python parser. We used
 * to have only the block_nr in the blk_info struct. Now we use blk_name
 * instead of blk_nr to do the block matching.
 * SIP_BLK_NUM_TAG is `name="`
 *                           ^start
 */
gchar* get_blk_name(gchar* str) {
  int i=0;
  int start;
  gchar* str_val = "";

  gchar* s = NULL;
  gchar s1[2];

  do {
    s = strstr(&str[i++],SIP_BLK_NUM_TAG);
  } while (s != NULL);
  
  start = i + strlen(SIP_BLK_NUM_TAG) - 1;
  while (str[start] != '"') {
    g_snprintf(s1,2,"%c",str[start]);
    s1[1]='\0';
    str_val = g_strconcat(str_val, s1, NULL);
    start++;
  }
  
  MSG1(" [get_blk_name(): (%s)\n", str_val);
  return str_val;
}







/*
 * Must be called after gtk_init()
 */  
void color_font_init()
{
  /*Deprecated*/
  /*
  if ((fixed_font = gdk_font_load (C_SRC_FONT)) == NULL
      || (large_font = gdk_font_load(C_SRC_FONT_LARGE)) == NULL 
      || (small_font = gdk_font_load(C_SRC_FONT_SMALL)) ==NULL) {
    fprintf(OUT, "  font NOT found\n");
  }
  */
  cmap = gdk_colormap_get_system();
  /* Red indicates the highlighted lines of code*/
  color_red.red = 0xffff;
  color_red.green = 0x0;
  color_red.blue = 0x0;
  /* White covers the chars which won't be displayed*/
  color_white.red = 0xffff;
  color_white.green = 0xffff;
  color_white.blue = 0xffff;
  /* Black is the default color for the displayed source code*/
  color_black.red=0x0;
  color_black.green=0x0;
  color_black.blue=0x0;

  if (!gdk_color_alloc(cmap, &color_red) || 
      !gdk_color_alloc(cmap,&color_white) ||
      !gdk_color_alloc(cmap,&color_black)) {
    ERR(" [color_font_init(): couldn't allocate color");
  }

  color_basic = color_black;
  color_highlight=color_red;
}  





/* 
 * Assign the string constants. Get the files infomation (names, path)
 * needed in the interface. But source files are not read yet.
 */
void const_init() 
{
  int i;

  /*Remove the blockXip.xml if exists (generated by previous run)*/
  for (i=0;i<NR_XIP_FILE;i++) {
    if (remove(XIP_FILE[i])==0) {
      MSG1(" [const_init(): %s removed",XIP_FILE[i]);
    }
  }

  // if (!strcmp(curr_demo->name, "UAV")) {
  for (i=0;i<NR_XIP_FILE;i++) {
    if (remove(REAL_XIP_FILE[i])==0) {
      MSG1(" [const_init(): %s removed",REAL_XIP_FILE[i]);
    }
  }
  //}

  /*Remove the generated code if exists*/
  for (i=0;i<NR_GENCODE_FILE; i++) {
    if (remove(GENCODE_FILE[i]) == 0) 
      MSG1(" [const_init(): %s removed",GENCODE_FILE[i]);
    else
      ERR1(" [const_init(): %s can not be removed\n",GENCODE_FILE[i]);
  }
}






int load_one_file(GtkTextBuffer* text, char* name, char* mode, 
		  C_SRC_FONT_SIZE font_size)
{
  FILE* infile;

  if (NULL!=(infile=open_file(name,mode))) {
    insert_file(text,font_size,infile);
    fclose(infile);
    return 1;
  }
  else {
    ERR1(" [load_one_file(): file >%s< NOT found\n",name);
    return 0;
  }
}


int save_blk_SIP_2_SIP_file(gchar* text, char* name, char* mode)
{
  FILE* outfile;
  int nchars = 0;
  int nr = 0;
  char line[1024];
  gchar* ptr = text;

  if (NULL!=(outfile=open_file(name,mode))) {
    while (*ptr != '\0') {
      while (*ptr != '\n') {
	line[nchars++] = *ptr;
	ptr ++;
      }
      line[nchars] = '\n'; line[nchars+1]='\0';
      if (NULL == g_strstr_len(line, nchars, SIP_START_BLK_TAG) &&
	  NULL == g_strstr_len(line, nchars, SIP_BLK_TAG_OTHER_1) &&
	  NULL == g_strstr_len(line, nchars, SIP_BLK_TAG_OTHER_2) &&
	  NULL == g_strstr_len(line, nchars, SIP_END_BLK_TAG) )
	{
	  MSG1(">%s<",line);
	  nr = fwrite(line, 1, nchars+1, outfile);
	}
      ptr++;
      nchars = 0;
    }

    if (outfile) fclose(outfile);
    return 1;
  }
  else {
    ERR1(" [save_blk_SIP_2_SIP_file(): file >%s< NOT found\n",name);
    return 0;
  }
}
  



/*
 * Try to load as many files which can be found into the GUI
 */
void load_files() {
  int i;
  //GdkFont* fixed_font;
  FILE* sip_file_in;
  gchar* tmp_str=NULL;

  /* This is weird, but working for python SIP=>XIP code */
  /* See ISG_ROOT/sip2xml/csiplex.c */
  /* Read SIP file first into string */
  /* ======================================*/
  /* Nov 11, 02: Young did the 2nd version of the SIP=>XIP parser. So
     the following is obsolete and being replaced by the getBlockSip(
     char* filename) */
  /*
  for (i=0;i<NR_SIP_FILE;i++) {  
    if ((sip_file_in=open_file(REAL_SIP_FILE[i] ,"r"))==NULL) {
      fprintf(OUT, " [load_files(): input SIP file not found\n");
      gtk_exit(-1);
    }
    i = read_file_into_str(sip_file_in,&SIP_str_real);

    fprintf(OUT, " [load_files(): sip_str_real: >%s<\n, len: %d\n",
	    SIP_str_real,i);
    fclose(sip_file_in);
  }

  if (0>=i) {
    fprintf(OUT, " [load_files(): input SIP file empty\n");
    gtk_exit(0);
  }

  parseString(SIP_str_real);
  tmp_str = getBlockSip();
  */

  /* Read in the real SIP (w/o block info) file and call python parser and
     then write to the corresponding SIP_FILE (with block info)*/
  for (i=0;i<NR_SIP_FILE;i++) {  
    tmp_str = (gchar*)getBlockSip(REAL_SIP_FILE[i]);
    //Hard to control error
    //gtk_exit(-1);
    if (!tmp_str) {
      ERR(" [load_files(): Got empty SIP from the parser");
      return;
    }

    /* May 4, 03: the most recent block_SIP is replicated for restoring if necessary*/
    last_blk_SIP = g_strdup (tmp_str);

    MSG2(" [load_files(): blk SIP: >%s<\n, len: %d",tmp_str,strlen(tmp_str));
    /*write to SIP_file*/
    if ((sip_file_in = open_file(SIP_FILE[i],"w"))==NULL) {
      ERR1(" [load_files(): cannot open file %s for write", SIP_FILE[i]);
      gtk_exit(-1);
    }
    fwrite(tmp_str, 1, strlen(tmp_str), sip_file_in);
    MSG1(" [load_files(): file %s is writen",SIP_FILE[i]);
    fclose(sip_file_in);
  }

  if (tmp_str) g_free(tmp_str);

  for (i=0;i<NR_DEMO_SRC_FILE;i++) {
    if (load_one_file(text_demo_src_file_buf[i], DEMO_SRC_FILE[i],
		      "r",font_size)) {
    MSG2(" [load_files(): %d char read from %s",
	 gtk_text_buffer_get_char_count(GTK_TEXT_BUFFER(text_demo_src_file_buf[i])),DEMO_SRC_FILE[i]);
    }
  }

  for (i=0;i<NR_SIP_FILE;i++) {
    if (load_one_file((text_SIP_file_buf[i]), SIP_FILE[i], "r", font_size)) {
      MSG2( " [load_files(): %d char read from %s",
	      gtk_text_buffer_get_char_count(GTK_TEXT_BUFFER(text_SIP_file_buf[i])),SIP_FILE[i]);
      update_file_text_list_file(SIP,SIP_FILE[i],
		     gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));    
      update_file_text_list_text(text_SIP_file[i], (text_SIP_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));
      update_file_text_list_blk_list((text_SIP_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));
      SIP_file_created &= TRUE;
    }
    else {
      SIP_file_created &= FALSE;
    }
  }

  /* the block file will be loaded later actually*/
  for (i=0;i<NR_XIP_FILE;i++) {
    if (load_one_file((text_XIP_file_buf[i]), XIP_FILE[i], "r", font_size)) {
      update_file_text_list_file(XIP, XIP_FILE[i],
     		 gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));    
      update_file_text_list_text(text_XIP_file[i], (text_XIP_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
      update_file_text_list_blk_list((text_XIP_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
      XIP_file_created &= TRUE;
    }
    else 
      XIP_file_created &= FALSE;
  }

  for (i=0;i<NR_GENCODE_FILE;i++) {
    if (load_one_file((text_gencode_file_buf[i]), GENCODE_FILE[i], "r", font_size))
      {
	update_file_text_list_file(GENCODE, GENCODE_FILE[i],
	     gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));    
	update_file_text_list_text(text_gencode_file[i],
				   (text_gencode_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));
	update_file_text_list_blk_list((text_gencode_file_buf[i]),
		       gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));
	gencode_file_created &= TRUE;
      }
    else 
      gencode_file_created &= FALSE;
  }

  //MSG1(" [load_files(): gencode_file_created: %d",gencode_file_created);
  for (i=0;i<NR_DEMO_ISG_FILE;i++) {
    load_one_file((text_demo_isg_file_buf[i]), DEMO_ISG_FILE[i], "r", font_size);
  }

  //Load the stats file
  if (!stats_input) {
    if ((stats_input = open_file(STATS_FILE,"r")) == NULL) 
      {
	ERR1(" [load_files(): file %s open error\n",STATS_FILE);
      }
  }

#ifdef DEBUG
  dump_file_text_list();
#endif

}






FILE* open_file(char* path, char* mode)
{
  FILE* file;
  if ( (file=fopen(path, mode)) == NULL) {
    ERR1("Error reading file >%s<\n",path);
    return NULL;
  }

  return file;
}








int read_file_into_str (FILE* file, char** str) 
{
  char** pts = str;
  char* tmp_pts;
  int s = 1025;

  if (file) {
    int nchars;
    int len=0;
    int loop=1;
    char buffer[s];
    *pts = malloc(sizeof(char)*s);
    (*pts)[len]='\0';

    while (1)
      {
        nchars = fread(buffer, 1, s-1, file);
        strncat(*pts,buffer,nchars);
	len += nchars;
	(*pts)[len]='\0';
	//MSG2( " [read_file_into_str(): >%s<, len: %d",*pts,len);
        if (nchars < s-1)  
          break;
	else {
	  tmp_pts = malloc(sizeof(gchar)* s *(loop+1));
	  strncpy(tmp_pts,*pts, (s-1)*loop);
	  tmp_pts[(s-1)*loop]='\0';
	  //MSG2(" [read_file_into_str(): >%s<, tmp_pts len: %d",tmp_pts,len);
	  free(*pts);
	  *pts = tmp_pts;
	}

	loop++;
      }
    return len;
  }

  return 0;
}









#if 0 

void create_block_SIP_XIP_file()
{
  //e.g ./isg -s tests/bwprobe.xml -t templates/ECho.xml
  char* args[6];
  pid_t pid;
  args[0] = concat(ISG_ROOT,"/sip2xml/runTest");
  args[1] = NULL;

  pid = fork();
  if (0==pid) {
    fprintf(OUT, " [create_SIP_file(): creating block SIP file ...\n");
    execvp(args[0],args);
  }
  else if (-1!=pid) {
    signal(SIGCHLD, (void*)wait_child_end);
    //waitpid(pid,NULL,0);
  }
  else {
    fprintf(OUT, " [create_SIP_file(): error starting create_SIP_file\n");
  }
}

#endif








/* Used in displaying the info window in the cfg page */
void 
insert_curr_demo_info (GtkWidget* text_view)
{
  GtkTextIter iter;
  gint i;
  GList* t;

  GtkTextBuffer* text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
  if (!curr_demo)
    return;

  gtk_text_buffer_get_end_iter (text_buf, &iter);

  gtk_text_buffer_insert (text_buf, &iter, " Name of the demo: ", -1);
  gtk_text_buffer_insert (text_buf, &iter, curr_demo->name, -1);
  gtk_text_buffer_insert (text_buf, &iter, "\n Config file: ",-1);
  gtk_text_buffer_insert (text_buf, &iter, curr_demo->cfg_file, -1);
  gtk_text_buffer_insert (text_buf, &iter, "\n",-1);
  
  if (curr_demo->demo_src_file) {
    gtk_text_buffer_insert (text_buf, &iter, " Demo src file list: \n",-1);
    t = curr_demo->demo_src_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->demo_isg_file) {
    gtk_text_buffer_insert (text_buf, &iter, " Demo src (isg version) file list: \n",-1);
    t = curr_demo->demo_isg_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->gencode_file) {
    gtk_text_buffer_insert (text_buf, &iter, " ISG gencode file list: \n",-1);
    t = curr_demo->gencode_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->SIP_file) {
    gtk_text_buffer_insert (text_buf, &iter, " SIP file list: \n",-1);
    t = curr_demo->SIP_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->REAL_SIP_file) {
    gtk_text_buffer_insert (text_buf, &iter, " REAL SIP file list: \n",-1);
    t = curr_demo->REAL_SIP_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->XIP_file) {
    gtk_text_buffer_insert (text_buf, &iter, " XIP file list: \n",-1);
    t = curr_demo->XIP_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->REAL_XIP_file) {
    gtk_text_buffer_insert (text_buf, &iter, " REAL XIP file list: \n",-1);
    t = curr_demo->REAL_XIP_file;
    for (i=0;i<g_list_length(t);i++) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,(gchar*)g_list_nth_data(t,i),
			     -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  if (curr_demo->stats_file) {
    gchar* tmp=NULL;
    gtk_text_buffer_insert (text_buf, &iter, " stats file: \n",-1);
    tmp = curr_demo->stats_file;
    if (tmp) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,tmp, -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }
   
  if (curr_demo->run_isg_script) {
    gchar* tmp=NULL;
    gtk_text_buffer_insert (text_buf, &iter, " isg run script: \n",-1);
    tmp = curr_demo->run_isg_script;
    if (tmp) {
      gtk_text_buffer_insert(text_buf,&iter, "           ",-1);
      gtk_text_buffer_insert(text_buf,&iter,tmp, -1);
      gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
    }
  }

  gtk_text_buffer_insert(text_buf, &iter, "\n", -1);
  //gtk_text_buffer_place_cursor(text_buf, &iter);
  gtk_text_buffer_get_end_iter(text_buf, &iter);
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(text_view), &iter,
  		       0,TRUE,0,0);
}







  
void insert_file(GtkTextBuffer* text, C_SRC_FONT_SIZE font_size, FILE* file) 
{
  if (file) {
    gchar buffer[1024];
    int nchars;
    GtkTextIter iter;
    GtkTextTagTable* tag_table;

    tag_table = gtk_text_buffer_get_tag_table(text);

    if (normal_tag)
      g_object_unref(G_OBJECT(normal_tag));
    normal_tag = gtk_text_tag_new("normal");

    //g_object_set(G_OBJECT(normal_tag), "family", "courier", NULL);
    if (font_size == MEDIUM) {
      g_object_set(G_OBJECT(normal_tag), "size", 10*PANGO_SCALE, NULL);
    }
    else if (font_size == LARGE) {
      g_object_set(G_OBJECT(normal_tag), "size", 12*PANGO_SCALE, NULL);
    }
    else {
      g_object_set(G_OBJECT(normal_tag), "size", 8*PANGO_SCALE, NULL);
    }


    if (!gtk_text_tag_table_lookup(tag_table, "normal"))
      gtk_text_tag_table_add(tag_table, normal_tag);

    
    gtk_text_buffer_get_end_iter (text, &iter);

    gtk_text_buffer_begin_user_action(GTK_TEXT_BUFFER(text));

    while (1)
      {
        nchars = fread(buffer, 1, 1023, file);
	buffer[nchars] = '\0';
        //gtk_text_insert (GTK_TEXT (text), font, &color_basic,
        //                 NULL, buffer, nchars);
	gtk_text_buffer_insert_with_tags(text, &iter, (gchar*)buffer, -1,
					 gtk_text_tag_table_lookup(tag_table,
								   "normal"),
					 NULL);
        if (nchars < 1023)
          break;
      }

    gtk_text_buffer_end_user_action(GTK_TEXT_BUFFER(text));

  }
}

