/*
 * $Id: const.h,v 1.1.1.1 2003/06/11 21:16:01 wyan Exp $
 * $Log: const.h,v $
 * Revision 1.1.1.1  2003/06/11 21:16:01  wyan
 * demoHarness
 *
 * Revision 1.9  2002/11/22 16:22:32  wyan
 * *** empty log message ***
 *
 * Revision 1.5  2002/11/06 21:51:20  wyan
 * *** empty log message ***
 *
 * $Revision: 1.1.1.1 $
 */
#ifndef _CONST_H
#define _CONST_H

#include <stdio.h>
#include <gtk/gtk.h>
#include <glib.h>

/*For Dump window or debug, comment out the following line if 
  not use stdout as output sink*/
#define USE_STDOUT 
#define DEBUG

#ifdef USE_STDOUT
#define OUT stdout
#else
#define OUT OS
extern FILE* OS;
#define OS_FILE_NAME "dump.txt"
#endif




#ifdef DEBUG
#define MSG(msg) fprintf(OUT, "%s\n", msg)
#define MSG1(msg, arg) fprintf(OUT, "" msg "\n", arg)
#define MSG2(msg, arg1, arg2) fprintf(OUT, "" msg "\n", arg1, arg2)
#define MSG3(msg, arg1, arg2, arg3) fprintf(OUT, "" msg "\n", arg1, arg2, arg3)
#else 
#define MSG(msg) 
#define MSG1(msg, arg)
#define MSG2(msg, arg1, arg2)
#define MSG3(msg, arg1, arg2, arg3)
#endif



#define ERR(msg) fprintf(OUT, "%s (line: %i), %s\n", __FILE__, __LINE__, msg)
#define ERR1(msg, arg) fprintf(OUT, "%s (line: %i) " msg "\n", __FILE__, __LINE__, arg)
#define ERR2(msg, arg1, arg2) fprintf(OUT, "%s (line: %i) " msg "\n", __FILE__, __LINE__, arg1, arg2)


/* If we want the animation at the start*/
//#define HAVE_ANIMATION


/* THe main window size */
/* This is the main window for the whole demo */
extern GtkWidget* window;
#define MAIN_WIN_WIDTH 600
#define MAIN_WIN_HEIGHT 500


/* The top notebook: includes the 1st page 'notebook_img' for the animation,
   and the 2nd page for the window_main for the demo. This will be added to 
   'window' */
extern GtkWidget* notebook_top;




#define STRING(str) #str
/*Predefined length for str constants used*/
#define STR_CONST_LENGTH_LONG 128
#define STR_CONST_LENGTH_SHORT 32


/*The # of items in the main menu - clist*/
#define MENU_SIZE 9



/*This is the file describes the outline of the ISG demo. The init 
  of the whole ISG demo needs this */
#define DEMO_RC_FILE STRING(/opt/Infopipes/tools/yadd/conf/demos.rc)

/* The root of the executable of this demo*/
#define DEMO_ROOT STRING(/opt/Infopipes/isg)





/* The demo_info struct has all the information related to the 
   demo displayed in the ISG demo
*/
typedef struct demo_info_struct demo_info;

struct demo_info_struct 
{
  /* Name of the demo*/
  char* name;
  /* Name of the cfg_file*/
  char* cfg_file;
  /* List of the file names of all the demo_src_file*/
  GList* demo_src_file;
  /* List of the file names of all the modified isg version of the 
     demo src */
  GList* demo_isg_file;
  /* List of the file names of all the generated code*/
  GList* gencode_file;
  /* List of the file names of all the SIP files*/
  GList* SIP_file;
  /* List of the file names of all the XIP files*/
  GList* XIP_file;
  /* List of the file names of all the SIP files (without block info)*/
  GList* REAL_SIP_file;
  /* List of the file names of all the XIP files (without block info)*/
  GList* REAL_XIP_file;
  /* Name of the stats file which contains the facts related to the demo*/
  char* stats_file;
  /* Name of the script (full path) to run isg to gen code*/
  char* run_isg_script;
};



/* The list stores all the demos showed in the ISG demo. Each node of 
   the list is a demo_info_struct */
extern GList* ALL_DEMO;

/* All the info about the demo currently shown */
extern gchar* dflt_demo; //== curr_demo->name
extern demo_info* curr_demo;
extern gchar* str_conf_file;/*current conf file*/
extern gchar* str_demo_src_root;/*current demo_src_root*/
extern gchar* str_demo_isg_root;/*current isg version of demo_src_root*/
extern gchar* str_gencode_root;/*current isg generated code root*/



/////////////////////////////////
//TO BE DELETED
extern gchar* str_demo_src_root;
extern gchar* str_demo_isg_root;
extern gchar* str_isg_root;
//
//////////////////////////////



extern int NR_DEMO_SRC_FILE;
extern int NR_SIP_FILE;
extern int NR_XIP_FILE;
extern int NR_GENCODE_FILE;
extern int NR_DEMO_ISG_FILE;



extern gchar** DEMO_SRC_FILE;
extern gchar** SIP_FILE;
extern gchar** XIP_FILE;
extern gchar** GENCODE_FILE;
extern gchar** DEMO_ISG_FILE;


/* This the input of the Python SIP=>XIP parser */
extern gchar** REAL_SIP_FILE;

/* This the real input of isg */
extern gchar** REAL_XIP_FILE;

/* Each displayed demo has a fact sheet related to itself*/
extern gchar* STATS_FILE;
extern FILE* stats_input;

/* The script to call ISG based on the spec/template of each demo*/
extern gchar* RUN_ISG_SCRIPT;




/*char arrays of path values in cfg_windown*/
extern gchar* clist_cfg_path_value[3][2];

/*Font & color*/
extern GdkFont* fixed_font;
extern GdkFont* large_font;
extern GdkFont* small_font;
extern GdkColor color_white, color_red, color_black;
extern GdkColor color_basic,color_highlight;
extern GdkColormap *cmap;




/*FONT sets for C src files*/
/*Gdkfont is deprecated. Use Pango now*/
/*
#define C_SRC_FONT STRING(-misc-fixed-medium-r-*--*-140-*-*-*-*-iso8859-1)
#define C_SRC_FONT_LARGE STRING(-misc-fixed-bold-r-*--*-140-*-*-*-*-iso8859-1)
#define C_SRC_FONT_SMALL STRING(-misc-fixed-medium-r-*--*-110-*-*-*-*-iso8859-1)
*/



typedef enum 
{
  SMALL, MEDIUM, LARGE
} C_SRC_FONT_SIZE;

extern C_SRC_FONT_SIZE font_size;




/*config file names under conf dir. You need to modify the content
  of these files to set the right paths for the demo*/
#define conf_DIR STRING(/yadd/conf)
#define conf_DEMO_SRC_FILE STRING(/demo_src_file)
#define conf_SIP_FILE STRING(/SIP_file)
#define conf_XIP_FILE STRING(/XIP_file)
#define conf_GENCODE_FILE STRING(/gencode_file)

/*this is the same as /demo_src_file, but the prepended dir is different */
#define conf_DEMO_ISG_FILE STRING(/demo_src_file)


//Flags
extern gboolean SIP_file_created;
extern gboolean XIP_file_created ;
extern gboolean gencode_file_created ;


//XXX
//Modify this macro accordingly. The ISG generator uses this file 
//-- not the one above. XIP_FILE includes block info which is ONLY
//for this demo purpose.
//This is weird, but it is created for calling python SIP=>XIP routine.
//char* SIP_str_real;
//char* XIP_str_real;
//#define SIP_FILE_REAL "multiuav.sip" /*"/sip2xml/siptest.sip"*/
//#define XIP_FILE_REAL "/tests/bwprobe.xml"
//#define XIP_TEMPLATE_REAL "/home/wyan/Infosphere/isg/tests/AV/XSLT/UAV.xsl"
/* /templates/ECho.xml"*/



//The data struct for displayed files & their text area
typedef enum {
  SIP=0,
  XIP,
  GENCODE,
  SRC,
  SRC_ISG,
} demo_file_type;






typedef struct isg_file_text_object file_text;
typedef struct display_block_info blk_info;

/*The list stores the isg_file_text_object*/
GList* file_text_list;

struct isg_file_text_object {
  demo_file_type type;
  gchar* file; //whole path of the related src file
  gchar* name; //name of the object
  GtkWidget* text; //text_view area to display the file
  GtkTextBuffer* text_buf;//text_buffer to store the file
  GList* blk_list; //list of blk_info
};



struct display_block_info {
  /* block_num becomes obsolete because python parser outputs string 
     block info instead of numbers */
  gint block_num;
  gchar* block_name;
  gint start_line;
  gint end_line;
  gint start_char; //the start cursor place
  gint end_char; // the ending cursor place
};



//XXX
//These are used in mapping the block among SIP,XIP and GENCODE
#define SIP_BLK_NUM_TAG STRING(name=)
#define SIP_START_BLK_TAG "<block " /* the ending space is important*/
#define SIP_BLK_TAG_OTHER_1 STRING(<blockSip>)
#define SIP_BLK_TAG_OTHER_2 STRING(</blockSip>) /*STRING(</block)*/
#define SIP_END_BLK_TAG STRING(</block>)


/* The new version of SIP=>XIP Python parser changes the output of 
   block XIP, which then is very the same as block SIP*/
#define XIP_BLK_NUM_TAG STRING(name=)
#define XIP_START_BLK_TAG "<block "
#define XIP_END_BLK_TAG STRING(</block>)



extern gchar* ALL_SIP_BLK_TAGS[];
extern gchar* ALL_XIP_BLK_TAGS[];



//The tag table
//extern GtkTextTagTable* text_tag_table;
extern GtkTextTag* hidden_tag;
extern GtkTextTag* highlight_tag;
extern GtkTextTag* normal_tag;


extern GtkWidget** label_gencode_file;





//void reset_curr_demo();

/*Recreate all the widgets in each notebook*/
void recreate_notebooks_widgets();

/*Destroy the dialog widgets*/
void destroy_dialog_widgets();

/*Destroy the widget componet*/
void destroy_notebooks_widgets();

/*Clear the textbuffer displaying the facts*/
void clear_text_stats ();

void set_curr_demo(demo_info* di);

void init_rc();

int int_to_str(char* str, int i);

int read_src_file_list(char* path, char*** file_list_ptr, int* nr, char* dir);

char* concat(char* s1, char* s2);

void const_init();

void color_font_init();

FILE* open_file(char* path, char* mode);

void 
insert_curr_demo_info (GtkWidget* text_view);

void insert_file(GtkTextBuffer* text, C_SRC_FONT_SIZE font_size, FILE* file);

void load_files();

int load_one_file(GtkTextBuffer* text, char* name, char* mode, 
		  C_SRC_FONT_SIZE font_size);

int save_blk_SIP_2_SIP_file(gchar* text, char* name, char* mode);

int read_file_into_str (FILE* file, char** str) ;

void create_SIP_XIP_file ();

//Used for block matching in SIP,XIP and GENCODE
void update_file_text_list_file(demo_file_type type, char* file, 
				const gchar* widget_name);

void update_file_text_list_text(GtkWidget* text, GtkTextBuffer* text_buf,
				const gchar* widget_name);

int find_node_in_file_text_list(const gchar* widget_name);

void update_file_text_list_blk_list(GtkTextBuffer* text, 
				    const gchar* widget_name);

GList* parse_text(GtkTextBuffer* text, const gchar* widget_name);

/*
void collect_blk_info_XIP (GList** l, GtkTextBuffer* text, char* nr_tag, 
			   char* blk_start_tag_1, char* blk_start_tag_2,
			   char* blk_end_tag_1, char* blk_end_tag_2) ;
*/

void collect_blk_info_XIP (GList** l, GtkTextBuffer* text, char* nr_tag, 
			   char** blk_start_tags, char** blk_end_tags); 

void collect_blk_info_SIP (GList** l, GtkTextBuffer* text, char* nr_tag, 
			   char* blk_start_tag,
			   char* blk_end_tag);

int collect_blk_info_SIP_real (int start_from, GList** l, 
				GtkTextBuffer* text, char* nr_tag, 
				char* blk_start_tag,
				char* blk_end_tag);

GList* update_blk_list(GList* l, int blk_nr, gchar* blk_name, int start_l, 
				    int end_l,int start_pos, int  end_pos);

int get_blk_nr(char* str) ;

gchar* get_blk_name(gchar* str);

void get_line_from_text(GtkWidget* text, guint start_point, gchar* line);

void dump_curr_demo();

void dump_ALL_DEMO();

void dump_blk_info(blk_info* bi);

void dump_file_text_list();

#endif
