/*
 * $Id: dialog_show_file.c,v 1.1.1.1 2003/06/11 21:16:01 wyan Exp $
 * $Revision: 1.1.1.1 $
 * $Log: dialog_show_file.c,v $
 * Revision 1.1.1.1  2003/06/11 21:16:01  wyan
 * demoHarness
 *
 * Revision 1.8  2002/11/22 16:12:56  wyan
 *
 *  This demo puts a front end to show how GaTech Infopipe Stub Generator
 *  (ISG) works. ISG has been used in several places including the GaTech
 *  Multi-UAV demo, the Mapquest (Java socket) demo and BBN's OEP demo.
 *  More demos using ISG to expediate programming are expected in the
 *  future.
 *  The demo is fully implemented in GLib, GDK and GTK+. This latest
 *  version uses GTK+2.0.5. Since there have been significant changes
 *  from GTK+1.2 (from which the previous version was implemented), lots
 *  of modifications has been made in this update. It's not suprised you
 *  may find different function API which serves the same job or 2 different
 *  data structure of the similar data.
 *
 *  Wenchang 12/21/02
 *
 * Revision 1.4  2002/11/06 21:51:20  wyan
 * *** empty log message ***
 *
 * Revision 1.3  2002/07/12 16:56:24  wyan
 *
 * autoconf targeting for python package
 *
 * Revision 1.2  2002/07/03 03:54:08  wyan
 * *** empty log message ***
 *
 */


#include "dialog_show_file.h"
#include "callbacks.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "const.h"

/* 
 * Open a dialog box which shows the file `filename`.
 * FILE* file is the pointer of the file to be shown.
 */
GtkWidget*
create_dialog_show_file (gchar* filename, gint x, gint y, 
			 GtkWidget** dialog_show_file_text,
			 GtkTextBuffer** dialog_show_file_text_buf,
			 gchar* text_widget_name)
{
  GtkWidget *dialog_show_file;
  GtkWidget *dialog_show_file_vbox;
  GtkWidget *dialog_show_file_scrolledwindow;
  //GtkWidget *dialog_show_file_text;
  GtkWidget *dialog_show_file_action_area;
  GtkWidget *close_button;
  GtkWidget *close_all_dialog_button;

  dialog_show_file = gtk_dialog_new ();
  gtk_widget_set_name (dialog_show_file, "dialog_show_file");
  g_object_set_data (G_OBJECT (dialog_show_file), "dialog_show_file", dialog_show_file);
  gtk_window_set_gravity(GTK_WINDOW(dialog_show_file), GDK_GRAVITY_NORTH_WEST);
  //gtk_widget_set_uposition (dialog_show_file, x, y);
  gtk_window_set_title (GTK_WINDOW (dialog_show_file), filename);
  GTK_WINDOW (dialog_show_file)->type = GTK_WINDOW_TOPLEVEL;
  gtk_window_set_default_size (GTK_WINDOW (dialog_show_file), 400, 480);
  //gtk_window_set_policy (GTK_WINDOW (dialog_show_file), TRUE, TRUE, FALSE);
  gtk_window_set_resizable(GTK_WINDOW(dialog_show_file),TRUE);

  dialog_show_file_vbox = GTK_DIALOG (dialog_show_file)->vbox;
  gtk_widget_set_name (dialog_show_file_vbox, "dialog_show_file_vbox");
  g_object_set_data (G_OBJECT (dialog_show_file), "dialog_show_file_vbox", dialog_show_file_vbox);
  gtk_widget_show (dialog_show_file_vbox);

  dialog_show_file_scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (dialog_show_file_scrolledwindow, "dialog_show_file_scroll
edwindow");
  gtk_widget_ref (dialog_show_file_scrolledwindow);
  g_object_set_data_full (G_OBJECT (dialog_show_file), "dialog_show_file_scrolledwindow", dialog_show_file_scrolledwindow,
                            (GDestroyNotify) g_object_unref);
  gtk_widget_show (dialog_show_file_scrolledwindow);
  gtk_box_pack_start (GTK_BOX (dialog_show_file_vbox), dialog_show_file_scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (dialog_show_file_scrolledwindow), GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);

  *dialog_show_file_text = gtk_text_view_new ();
  *dialog_show_file_text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(*dialog_show_file_text));
  
  MSG1(" [create_dialog_show_file(): *dialog_show_file_text(%p)",*dialog_show_file_text);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(*dialog_show_file_text),FALSE);
  //gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(*dialog_show_file_text),TRUE);
  gtk_widget_set_name (*dialog_show_file_text, text_widget_name);
  gtk_widget_ref (*dialog_show_file_text);
  g_object_set_data_full (G_OBJECT (dialog_show_file), text_widget_name, 
			  *dialog_show_file_text,
                          (GDestroyNotify) g_object_unref);

  //gtk_text_buffer_begin_user_action(*dialog_show_file_text_buf);

  //Must load the file
  if (load_one_file(*dialog_show_file_text_buf, filename, "r", font_size)) {

    gtk_widget_show (*dialog_show_file_text);
    gtk_container_add (GTK_CONTAINER (dialog_show_file_scrolledwindow), *dialog_show_file_text);
    
    dialog_show_file_action_area = GTK_DIALOG (dialog_show_file)->action_area;
    gtk_widget_set_name (dialog_show_file_action_area, "dialog_show_file_action_area");
    g_object_set_data (G_OBJECT (dialog_show_file), "dialog_show_file_action_area", dialog_show_file_action_area);
    gtk_widget_show (dialog_show_file_action_area);
    gtk_container_set_border_width (GTK_CONTAINER (dialog_show_file_action_area),       6);

    close_button = gtk_button_new_with_label ("Close");
    gtk_widget_set_name (close_button, "close_button");
    gtk_widget_ref (close_button);
    g_object_set_data_full (G_OBJECT (dialog_show_file), "close_button", 
			    close_button,
			    (GDestroyNotify) g_object_unref);
    gtk_widget_show (close_button);
    gtk_box_pack_start (GTK_BOX (dialog_show_file_action_area), close_button, FALSE, FALSE, 0);

    close_all_dialog_button = gtk_button_new_with_label ("Close All Popup");
    gtk_widget_set_name (close_all_dialog_button, "close_all_dialog_button");
    gtk_widget_ref (close_all_dialog_button);
    g_object_set_data_full (G_OBJECT (dialog_show_file), 
			    "close_all_dialog_button", 
			    close_all_dialog_button,
			    (GDestroyNotify) g_object_unref);
    gtk_widget_show (close_all_dialog_button);
    gtk_box_pack_start (GTK_BOX (dialog_show_file_action_area), 
			close_all_dialog_button, FALSE, FALSE, 0);
    
    g_signal_connect (G_OBJECT (dialog_show_file), "delete_event",
                      G_CALLBACK (on_dialog_show_file_delete_event
				       /*gtk_widget_hide*/ ),
                      NULL);
    g_signal_connect (G_OBJECT (*dialog_show_file_text), "focus_in_event",
			G_CALLBACK (on_dialog_show_file_text_focus_in_event),
                      /*(gpointer)file*/NULL);
    
    g_signal_connect_object (G_OBJECT (close_button), "clicked",
                      G_CALLBACK (/*on_close_button_clicked*/
				       gtk_widget_hide),
			       dialog_show_file, G_CONNECT_SWAPPED);

    g_signal_connect (G_OBJECT (close_all_dialog_button), "clicked",
                      G_CALLBACK (on_close_all_dialog_button_clicked),
			     NULL);

    ///////////////////////
    ///
    g_signal_connect (G_OBJECT(*dialog_show_file_text), 
			      "button_press_event",
		      G_CALLBACK(on_dialog_show_file_text_button_press),
		      NULL);



    /*
    g_signal_connect_after (G_OBJECT(*dialog_show_file_text), "delete_text",
			    GTK_SIGNAL_FUNC(on_dialog_show_file_text_delete_event),NULL);
    */


    g_signal_connect_after (G_OBJECT(*dialog_show_file_text), "move_cursor",
			    GTK_SIGNAL_FUNC(on_dialog_show_file_text_move_cursor_event), NULL);
    //
    ////////////////////////
    //gtk_text_buffer_end_user_action(*dialog_show_file_text_buf);


    return dialog_show_file;
  }
  else 
    return NULL;
}



/////////////////
///
gboolean on_dialog_show_file_text_delete_event(GtkEditable* widget,
                                        gint             start_pos,
                                        gint             end_pos,
                                        gpointer         user_data)
{
  return TRUE;
}





gboolean on_dialog_show_file_text_move_cursor_event(GtkEditable* widget,
                                        gint             x,
                                        gint             y,
                                        gpointer         user_data)
{
  return TRUE;
}
/////
/////////////







gboolean on_dialog_show_file_text_button_press(GtkWidget* widget,
					   GdkEventButton* event,
					   gpointer data)
{
  gint x,y,buf_x,buf_y;

  GtkTextIter iter;
  //pos = gtk_text_get_point(GTK_TEXT(widget));

  gtk_widget_get_pointer(GTK_WIDGET(widget), &x, &y);
  gtk_text_view_window_to_buffer_coords(GTK_TEXT_VIEW(widget),
					GTK_TEXT_WINDOW_WIDGET,
					x,y,
					&buf_x,&buf_y);
  gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(widget),
				     &iter, buf_x, buf_y);

  //CUR_BLK_NR = get_blk_nr_from_cursor(widget,gtk_text_iter_get_offset(&iter));
  CUR_BLK_NAME = get_blk_name_from_cursor(widget,gtk_text_iter_get_offset(&iter));

  redisplay_all_blk(CUR_BLK_NAME);

  return TRUE;
}






/*
 *Redisplay the clicked text with blk highlighted.
 *Redisplay the corresponding blks in other texts also.
 */
/* Obsolete */
//guint CUR_BLK_NR = -1;
gchar* CUR_BLK_NAME=NULL;







#if 0
guint get_blk_nr_from_cursor(GtkWidget* text, int pos)
{
  int i,j;
  file_text* ft=NULL;
  blk_info* bi=NULL;
  GList* bl=NULL;

  fprintf(OUT, " [get_blk_nr_from_cursor(): widget name: >%s<\n",gtk_widget_get_name(GTK_WIDGET(text)));

  for (i=0; i< g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);

    if (NULL != ft) {
      if (GTK_TEXT_VIEW(text) == GTK_TEXT_VIEW(ft->text)) {
	fprintf(OUT, " [get_blk_nr_from_cursor(): found text_view, bl(%p) \n",ft->blk_list);

	bl = ft->blk_list;
	if (NULL != bl) {
	  for (j=0; j<g_list_length(bl); j++) {
	    bi = (blk_info*)g_list_nth_data(bl,j);
	    fprintf(OUT, " [get_blk_nr_from_cursor(): j=%d\n",j);
	    if (pos < bi->end_char && pos >= bi->start_char) {
	      fprintf(OUT, " [get_blk_nr_from_cursor(): list node %d :\n",i);
	      fprintf(OUT, "       type: %d, file: %s\n",ft->type,ft->file);
	      fprintf(OUT, "       text: %p, buf: %p\n",ft->text,ft->text_buf);
	      fprintf(OUT, "       blk_list: \n");
	      dump_blk_info(bi);
	      return bi->block_num;
	    }
	  }
	  return -1;
	}
      }
    }
  }
  return -1;
}      





GList* get_blk_info_from_blk_nr(GtkWidget* text, guint blk_nr)
{
  GList* matched_blk_info_list=NULL;
  //blk_info* bi=NULL;
  int i,j;
  file_text* ft=NULL;
  GList* bl=NULL;

  fprintf(OUT, " [get_blk_info_from_blk_nr(): starts ...\n");

  if (0 > blk_nr)
    return NULL;
  
  for (i=0; i< g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);

    if (NULL != ft) {
      if (GTK_TEXT_VIEW(text) == GTK_TEXT_VIEW(ft->text)) {
	bl = ft->blk_list;
	if (NULL != bl) {
	  for (j=0; j<g_list_length(ft->blk_list); j++) {
	    if (((blk_info*)g_list_nth_data(bl,j))->block_num == blk_nr) {
	      dump_blk_info(g_list_nth_data(bl,j));
	      matched_blk_info_list = g_list_append(matched_blk_info_list,
			    (blk_info*)g_list_nth_data(bl,j));
	    }
	  }
	  MSG(" [get_blk_info_from_blk_nr(): matched list returned");
	  return matched_blk_info_list;
	}
	else 
	  return NULL;
      }/* if (NULL != bl) */
    } /* if (NULL != ft) */
  } /* for (i=0; ...) */
 
  return NULL;
}  




gboolean line_in_blk(guint line_nr, GList* matched_blk_info_list)
{
  gboolean match = FALSE;
  blk_info* bi = NULL;
  int i;

  if (NULL== matched_blk_info_list) 
    return match;

  for (i=0; i<g_list_length(matched_blk_info_list); i++) {
    bi = g_list_nth_data(matched_blk_info_list,i);
    if (NULL != bi) {
      if (line_nr >= bi->start_line && line_nr <= bi->end_line) {
	return TRUE;
      }
    }
  }
  return match;
}







void redisplay_all_blk(guint blk_nr)
{
  int i;
  file_text* ft=NULL;
  GtkWidget* text=NULL;
  //blk_info* bi;
  GList* matched_blk_info_list;
 
  for (i=0; i<g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);
    MSG( " [redisplay_all_blk() ...");
    fprintf(OUT, " [redisplay_all_blk(): i=%d, list_len=%d, blk_nr=%d, %s)\n",i,g_list_length(file_text_list),blk_nr,ft->name);

    if (NULL != ft) {
      text = ft->text;
      if (NULL != text) {
	matched_blk_info_list = get_blk_info_from_blk_nr(text,blk_nr);
	if (ft->type == SIP) {
	  redisplay_SIP_blk(text, matched_blk_info_list);
	}
	else if (ft->type == XIP) {
	  redisplay_XIP_blk(text, matched_blk_info_list);
	}
	else if (ft->type == GENCODE) {
	  //XXX
	  //Use SIP version for now
	  redisplay_SIP_blk(text, matched_blk_info_list);
	}
	g_list_free(matched_blk_info_list);
      }
    }
    /////////////////////////////////////////////////////
    ///XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
    //if (i==0)
    //  break;
  } /* for */
}

#endif







gchar* get_blk_name_from_cursor(GtkWidget* text, int pos)
{
  int i,j;
  file_text* ft=NULL;
  blk_info* bi=NULL;
  blk_info* return_bi = NULL;
  GList* bl=NULL;

  int nearest_start_char = 0;
  gboolean found_blk_name = FALSE;

  MSG1( " [get_blk_name_from_cursor(): widget name: >%s<\n",
	gtk_widget_get_name(GTK_WIDGET(text)));

  for (i=0; i< g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);

    if (NULL != ft) {
      if (GTK_TEXT_VIEW(text) == GTK_TEXT_VIEW(ft->text)) {
	MSG1(" [get_blk_name_from_cursor(): found text_view, bl(%p) \n",
	     ft->blk_list);

	bl = ft->blk_list;
	if (NULL != bl) {
	  for (j=0; j<g_list_length(bl); j++) {
	    bi = (blk_info*)g_list_nth_data(bl,j);
	    MSG1(" [get_blk_name_from_cursor(): j=%d",j);
	    if (pos < bi->end_char && pos >= bi->start_char) {
	      found_blk_name = TRUE;
	      //In order to find the narrowest blk which corresponds to
	      //this mouse click position
	      if (bi->start_char >= nearest_start_char) {
		return_bi = bi;
		nearest_start_char = bi->start_char;
	      }
	    }
	  }

	  if (found_blk_name) {
	    MSG1(" [get_blk_name_from_cursor(): list node %d :",i);
	    MSG2("       type: %d, file: %s",ft->type,ft->file);
	    MSG2("       text: %p, buf: %p",ft->text,ft->text_buf);
	    MSG ("       blk_list: ");
	    //dump_blk_info(return_bi);
	    return return_bi->block_name;
	  }
	  else  
	    return NULL;
	}
      }
    }
  }
  return NULL;
}      




/* 
 * Get the matched blk_info struct from its name
 */
GList* get_blk_info_from_blk_name(GtkWidget* text, gchar* blk_name)
{
  GList* matched_blk_info_list=NULL;
  int i,j;
  file_text* ft=NULL;
  GList* bl=NULL;

  if (NULL == blk_name)
    return NULL;
  
  for (i=0; i< g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);
    //fprintf(OUT, "    [get_blk_info_from_blk_name(): i=%d, curr_text(%p), ft->text(%p),ft->name: >%s<, ft->text.name: >%s<\n",i,text,ft->text,ft->name,gtk_widget_get_name(GTK_WIDGET(ft->text)));
    if (NULL != ft) {
      if (GTK_TEXT_VIEW(text) == GTK_TEXT_VIEW(ft->text)) {
	bl = ft->blk_list;
	if (NULL != bl) {
	  for (j=0; j<g_list_length(ft->blk_list); j++) {
	    if (0==strcmp(((blk_info*)g_list_nth_data(bl,j))->block_name,
			  blk_name))
	      {
#ifdef DEBUG
	      dump_blk_info(g_list_nth_data(bl,j));
#endif
	      matched_blk_info_list = g_list_append(matched_blk_info_list,
			    (blk_info*)g_list_nth_data(bl,j));
	      }
	  }
	  MSG(" [get_blk_info_from_blk_name(): matched list returned");
	  return matched_blk_info_list;
	}
	else 
	  return NULL;
      }/* if (NULL != bl) */
    } /* if (NULL != ft) */
  } /* for (i=0; ...) */
 
  return NULL;
}  





void redisplay_all_blk(gchar* blk_name)
{
  int i;
  file_text* ft=NULL;
  GtkWidget* text=NULL;
  GList* matched_blk_info_list;
 
  for (i=0; i<g_list_length(file_text_list); i++) {
    ft = (file_text*)g_list_nth_data(file_text_list,i);
    MSG(" [redisplay_all_blk() ...");
    //fprintf(OUT, " [redisplay_all_blk(): i=%d, list_len=%d, blk_name=%s, %s)\n",i,g_list_length(file_text_list),blk_name,ft->name);

    if (NULL != ft) {
      text = ft->text;
      if (NULL != text) {
	matched_blk_info_list = get_blk_info_from_blk_name(text,blk_name);
	if (ft->type == SIP) {
	  redisplay_SIP_blk(text, matched_blk_info_list);
	}
	else if (ft->type == XIP) {
	  //Since XIP has the same format of the blk_info as SIP in the 
	  //new version generated by SIP=>XIP python parser, we use 
	  //redisplay_SIP_blk() instead of redisplay_XIP_blk().
	  //	  redisplay_XIP_blk(text, matched_blk_info_list);
	  redisplay_SIP_blk(text, matched_blk_info_list);
	}
	else if (ft->type == GENCODE) {
	  redisplay_gencode_blk(text, matched_blk_info_list);
	}
	g_list_free(matched_blk_info_list);
      }
    }
  } /* for */
}






gboolean word_in_blk(guint offset, GList* matched_blk_info_list)
{
  gboolean match = FALSE;
  blk_info* bi = NULL;
  int i;

  if (NULL== matched_blk_info_list) 
    return match;

  for (i=0; i<g_list_length(matched_blk_info_list); i++) {
    bi = g_list_nth_data(matched_blk_info_list,i);
    if (NULL != bi) {
      if (offset >= bi->start_char && offset <= bi->end_char) {
	return TRUE;
      }
    }
  }
  return match;
}






void redisplay_SIP_blk(GtkWidget* text, GList* matched_blk_info_list)
{
  gchar* word;//[256];
  gboolean get_mark_scroll_to = FALSE;
  GtkTextIter iter_limit, iter_s, iter_e;
  GtkTextIter iter_scroll_to;

  GtkTextMark* mark1, *mark2, *mark_scroll_to;
  GtkTextSearchFlags sflag;
  GtkTextBuffer* text_buf;
  GtkTextTagTable* tag_table;

  text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
  tag_table = gtk_text_buffer_get_tag_table(text_buf);

  {//Seems each tagtable requires brand new instance of tag
    if (hidden_tag) g_object_unref(G_OBJECT(hidden_tag));
    hidden_tag = gtk_text_tag_new("hidden");
    //g_object_set(G_OBJECT(hidden_tag), "style", PANGO_STYLE_ITALIC, NULL);
    g_object_set(G_OBJECT(hidden_tag), "foreground", "white", NULL);
    //The hightlighted text is red
    if (highlight_tag) g_object_unref(G_OBJECT(highlight_tag));
    highlight_tag = gtk_text_tag_new("highlight");
    g_object_set(G_OBJECT(highlight_tag), /*"foreground"*/
		 "foreground-gdk", &color_highlight
		 /*"red"*/, NULL);
    //Normal 
    if (normal_tag) g_object_unref(G_OBJECT(normal_tag));
    normal_tag = gtk_text_tag_new("normal");
    g_object_set(G_OBJECT(normal_tag),NULL);
  }

  if (!gtk_text_tag_table_lookup(tag_table, "hidden"))
      gtk_text_tag_table_add(tag_table, hidden_tag);
  if (!gtk_text_tag_table_lookup(tag_table, "highlight"))   
      gtk_text_tag_table_add(tag_table, highlight_tag);
  if (!gtk_text_tag_table_lookup(tag_table, "normal"))
      gtk_text_tag_table_add(tag_table, normal_tag);

  //MSG1(" [redisplay_SIP_blk(): starts ..., matched_blk_info_list(%p)",
  //matched_blk_info_list);


  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_s);
  //If nothing is highlighted then scroll the window to the start point
  mark_scroll_to = gtk_text_buffer_create_mark(text_buf,"scroll_to",
				     &iter_s,FALSE);

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_e);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text_buf),&iter_limit);
  mark1 = gtk_text_buffer_create_mark(text_buf,"delete_back_to",
				     &iter_s,FALSE);
  mark2 = gtk_text_buffer_create_mark(text_buf,"insert_up_to",
				      &iter_s, FALSE);

  gtk_text_buffer_begin_user_action(GTK_TEXT_BUFFER(text_buf));

  while (gtk_text_iter_forward_word_end(&iter_e)) {
    if (gtk_text_iter_get_char(&iter_s)=='\n') 
      gtk_text_iter_forward_char(&iter_s);

    //The leading space before each word shall be supressed
    while (gtk_text_iter_get_char(&iter_s)==' ') 
      gtk_text_iter_forward_char(&iter_s);

    gtk_text_iter_forward_char(&iter_e);
    word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    //THis is a fix for pango word recognition
    if (g_strrstr(word, "\n")) {
      //A newline in the middle of the word
      gtk_text_iter_backward_line(&iter_e);
      gtk_text_iter_forward_line(&iter_e);
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    }

    gtk_text_buffer_move_mark_by_name(text_buf, "delete_back_to", &iter_s);
    gtk_text_buffer_move_mark_by_name(text_buf, "insert_up_to",&iter_e);
    //MSG1(" [redisplay_SIP_blk(): word: >%s<", word);

    if (!strcmp(word, SIP_BLK_TAG_OTHER_1) 
	|| !strcmp(word, SIP_BLK_TAG_OTHER_2) 
	|| !strcmp(word, SIP_END_BLK_TAG)) 
      {
	//MSG(" [redisplay_SIP_blk(): 1 ...");
	//<blockSip> or </blockSip> or </block>
	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					 "hidden"), NULL);
      }
    else if (!strcmp(word, SIP_START_BLK_TAG)) 
      {
	//<block ...>
	//Search for the closing '>'
	GtkTextIter tmp_iter = iter_s;
	//MSG(" [redisplay_SIP_blk(): 2 ...");

	gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text_buf),&iter_limit);
	if (!gtk_text_iter_forward_search(&iter_e, ">", sflag,
					  &iter_s, &iter_e, &iter_limit)) 
	  {
	    ERR(" [redisplay_SIP_blk(): SIP format error\n");
	    exit(-1);
	  }
	iter_s = tmp_iter;
	word = gtk_text_iter_get_slice(&iter_s, &iter_e);
	gtk_text_buffer_move_mark_by_name(text_buf, "delete_back_to", 
					  &iter_s);
	gtk_text_buffer_move_mark_by_name(text_buf, "insert_up_to",&iter_e);

	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					   "hidden"), NULL);
      }
    else if ( matched_blk_info_list &&
	      word_in_blk(gtk_text_iter_get_offset(&iter_s), 
			  matched_blk_info_list))
      {
	//MSG(" [redisplay_SIP_blk(): 3 ...");
	//block info needs to be hightlighted
	//If sth is highlighted, scroll the window to this point
	if (!get_mark_scroll_to) {
	  mark_scroll_to = gtk_text_buffer_create_mark(text_buf,"scroll_to",
						       &iter_s,FALSE);
	  get_mark_scroll_to = TRUE;
	}

	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					 "highlight"),
					   NULL);
      }
    else {
      //Other...
      //MSG(" [redisplay_SIP_blk(): 4 ...");
      gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
      gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
				       word, -1,
				       gtk_text_tag_table_lookup(tag_table,
								 "normal"),
				       NULL);
    }	

    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark2);
    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_e, mark2);
  } // end while

  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_scroll_to, mark_scroll_to);
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(text), &iter_scroll_to,
			       0,TRUE,0,0.5/*yalign: in the center*/);
  gtk_text_buffer_end_user_action(GTK_TEXT_BUFFER(text_buf));
}






void redisplay_gencode_blk(GtkWidget* text, GList* matched_blk_info_list)
{
  gchar* word;//[256];
  gboolean get_mark_scroll_to = FALSE;
  gboolean notebook_page_label_highlight = FALSE;
  //This flag is 
  //used in the code segment of Breakup '*/\n
  //                                     /*\n'
  gboolean word_in_blk_info_line = FALSE;
  GtkTextIter iter_limit, iter_s, iter_e;

  GtkTextIter iter_scroll_to;

  GtkTextMark* mark1, *mark2, *mark_scroll_to;
  GtkTextSearchFlags sflag;

  GtkTextBuffer* text_buf;
  GtkTextTagTable* tag_table;

  text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
  tag_table = gtk_text_buffer_get_tag_table(text_buf);

  {//Seems each tagtable requires brand new instance of tag
    if (hidden_tag) g_object_unref(G_OBJECT(hidden_tag));
    hidden_tag = gtk_text_tag_new("hidden");
    //g_object_set(G_OBJECT(hidden_tag), "style", PANGO_STYLE_ITALIC, NULL);
    g_object_set(G_OBJECT(hidden_tag), "foreground", "white", NULL);
    //The hightlighted text is red
    if (highlight_tag) g_object_unref(G_OBJECT(highlight_tag));
    highlight_tag = gtk_text_tag_new("highlight");
    g_object_set(G_OBJECT(highlight_tag), /*"foreground"*/
		 "foreground-gdk", &color_highlight
		 /*"red"*/, NULL);
    //Normal 
    if (normal_tag) g_object_unref(G_OBJECT(normal_tag));
    normal_tag = gtk_text_tag_new("normal");
    g_object_set(G_OBJECT(normal_tag),NULL);
  }

  if (!gtk_text_tag_table_lookup(tag_table, "hidden"))
      gtk_text_tag_table_add(tag_table, hidden_tag);
  if (!gtk_text_tag_table_lookup(tag_table, "highlight"))   
      gtk_text_tag_table_add(tag_table, highlight_tag);
  if (!gtk_text_tag_table_lookup(tag_table, "normal"))
      gtk_text_tag_table_add(tag_table, normal_tag);

  //MSG1(" [redisplay_gencode_blk(): starts ..., matched_blk_info_list(%p)",matched_blk_info_list);


  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_s);
  //If nothing is highlighted then scroll the window to the start point
  mark_scroll_to = gtk_text_buffer_create_mark(text_buf,"scroll_to",
				     &iter_s,FALSE);

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_e);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text_buf),&iter_limit);
  mark1 = gtk_text_buffer_create_mark(text_buf,"delete_back_to",
				     &iter_s,FALSE);
  mark2 = gtk_text_buffer_create_mark(text_buf,"insert_up_to",
				      &iter_s, FALSE);

  gtk_text_buffer_begin_user_action(GTK_TEXT_BUFFER(text_buf));

  while (gtk_text_iter_forward_word_end(&iter_e)) {
    if (gtk_text_iter_get_char(&iter_s)=='\n') 
      gtk_text_iter_forward_char(&iter_s);

    //The leading space before each word shall be supressed
    while (gtk_text_iter_get_char(&iter_s)==' ') 
      gtk_text_iter_forward_char(&iter_s);

    gtk_text_iter_forward_char(&iter_e);
    word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    //THis is a fix for pango word recognition
    if (g_strrstr(word, "\n")) {
      //A newline in the middle of the word
      gtk_text_iter_backward_line(&iter_e);
      gtk_text_iter_forward_line(&iter_e);
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    }

    //We put block info in comments of the generated code.
    //Pango treat '/* <block ' and '/* </block>' ... as
    //a single word.
    //Ugly: Suppress '/*' in '/* <block ' or '/* </block>'
    //  and suppress '//' in '// <block ' or '// </block>'    
    if ((g_strrstr(word, SIP_START_BLK_TAG) || 
	g_strrstr(word, SIP_END_BLK_TAG)) &&
	(g_strrstr(word, "//") || g_strrstr(word, "/*"))) {
      while (gtk_text_iter_get_char(&iter_s)=='/' ||
	     gtk_text_iter_get_char(&iter_s)=='*' )
	gtk_text_iter_forward_char(&iter_s);
      while (gtk_text_iter_get_char(&iter_s)==' ') 
        gtk_text_iter_forward_char(&iter_s);
        //again. update word
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    }

    //Pango treats the following 3 lines '*/\n
    //                                   /*\n' as a single word.
    //Breakup '*/\n
    //         /*\n'
    if (g_strrstr(word, "*/") && g_strrstr(word, "/*")
	&& word_in_blk_info_line) {
      gtk_text_iter_backward_line(&iter_e);
      gtk_text_iter_backward_line(&iter_e);
      gtk_text_iter_forward_line(&iter_e);
      while (gtk_text_iter_get_char(&iter_s)=='/' ||
	     gtk_text_iter_get_char(&iter_s)=='*' )
	gtk_text_iter_forward_char(&iter_s);
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
      word_in_blk_info_line = FALSE;
    }
						  
    gtk_text_buffer_move_mark_by_name(text_buf, "delete_back_to", &iter_s);
    gtk_text_buffer_move_mark_by_name(text_buf, "insert_up_to",&iter_e);
    //MSG1(" [redisplay_gencode_blk(): word: >%s<", word);

    if (!strcmp(word, SIP_BLK_TAG_OTHER_1) 
	|| !strcmp(word, SIP_BLK_TAG_OTHER_2) 
	|| !strcmp(word, SIP_END_BLK_TAG)) 
      {
	//MSG(" [redisplay_gencode_blk(): 1 ...");
	//<blockSip> or </blockSip> or </block>
	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					 "hidden"), NULL);
      }
    else if (!strcmp(word, SIP_START_BLK_TAG)) 
      {
	//<block ...>
	//Search for the closing '>'
	GtkTextIter tmp_iter = iter_s;
	//MSG(" [redisplay_gencode_blk(): 2 ...");

	gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text_buf),&iter_limit);
	if (!gtk_text_iter_forward_search(&iter_e, ">", sflag,
					  &iter_s, &iter_e, &iter_limit)) 
	  {
	    ERR(" [redisplay_gencode_blk(): gencode format error\n");
	    exit(-1);
	  }
	iter_s = tmp_iter;
	word = gtk_text_iter_get_slice(&iter_s, &iter_e);
	gtk_text_buffer_move_mark_by_name(text_buf, "delete_back_to", 
					  &iter_s);
	gtk_text_buffer_move_mark_by_name(text_buf, "insert_up_to",&iter_e);

	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					   "hidden"), NULL);
	word_in_blk_info_line = TRUE;
      }
    else if ( matched_blk_info_list &&
	      word_in_blk(gtk_text_iter_get_offset(&iter_s), 
			  matched_blk_info_list))
      {
	//MSG(" [redisplay_gencode_blk(): 3 ...");
	//block info needs to be hightlighted
	//If sth is highlighted, scroll the window to this point
	if (!get_mark_scroll_to) {
	  mark_scroll_to = gtk_text_buffer_create_mark(text_buf,"scroll_to",
						       &iter_s,FALSE);
	  get_mark_scroll_to = TRUE;
	}

	gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					 word, -1,
					 gtk_text_tag_table_lookup(tag_table,
					 "highlight"),
					   NULL);
	notebook_page_label_highlight = TRUE;
      }
    else {
      //Other...
      //MSG(" [redisplay_gencode_blk(): 4 ...");
      gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
      gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
				       word, -1,
				       gtk_text_tag_table_lookup(tag_table,
								 "normal"),
				       NULL);
    }	

    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark2);
    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_e, mark2);
  } // end while

  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_scroll_to, mark_scroll_to);
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(text), &iter_scroll_to,
			       0,TRUE,0,0.5/*yalign: in the center*/);
  gtk_text_buffer_end_user_action(GTK_TEXT_BUFFER(text_buf));

  reset_gencode_notebook_page_label(notebook_page_label_highlight, text);
}









void reset_gencode_notebook_page_label(gboolean highlight, 
				       GtkWidget* text_view)
{
  gchar* name = NULL;
  int num = 0;
  int i,j;

  for (i=0;i<g_list_length(file_text_list);i++) {
    file_text* ft = g_list_nth_data(file_text_list, i);
    if (ft && text_view) {
      if (ft->text == text_view) {
	name = g_strrstr(gtk_widget_get_name(text_view), "[");
	j = 1;
	while (name[j++] != ']') {
	  num = num*10 + name[j-1] - '0';
	}
      }
    }
  }    

  //MSG2(" [reset_gencode_notebook_page_label(): num = %d, yes? %d", 
  //num, highlight);

  //gtk_label_set_use_underline (GTK_LABEL(label_gencode_file[num]),
  //			       highlight);
  if (highlight) 
    gtk_label_set_markup(GTK_LABEL(label_gencode_file[num]), 
			 g_strconcat("<span foreground=\"red\">",
			gtk_label_get_text(GTK_LABEL(label_gencode_file[num])),
				     "</span>", NULL));
  else 
    gtk_label_set_markup(GTK_LABEL(label_gencode_file[num]), 
			 g_strconcat(
			gtk_label_get_text(GTK_LABEL(label_gencode_file[num])),
				     NULL));
    
}






/*
 * Since there's a leading space before "num=" in XIP, want to
 * change from " num=" to ">num=" for further displaying in the 
 * redisplay_XIP ...
 */
void  change_space_to_bracket_in_XIP(GtkWidget* text)
{
  GtkTextIter iter_limit, iter_s, iter_e;
  GtkTextMark* mark1, *mark2, *mark3;
  GtkTextSearchFlags sflag;
  gchar* word;
  
  GtkTextBuffer* text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));

  if (!text_buf) {
    ERR(" [change_space_to_bracket_in_XIP(): NULL text_buf\n");
    return;
  }

  gtk_text_buffer_get_start_iter(text_buf, &iter_s);
  gtk_text_buffer_get_start_iter(text_buf, &iter_e);
  gtk_text_buffer_get_end_iter(text_buf, &iter_limit);
  /*
  word = gtk_text_iter_get_slice(&iter_s, &iter_limit);
  MSG1(" [change_space_to_bracket_in_XIP(): >%s<", word);
  */
  mark1 = gtk_text_buffer_create_mark(text_buf,"delete_back_to",
				     &iter_s,FALSE);
  mark2 = gtk_text_buffer_create_mark(text_buf,"insert_up_to",
				      &iter_s, FALSE);
  mark3 = gtk_text_buffer_create_mark(text_buf,"end",
				      &iter_limit, FALSE);

  while (gtk_text_iter_forward_search(&iter_s, XIP_BLK_NUM_TAG,sflag,
				      &iter_s, &iter_e, &iter_limit))
    {
      gtk_text_iter_backward_char(&iter_s);
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);      
      gtk_text_buffer_move_mark_by_name(text_buf,"delete_back_to",&iter_s);
      gtk_text_buffer_move_mark_by_name(text_buf,"insert_up_to",&iter_e);

      gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);

      word[0] = '>';

      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
      gtk_text_buffer_insert(text_buf, &iter_s, word, -1);
      
      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark2);
      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_e, mark2);
      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_limit, mark3);
    }

}








    
void redisplay_XIP_blk(GtkWidget* text, GList* matched_blk_info_list)
{
  gchar* word;
  GtkTextIter iter_limit, iter_s, iter_e, iter_tmp;
  GtkTextMark* mark1, *mark2;
  GtkTextSearchFlags sflag;

  GtkTextBuffer* text_buf;
  GtkTextTagTable* tag_table;

  text_buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
  tag_table = gtk_text_buffer_get_tag_table(text_buf);

  {//Seems each tagtable requires brand new instance of tag
    hidden_tag = gtk_text_tag_new("hidden");
    g_object_set(G_OBJECT(hidden_tag), "style", PANGO_STYLE_ITALIC, NULL);
    //The hightlighted text is red
    highlight_tag = gtk_text_tag_new("highlight");
    g_object_set(G_OBJECT(highlight_tag), "foreground", "red", NULL);
    //Normal 
    normal_tag = gtk_text_tag_new("normal");
    g_object_set(G_OBJECT(normal_tag),NULL);
  }

  gtk_text_tag_table_add(tag_table, hidden_tag);
  gtk_text_tag_table_add(tag_table, highlight_tag);
  gtk_text_tag_table_add(tag_table, normal_tag);

  //Need to replace " num=?>" in XIP with ">num=?>" for convenience
  change_space_to_bracket_in_XIP(text);

  //Init the iterators and marks. Marks is to save the position before
  //the modification in text_buffer, because all effective iterators
  //will become invalid after modification
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_s);
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(text_buf),&iter_e);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(text_buf),&iter_limit);
  mark1 = gtk_text_buffer_create_mark(text_buf,"delete_back_to",
				     &iter_s,FALSE);
  mark2 = gtk_text_buffer_create_mark(text_buf,"insert_up_to",
				      &iter_s, FALSE);

  gtk_text_buffer_begin_user_action(GTK_TEXT_BUFFER(text_buf));

  while (gtk_text_iter_forward_word_end(&iter_e)) {
    gtk_text_iter_forward_char(&iter_e);
    word = gtk_text_iter_get_slice(&iter_s, &iter_e);

    //THis is a fix for pango word recognition of newline. Newline can
    //be appeared in the middle of the recognized word
    if (g_strrstr(word, "\n")) {
      //Move iter_e at newline
      gtk_text_iter_backward_line(&iter_e);
      gtk_text_iter_forward_line(&iter_e);
      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
    }

    gtk_text_buffer_move_mark_by_name(text_buf, "delete_back_to", &iter_s);
    gtk_text_buffer_move_mark_by_name(text_buf, "insert_up_to",&iter_e);

    if (matched_blk_info_list &&
	word_in_blk(gtk_text_iter_get_offset(&iter_s), 
		    matched_blk_info_list))
      {
	//Due to Pango word recognition, cannot use strcmp
	if (!g_strrstr(word,  XIP_BLK_NUM_TAG)) {
	  //needs to be hightlighted
	  gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	  gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					   word, -1,
					   gtk_text_tag_table_lookup(tag_table,
							     "highlight"),
					   NULL);
	}
	else {
	  //{<chars_before "num="}{"num="} 
	  //'>' needs to be highlighted, the rest needs to be hidden
	  //Backward iter_e at '>' in front of 'num='
	  gtk_text_iter_backward_chars(&iter_e, sizeof(XIP_BLK_NUM_TAG)-1);
	  word = gtk_text_iter_get_slice(&iter_s, &iter_e);

	  gtk_text_buffer_move_mark_by_name(text_buf,"delete_back_to",&iter_s);
	  gtk_text_buffer_move_mark_by_name(text_buf,"insert_up_to",&iter_e);
	  gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	  gtk_text_buffer_insert_with_tags(text_buf,&iter_s, 
					   word, -1,
					   gtk_text_tag_table_lookup(tag_table,
						     "highlight"),NULL);
	  
cover_NUM_tag:
	  //Starting from {num=} to the end of matching closing '>', 
	  //all need to be covered (hided)
	  gtk_text_buffer_move_mark_by_name(text_buf,"delete_back_to",&iter_s);
	  iter_limit = iter_s;
	  gtk_text_iter_forward_line(&iter_limit);
	  if (gtk_text_iter_forward_search(&iter_s, ">", sflag,
					   &iter_tmp, &iter_e, &iter_limit))
	    {
	      gtk_text_iter_forward_char(&iter_e);
	      word = gtk_text_iter_get_slice(&iter_s, &iter_e);
	      gtk_text_buffer_move_mark_by_name(text_buf,"insert_up_to",
						&iter_e);
	      gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	      gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	      gtk_text_buffer_insert_with_tags(text_buf,&iter_s,word,-1,
					   gtk_text_tag_table_lookup(tag_table,
								     "hidden"),
					   NULL);
	    }
	  else {
	    ERR(" [redisplay_XIP_blk(): Closing > not found\n");
	  }
	}
      }/* if word_in_blk() */
    else 
      {
	//Word not in blk. Need displayed
	if (!g_strrstr(word,  XIP_BLK_NUM_TAG)) {
	  //needs to be displayed
	  gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	  gtk_text_buffer_insert_with_tags(text_buf,&iter_s,
					   word, -1,
					   gtk_text_tag_table_lookup(tag_table,
							     "normal"),
					   NULL);
	}
	else {
	  //needs to be covered and ...
	  gtk_text_iter_backward_chars(&iter_e, sizeof(XIP_BLK_NUM_TAG)-1);
	  word = gtk_text_iter_get_slice(&iter_s, &iter_e);
	  gtk_text_buffer_move_mark_by_name(text_buf,"delete_back_to",&iter_s);
	  gtk_text_buffer_move_mark_by_name(text_buf,"insert_up_to",&iter_e);
	  gtk_text_buffer_delete(text_buf, &iter_s, &iter_e);
	  gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark1);
	  gtk_text_buffer_insert_with_tags(text_buf,&iter_s, 
					   word, -1,
					   gtk_text_tag_table_lookup(tag_table,
						     "normal"),NULL);

	  goto cover_NUM_tag;
	}
      }

    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_s, mark2);
    gtk_text_buffer_get_iter_at_mark(text_buf, &iter_e, mark2);
  }/*while*/

  gtk_text_buffer_end_user_action(GTK_TEXT_BUFFER(text_buf));
}



  

/* Callbacks*/
gboolean on_dialog_show_file_delete_event(GtkWidget * widget,
					  GdkEvent * event,
					  gpointer user_data)
{
  gtk_widget_hide(widget/*dialog_show_file*/);
  return TRUE;
}






void
on_close_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  //gtk_widget_hide(dialog_show_file);
  //gtk_exit(0);
}





void
on_close_all_dialog_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
  int i;
  
  if (SIP_dialog_window) {
    for (i=0;i<NR_SIP_FILE;i++) {
      if (SIP_dialog_window[i])
	gtk_widget_hide(SIP_dialog_window[i]);
    }
  }

  if (XIP_dialog_window) {
    for (i=0;i<NR_XIP_FILE;i++) {
      if (XIP_dialog_window[i])
	gtk_widget_hide(XIP_dialog_window[i]);
    }
  }

  if (gencode_dialog_window) {
    for (i=0;i<NR_GENCODE_FILE;i++) {
      if (gencode_dialog_window[i])
	gtk_widget_hide(gencode_dialog_window[i]);
    }
  }

}



gboolean
on_dialog_show_file_text_focus_in_event
                                        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  return TRUE;
}



