/*
 * $Id: main.c,v 1.1.1.1 2003/06/11 21:16:01 wyan Exp $
 * $Log: main.c,v $
 * Revision 1.1.1.1  2003/06/11 21:16:01  wyan
 * demoHarness
 *
 * Revision 1.9  2002/11/22 16:12:56  wyan
 *
 *  This demo puts a front end to show how GaTech Infopipe Stub Generator
 *  (ISG) works. ISG has been used in several places including the GaTech
 *  Multi-UAV demo, the Mapquest (Java socket) demo and BBN's OEP demo.
 *  More demos using ISG to expediate programming are expected in the
 *  future.
 *  The demo is fully implemented in GLib, GDK and GTK+. This latest
 *  version uses GTK+2.0.5. Since there have been significant changes
 *  from GTK+1.2 (from which the previous version was implemented), lots
 *  of modifications has been made in this update. It's not suprised you
 *  may find different function API which serves the same job or 2 different
 *  data structure of the similar data.
 *
 *  Wenchang 12/21/02
 *
 * Revision 1.5  2002/11/06 21:51:20  wyan
 * 
 *
 * *** empty log message ***
 *
 * Revision 1.4  2002/07/12 16:56:25  wyan
 *
 * autoconf targeting for python package
 *
 * Revision 1.3  2002/07/05 20:37:39  wyan
 * *** empty log message ***
 *
 * Revision 1.2  2002/07/03 03:54:09  wyan
 * *** empty log message ***
 *
 * $Revision: 1.1.1.1 $
 */

/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "const.h"
#include "dialog_show_file.h"
#include "cfg_info_parse.h"
#include "pixbufs.h"
#include <stdio.h>
#include <signal.h>
#include <unistd.h>

#ifndef USE_STDOUT
FILE* OS;
long OS_file_pos;
#endif

guint ANIMATION_DISPLAYED = 0;
GtkWidget* notebook_top;
GtkWidget* window;

int
main (int argc, char *argv[])
{
  GtkWidget *isg_demo;

#ifndef USE_STDOUT
  //open the file for dumping msg
  OS_file_pos = 0;
  OS = open_file(OS_FILE_NAME,"w+");
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  color_font_init();

  init_rc();

  const_init();

  /* 
   * Main window created 
   */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "window");
  g_object_set_data (G_OBJECT (window), "window", window);
  gtk_window_set_title (GTK_WINDOW (window), _("ISG Demo"));
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW(window), MAIN_WIN_WIDTH,
			       MAIN_WIN_HEIGHT);

  /* 
   * The top level notebook which holds the notebook_img for the
   * animation (if required) and the frame window_main for the 
   * demo interface.
   */
  notebook_top = gtk_notebook_new();    
  gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook_top), FALSE);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook_top), FALSE);
  gtk_widget_show(notebook_top);
  gtk_container_add(GTK_CONTAINER(window), notebook_top);

#ifdef HAVE_ANIMATION

  init_load(notebook_top);

#endif  

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  isg_demo = create_window_main ();

  //Load files into GUI
  load_files();  

  //The process can not be stopped because of the Python linking.
  //This is just for that.
  signal(SIGINT,ctrl_c_pressed);

  gtk_widget_show (window/*isg_demo*/);

  //Just a click to get rid of block infomation in the spec displays
  if (text_SIP_file[0])
    on_dialog_show_file_text_button_press(text_SIP_file[0],
					  NULL,NULL);

  gtk_main ();


  return 0;
}

