/* 
 * $Id: pixbufs.h,v 1.1.1.1 2003/06/11 21:16:01 wyan Exp $
 * file: pixbufs.h
 * Some of them are borrowed from the examples coming with Gtk+-2.0.6
 */
#ifndef _PIXBUFS_H
#define _PIXBUFS_H

#include <stdlib.h>
#include <gtk/gtk.h>
#include <math.h>
#include <stdio.h>
#include <errno.h>
#include "const.h"

/* Timing for timeout callback*/
#define FRAME_DELAY 50

/* CYCLE_LEN frames showed*/
#define CYCLE_LEN 150

/* The floating cal adjustment in y location of the logo*/
#define ADJUST 20

/* The following images have the size of */
/* width x height = 600 x 500. Matching with isg demo window size*/
/* The Gnome background*/
#define BACKGROUND_NAME "image/background.jpg"

/* The text img*/
#define TEXT_IMAGE "image/text.png"

/* We only have one img for now*/
static const char *image_names[] = {
  "image/colorLogo.png"
};

#define N_IMAGES G_N_ELEMENTS (image_names)



/* The widget holds the images */
/* This notebook container is the top level widget holds animation stuff */
extern GtkWidget* notebook_img;

/* The id for the timeout fn */
extern guint timeout_id;
extern guint load_timeout;

/* The progressive load */
extern GdkPixbufLoader *pixbuf_loader;
extern FILE* text_img_stream;
extern gboolean text_img_loaded;

/* The containers hold the progressive loaded text img*/
extern GtkWidget *frame_text;

/* GtkImage can't receive event, needs to put it into an GtkEventBox */
extern GtkWidget *image_event_box;

/* The img about the text */
extern GtkWidget *image_text;

/* Forbid the img to scale while resizing the window*/
//extern GtkWidget *align;

/* The logo */
/* Current frame */
extern GdkPixbuf *pixbuf_logo;
extern GtkWidget* frame_logo;
extern int frame_num;

/* Background image */
extern GdkPixbuf *background;
extern gint back_width, back_height;

/* Images: we only have one */
extern GdkPixbuf *images[N_IMAGES];

/* The drawing area if the logo */
extern GtkWidget *da;




/* An error msg processing routine*/
void error_msg(GtkWidget* window, GError* error);

/* Click to let the animation go away*/
gboolean on_window_clicked(GtkWidget* widget, GdkEventButton* event,
			   gpointer data);


/* Progressive loading the text image part*/
void do_load_text_image (void);

gint progressive_timeout (gpointer data);

void
progressive_updated_callback (GdkPixbufLoader *loader,
                              gint                 x,
                              gint                 y,
                              gint                 width,
                              gint                 height,
                              gpointer     data);

void
progressive_prepared_callback (GdkPixbufLoader *loader,
                               gpointer         data);

/* Loading of the logo img */
void do_pixbufs (void);

/* Start loading here */
void init_load(GtkWidget* container);


#endif
