#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>

#include "sipParser.h"

static char PARSER_ROOT[]= "../../sip2xml/sipParser";
static char script[64];
static int SIZE= 1024;

char* final_str = NULL;

char *exec_child(char *filename, char *arg);

char *getBlockXip(char *filename)
{
  script[0]='\0';
  strcat(strcat(script,PARSER_ROOT), "/getBlockXip.py");
  return exec_child(script, filename);
}

char *getXip(char *filename)
{
  script[0]='\0';
  strcat(strcat(script,PARSER_ROOT), "/getXip.py");
  return exec_child(script, filename);
}

char *getBlockSip(char *filename)
{
  script[0]='\0';
  strcat(strcat(script,PARSER_ROOT), "/getBlockSip.py");
  return exec_child(script, filename);
}

char *exec_child(char *filename, char *arg)
{
	int pfd[2];
	int pid;
	int sum=0;

	char *buf = NULL;
	char* tmp =NULL;

	int rb;
	
	struct stat st;
	int status;


	pipe(pfd);
	pid = fork();
	switch(pid) {
	case 0:
		close(pfd[0]);
		dup2(pfd[1], fileno(stdout));
		execl(filename, filename, arg, NULL);
		perror("error on exec()\n");
		exit(-1);
	case -1:
		printf("error on fork()\n");
		exit(-2);
	default:
		close(pfd[1]);
		fstat(pfd[0], &st);
		
		final_str = NULL;

		while (1) {
		  buf = (char *)malloc(SIZE);
		  rb = read(pfd[0], buf, SIZE-1);
		  sum += rb;

		  if (rb<1) {
		    if (tmp) free(tmp);
		    if (buf) free(buf);
		    wait(&status);
		    close(pfd[0]);

		    return final_str;
		  }

		  buf[rb]=0;
		  if (final_str) free(final_str);
		  final_str = (char*)malloc(SIZE+sum);
                  final_str[0] = 0;

		  if (tmp)
		    strcpy(final_str, tmp);

		  strcat(final_str,buf);
		  final_str[sum]=0;


		  if (tmp) free(tmp);
		  if (buf) free(buf);
		  tmp = (char*)malloc(strlen(final_str)+1);
		  strcpy(tmp,final_str);
		  
		}
	}

	//return buf;
}

#if 0
int main(int argc, char **argv) 
{

  printf("%s", getXip(argv[1]));
  char* t;
  t = getBlockSip(argv[1]);
  //printf("%s: length(%d)\n", t, strlen(t));

  printf("%s", getXip(argv[1]));
  //printf("%s", getXip(argv[1]));
}
#endif
